2026-06-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-02  Jan Beulich  <jbeulich@suse.com>

	gprof: fix testsuite with older glibc
	It is quite sad that 2.46 has again shipped with this breakage. Short of
	those responsible taking care, use the workaround that was suggested in
	https://sourceware.org/pipermail/binutils/2025-April/140316.html.

	(cherry picked from commit 1319410a1e9d857f15c9019a87d6d4b62fa6d39a)

2026-06-02  Simon Marchi  <simon.marchi@polymtl.ca>

	sim: fix a few -Wdiscarded-qualifiers errors
	Change-Id: I5caaf741a6d3835d593e62c3a567171c09d6241c
	(cherry picked from commit 38e9187d24b6e14bfadafb6d6feda5770f74ff07)

2026-06-02  Keith Seitz  <keiths@redhat.com>

	Fix even more -Wdiscarded-qualifers issues
	Fedora Rawhide is failing to build due to new glibc header changes
	enforcing const-correctness in functions like strchr and memchr.
	For example:

	../../opcodes/aarch64-dis.c: In function ‘remove_dot_suffix’:
	../../opcodes/aarch64-dis.c:4027:7: error: assignment discards ‘const’ qualifier from po
	inter target type [-Werror=discarded-qualifiers]
	 4027 |   ptr = strchr (inst->opcode->name, '.');
	      |       ^
	cc1: all warnings being treated as errors

	This patch addresses all the discovered issues with --enable-targets=all
	and regenerates a few cgen files along the way.

	(cherry picked from commit 36974d77e95efb1b640e8005a6bea6a6bed64aa7)

2026-06-02  Simon Marchi  <simon.marchi@polymtl.ca>

	bfd: fix 2 more -Wdiscarded-qualifiers errors
	Change-Id: I047cd848506fc4d3dafdb901e300fe22430dddde
	(cherry picked from commit b3679b82926dd525e17a9b48114e96e95f0f6444)

2026-06-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-06-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-31  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-27  Alan Modra  <amodra@gmail.com>

	check sframe version in _bfd_elf_parse_sframe
	Currently if you attempt to link an object file with sframe version 2
	contents, the linker will complain in _bfd_elf_merge_section_sframe
	and fail to produce an output.  This affects anyone who has objects
	assembled by binutils-2.45 with .sframe sections.  A work-around is to
	pass --discard-sframe to ld.

	Ideally the linker would rewrite version 2 sframe input to version 3,
	but in the absence of that support it would be nicer if ld just
	ignored version 2 (or 1) sframe sections without needing to pass
	--discard-sframe.  That is the aim of this patch.

	It does so by checking the sframe version in _bfd_elf_parse_sframe
	where various failing checks result in an error being printed and the
	section not being marked as SEC_INFO_TYPE_SFRAME, but causes no
	overall linker failure.  In addition, an sframe version failure now
	also marks the sframe section with SEC_EXCLUDE.  This is also done for
	other sframe failures.  See the changelog below for other fixes.

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Don't check
		sframe version here.
		(_bfd_elf_parse_sframe): Check sframe version here instead.
		Do the "already parsed" check first.  Reorder various other
		checks.  Do not bother parsing or print errors when
		discard_sframe is set.  Free section contents on failure
		paths.  Set SEC_EXCLUDE for fails.  Check for NULL bfd_zalloc
		return, and only allocate after successfully parsing sframe.
		On errors report that the section will be ignored, not "no
		.sframe will be created".
	binutils/
		* testsuite/lib/binutils-common.exp: Ignore sframe version
		errors.

	(cherry picked from commit 7c80233f4d47c2508d8984bdcfc644b9a6e7bf9a)

2026-05-27  Alan Modra  <amodra@gmail.com>

	Correct calls to sframe_encoder_free
	Like the patch to free sframe decoder data, this also needs to ensure
	the function doing the free is passed the actual context address.

	bfd/
		* elf-sframe.c (_bfd_elf_write_section_sframe): Don't pass
		address of local var to sframe_encoder_free, pass the actual
		context address.
		* elf64-s390.c (elf_s390_link_hash_table_create): Tidy
		zmalloc call.
		(_bfd_s390_elf_write_sframe_plt): Don't pass address of local
		var to sframe_encoder_free, pass the actual context address.
		* elfxx-x86.c (_bfd_x86_elf_write_sframe_plt): Likewise.

	(big-fix cherry-pick from 3949fb481a6739dc1f4dc5fad09d7646c90af3d2
	 without the extra encoder frees)

2026-05-27  Alan Modra  <amodra@gmail.com>

	Correct calls to sframe_decoder_free
	Correct calls to sframe_decoder_free so that sfd_info->stf_ctx is
	cleared.  If sfd_info->stf_ctx isn't cleared we can get double frees.

		* elf-sframe.c (sframe_decode): Do not pass local var sfd_ctx
		address to sframe_decoder_free, pass the actual context address.
		(_bfd_elf_merge_section_sframe): Likewise.

	(bug-fix cherry-pick from 3949fb481a6739dc1f4dc5fad09d7646c90af3d2
	 without the free on bfd_close.)

2026-05-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-07  Calvin Owens  <calvin@wbinvd.org>

	Fix discarded-qualifiers problems in ldlang.c
	Assign strchr return to a const char* to match its arg in a couple of
	places.  archive_path now returns a const char*, and
	input_statement_is_archive_path now has a const char* sep arg.  If
	you follow where these args come from in ldgram.y it can be seen that
	they are in fact in writable memory, so it isn't necessary to copy
	file_spec to poke in a zero which is restored before the function
	returns.

	This partially fixes PR binutils/34125.

	(cherry picked from commit 65cd0d66a647f14719e69bd19f34dc98bdb7e635)

2026-05-07  Mark Wielaard  <mark@klomp.org>

	ld: Fix calls to strchr that discard or use wrong const qualifiers
		PR binutils/34125
		* ld/emultempl/pe.em (pe_fixup_stdcalls): Make at a const char *.
		(gldEMULATION_NAME_after_open): Make pnt a const char *.
		(gldEMULATION_NAME_place_orphan): Make dollar a const char *.
		* ld/emultempl/pep.em (pep_fixup_stdcalls): Make at a
		const char *. Introduce at2 as non-const char *.
		(gldEMULATION_NAME_after_open): Make pnt a const char *.
		(gldEMULATION_NAME_place_orphan): Make dollar a const char *.
		* ld/emultempl/spuelf.em (spu_elf_load_ovl_mgr): Make p a
		const char *. Introduce np as char *.
		* ld/ldelf.c (ldelf_search_needed): Call strchr on freeme, so
		slash is non-const, then assign freeme to replacement.

	(cherry picked from commit 34ca322d8a2b55e4ee193492a489aaa68195cffb)

2026-05-07  Simon Marchi  <simon.marchi@polymtl.ca>

	binutils: fix C23 -Wdiscarded-qualifiers errors
	When compiling with gcc 15, I get these:

	      CC       prdbg.o
	    /home/simark/src/binutils-gdb/binutils/prdbg.c: In function â€˜tg_start_functionâ€™:
	    /home/simark/src/binutils-gdb/binutils/prdbg.c:2658:11: error: assignment discards â€˜constâ€™ qualifier from pointer target type [-Werror=discarded-qualifiers]
	     2658 |       sep = strchr (name, '(');
	          |           ^
	    cc1: all warnings being treated as errors
	    make[2]: *** [Makefile:1220: prdbg.o] Error 1
	      CC       addr2line.o
	    /home/simark/src/binutils-gdb/binutils/addr2line.c: In function â€˜translate_addressesâ€™:
	    /home/simark/src/binutils-gdb/binutils/addr2line.c:390:21: error: assignment discards â€˜constâ€™ qualifier from pointer target type [-Werror=discarded-qualifiers]
	      390 |                   h = strrchr (filename, '/');
	          |                     ^
	    cc1: all warnings being treated as errors
	    make[2]: *** [Makefile:1220: addr2line.o] Error 1
	      CC       nm.o
	    /home/simark/src/binutils-gdb/binutils/nm.c: In function â€˜print_symnameâ€™:
	    /home/simark/src/binutils-gdb/binutils/nm.c:689:21: error: initialization discards â€˜constâ€™ qualifier from pointer target type [-Werror=discarded-qualifiers]
	      689 |       char *atver = strchr (name, '@');
	          |                     ^~~~~~
	    cc1: all warnings being treated as errors

	I think they are related to the fact that strchr having changed to
	return const when passed a const.

	This partially fixes PR binutils/34125.

	Change-Id: Idb829916378f0a18e717d1e80414aaa5eba4f7f0
	(cherry picked from commit 9cb12adfb54bc3dabf4ee00296064245eb7660ef)

2026-05-07  H.J. Lu  <hjl.tools@gmail.com>

	Fix the strrchr error for DOS based filesystem
	Fix the strrchr error like:

	gprof/source.c:130:28: error: initialization discards ‘const’ qualifier from pointer target type [-Werror=discarded-qualifiers]
	  130 |             char *bslash = strrchr (sf->name, '\\');

	binutils/

		PR binutils/34125
		* bucomm.c (template_in_dir): Make bslash const char *.

	gprof/

		PR binutils/34125
		* source.c (annotate_source): Make bslash const char *.

	(cherry picked from commit 365fc34606d2d566855e8ba3db9c4f7986ed3bcc)

2026-05-07  Mark Wielaard  <mark@klomp.org>

	gprof: Fix strchr discarded qualifier call
	In annotate_source strrchr is called on a const char *. So the result
	should also be stored in a const char *.

		PR binutils/34125
		* gprof/source.c (annotate_source): Make name_only a const char *.

	(cherry picked from commit b8d39fd810e7373aac4f129c34813f6a609d8d5f)

2026-05-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-05  H.J. Lu  <hjl.tools@gmail.com>

	ld: Limit PR ld/34088 test to Linux/x86-64 and Linux/aarch64
	Since PR ld/34088 test requires libm.a, which has feclearexcept, as a
	linker script like

	GROUP ( /usr/lib64/libm-2.42.a /usr/lib64/libmvec.a )

	which is implemented for Linux/x86-64 and Linux/aarch64, limit such test
	to Linux/x86-64 and Linux/aarch64.

		PR ld/34088
		* testsuite/ld-plugin/lto.exp: Limit PR ld/34088 test to
		Linux/x86-64 and Linux/aarch64.

	(cherry picked from commit 4d11bf8cc73a1f56d2ffc5af7334ae2c251584b6)

2026-05-05  H.J. Lu  <hjl.tools@gmail.com>

	ld: Maintain the input file order
	When adding a new input archive, which comes from a linker script file
	and isn't referenced by any inputs, ld appends it to the input file list.
	On Linux, when -lm is used with /usr/lib64/libm.a:

	GROUP ( /usr/lib64/libm-2.42.a /usr/lib64/libmvec.a )

	the input file order looks like

	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crt1.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crti.o
	/usr/lib/gcc/x86_64-redhat-linux/15/crtbeginT.o
	x.o (symbol from plugin)
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/libm.a
	/usr/lib/gcc/x86_64-redhat-linux/15/libgcc.a
	/usr/lib/gcc/x86_64-redhat-linux/15/libgcc_eh.a
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/libc.a
	/usr/lib/gcc/x86_64-redhat-linux/15/crtend.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crtn.o
	/usr/lib64/libm-2.42.a
	/usr/lib64/libmvec.a

	since the compiler may not add compiler builtin functions to the LTO
	symbol table as it doesn't really know if builtin functions will have
	real symbols.  When ld extracts an element from the archive later during
	LTO rescan, the final input file order is

	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crt1.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crti.o
	/usr/lib/gcc/x86_64-redhat-linux/15/crtbeginT.o
	x.o (symbol from plugin)
	/tmp/ccHN6O4n.ltrans0.ltrans.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/libm.a
	/usr/lib/gcc/x86_64-redhat-linux/15/libgcc.a
	/usr/lib/gcc/x86_64-redhat-linux/15/libgcc_eh.a
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/libc.a
	/usr/lib/gcc/x86_64-redhat-linux/15/crtend.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crtn.o
	fclrexcpt.o

	where x.o references the builtin function, feclearexcept which is defined
	in fclrexcpt.o from /usr/lib64/libm-2.42.a.

	As the result, the .eh_frame section terminator in crtn.o is placed before
	fclrexcpt.o and the .eh_frame section in the output isn't terminated.  The
	output crashes when it runs over the .eh_frame section during EH frame
	registration.  Insert the new input file before the current input file to
	maintain the same input file order:

	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crt1.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crti.o
	/usr/lib/gcc/x86_64-redhat-linux/15/crtbeginT.o
	x.o (symbol from plugin)
	/usr/lib64/libm-2.42.a
	/usr/lib64/libmvec.a
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/libm.a
	/usr/lib/gcc/x86_64-redhat-linux/15/libgcc.a
	/usr/lib/gcc/x86_64-redhat-linux/15/libgcc_eh.a
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/libc.a
	/usr/lib/gcc/x86_64-redhat-linux/15/crtend.o
	/usr/lib/gcc/x86_64-redhat-linux/15/../../../../lib64/crtn.o

	as the non-LTO input to properly terminate the .eh_frame section.

	Add a static LTO test to reference feclearexcept which is a compiler
	builtin function and isn't in the LTO symbol table when GCC is used.
	It triggers the run-time crash on glibc targets of a linker script
	libm.a without this fix when GCC 13 or above is used:

	https://gcc.gnu.org/bugzilla/show_bug.cgi?id=124869

	Also add a debug function, debug_input_files, to display the input file
	chain.  It is optimized out when compiler optimization is turned on.

		PR ld/34088
		* ldlang.c (current_input_file): Changed to the pointer to
		lang_input_statement_type.
		(new_afile): Insert the new input file before the current input
		file to maintain the input file order.
		(lang_add_input_file): Updated.
		(load_symbols): Likewise.
		(debug_input_files): New function.
		(lang_process): Reference it.
		* testsuite/ld-plugin/lto.exp: Run PR ld/34088 test.
		* testsuite/ld-plugin/pr34088.c: New file.

	(cherry picked from commit da208daeb710b26608a0b981df215e9da209af80)

2026-05-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-05-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-17  Jan Beulich  <jbeulich@suse.com>

	x86: refine special casing of insns with MSR as immediate
	PR gas/34028

	i.op[].imms is legitimate to de-reference only when the operand actually
	is an immediate. The pointer happens to be non-NULL for most other operand
	kinds (i.e. a deref is UB, but would likely not fault), just not for
	memory operands without displacement.

	Leverage that the to-be-special-cased insns all only have just a single
	immediate, and leverage further that after the immediately preceding
	swapping of operands valid immediates will come first. Hence the
	conditional can be adjusted to satisfy the criteria above, and no loop is
	needed at all.

	With the conditional changed, leverage the property also in optimize_imm()
	itself, reducing the number of loop iterations.

2026-04-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-04-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-31  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-03-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-08  Nick Clifton  <nickc@redhat.com>

	Open 2.46 branch for development and update version number to 2.46.0

	This is the 2.46 release

2026-02-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-06  Indu Bhagat  <indu.bhagat@oracle.com>

	sframe: doc: minor fixups in language for clarity
	libsframe/doc/
		* sframe-spec.texi: Minor language and formatting fixup.

	(cherry picked from commit 2c4129c4cc3e715baa78a9327368a079b58bebeb)

2026-02-06  Indu Bhagat  <indu.bhagat@oracle.com>

	bfd: sframe: use better wording for error messages
	Fix PR ld/33849.

	Change the messages to display the owner BFD, together with the section
	name.  E.g., when mixing SFrame V2 and V3, the linker will now emit
	something like:

	 error in test.o (.sframe); unexpected SFrame format version 2

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	bfd/
		PR ld/33849
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Improve error
		messages.

	(cherry picked from commit 34825538ba711842a0ec2e2112f2b013dafba6f2)

2026-02-06  Nick Clifton  <nickc@redhat.com>

	Updated/new translation files for the 2.46 release

2026-02-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-04  Alan Modra  <amodra@gmail.com>

	PR 33593 Misplaced synthetic plt symbols in aarch64 PIE binaries
	elfNN_aarch64_plt_sym_val wrongly treats PIEs.  PIEs are an executable
	but not ET_EXEC, instead being ET_DYN with DF_1_PIE set in DT_FLAGS_1
	to distinguish them from shared libraries.

	get_plt_type scans .dynamic for DT_AARCH64_BTI_PLT and
	DT_AARCH64_PAC_PLT, setting PLT_BTI and PLT_PAC in the function return
	value respectively.  It's easy enough to extend the .dynamic scan to
	also return DF_1_PIE in tdata is_pie.

	The patch also makes a few tidies, things I noticed when scanning all
	the code dealing with sw_protections.plt_type.

		PR 33593
		* elfnn-aarch64.c (get_plt_type): Return DF_1_PIE via tdata is_pie.
		(elfNN_aarch64_plt_sym_val): Handle PIEs as well as ET_EXEC.
		(setup_plt_values): Delete wrong ET_EXEC comments.
		(elfNN_aarch64_late_size_sections): Remove excess parentheses.
		(elfNN_aarch64_finish_dynamic_sections): Rename type to plt_type,
		and simplify test for PLT_BTI or PLT_BTI_PAC.

	Co-Authored-By: Michael Matz <matz@suse.de>
	(cherry picked from commit 2dfd38f93ce3b05d25c7bd14cbcff0fa3614c056)

2026-02-04  Claudiu Zissulescu  <claudiu.zissulescu-ianculescu@oracle.com>
	    Indu Bhagat  <indu.bhagat@oracle.com>

	sframe: Add tests for PR ld/32769
	Add simple tests that verify the behavior of garbage collection of
	SFrame sections during linking.

	x86_64-specific tests:
	  - sframe-gc-sections-1.d checks that none of the functions get
	    discarded with --gc-sections
	  - sframe-gc-sections-2a.d checks the behavior of --gc-sections with two
	    distinct .text.* sections (similar to -ffunction-sections compiler
	    option)
	  - sframe-gc-sections-2b.d checks the same behaviour as
	    sframe-gc-sections-2a.d, but with a linker script that discards
	    .eh_frame sections.  This testcase is keep it ensured that the two
	    section's GC behaviours are not unnecessarily inter-twined.

	All targets supporting sframe tests:
	   - pr32769.rd simple linking test in presence of --gc-sections
	     option.
	   - pr32769-2.d checks the behavior of --gc-sections with two .text.*
	     sections, one section is discarded
	   - pr32769-2r.d Like the above, but using -r option when linking and
	     checking for the relocations.
	   - pr32769-3.d checks the behavior of --gc-sections with multiple
	     sections, none is drop.

	ld/
		PR ld/32769
		* testsuite/ld-sframe/pr32769.rd: New file.
		* testsuite/ld-sframe/pr32769.s: Likewise.
		* testsuite/ld-sframe/pr32769-2.d: Likewise.
		* testsuite/ld-sframe/pr32769-2r.d: Likewise.
		* testsuite/ld-sframe/pr32769-2.s: Likewise.
		* testsuite/ld-sframe/pr32769-3.d: Likewise.
		* testsuite/ld-sframe/pr32769-3.s: Likewise.
		* testsuite/ld-sframe/sframe.exp: Add pr32769 test.
		* testsuite/ld-x86-64/sframe-baz.s: New file.
		* testsuite/ld-x86-64/sframe-gc-sections-1.d: Likewise.
		* testsuite/ld-x86-64/sframe-gc-sections-2.s: Likewise.
		* testsuite/ld-x86-64/sframe-gc-sections-2a.d: Likewise.
		* testsuite/ld-x86-64/sframe-gc-sections-2b.d: Likewise.
		* testsuite/ld-x86-64/sframe-gc-sections-2b.t: Likewise.
		* testsuite/ld-x86-64/x86-64.exp: Add new sframe gc tests.

	(cherry-picked from commit ae82750860f5aff1ff8a42542b87e7ad33f18b97)

2026-02-04  Claudiu Zissulescu  <claudiu.zissulescu-ianculescu@oracle.com>
	    Indu Bhagat  <indu.bhagat@oracle.com>

	ld: bfd: sframe: KEEP .sframe sections and support gc-sections
	Fix PR ld/32769

	Currently, specifying --gc-sections causes the linker to discard all
	input .sframe sections.  Fix this behaviour by adding KEEP for .sframe
	sections, like it is being done for .eh_frame sections, in the default
	ELF linker script.

	Additionally, add logic in the linker to gc mark .sframe sections.
	_bfd_elf_gc_mark () now is aware of SFrame sections. It relies on
	elf_section_sframe () to get the SFrame section associated with the
	text section.

	Also, the _bfd_elf_parse_sframe is changed to return TRUE when the
	input sframe section is already parsed. It fixes calling
	_bfd_elf_discard_section_sframe function in bfd_elf_discard_info,
	enabling correct behavior for discarding unneeded sframe sections.

	ld/
		PR ld/32769
		* scripttempl/elf.sc: KEEP .sframe sections.
	bfd/
		* elf-bfd.h (struct elf_obj_tdata): Add sframe section pointer.
		(elf_sframe_section): New macro.
		* elflink.c (_bfd_elf_gc_mark): Handle SFrame sections.
		(bfd_elf_gc_sections): Likewise.
		(bfd_elf_discard_info): Update for handling gc operations.
		* elf-sframe.c (_bfd_elf_parse_sframe): Return TRUE for already
		parsed sframe sections.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>
	(cherry-picked from commit 4b5ff658b4993fae1f347793bddd5c14b76167cd)

2026-02-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-03  Indu Bhagat  <indu.bhagat@oracle.com>

	include: libsframe: rename SFrame V3 Flexible FDE macros to CTRLWORD
	The existing SFrame V3 macros for Flexible FDEs used the term 'OFFSET'
	to refer to the data word encoding control/register data word. This can
	be confusing, as the control data word (register ID, dereference flags)
	is distinct from a stack offset.

	This patch renames these macros to use 'CTRLWORD' to better reflect
	their purpose. It also updates the assembler and libsframe dumper to
	use the new nomenclature.

	No functional change.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	gas/
		* gen-sframe.c (sframe_get_fre_dataword_size): Use
		SFRAME_V3_FLEX_FDE_CTRLWORD_ENCODE.
		(output_sframe_row_entry_datawords): Likewise.
	include/
		* sframe.h (SFRAME_V3_FLEX_FDE_REG_ENCODE): Rename from ..
		(SFRAME_V3_FLEX_FDE_CTRLWORD_ENCODE): .. to.
		(SFRAME_V3_FLEX_FDE_CTRLWORD_REGNUM): Rename from
		SFRAME_V3_FLEX_FDE_OFFSET_REG_NUM to this.
		(SFRAME_V3_FLEX_FDE_CTRLWORD_DEREF_P): Rename from
		SFRAME_V3_FLEX_FDE_OFFSET_REG_DEREF_P to this.
		(SFRAME_V3_FLEX_FDE_CTRLWORD_REG_P): Rename from
		SFRAME_V3_FLEX_FDE_OFFSET_REG_P to this.
		(SFRAME_V3_FRE_RA_UNDEFINED_P): Add new V3 macro.
	libsframe/
		* sframe-dump.c (dump_sframe_func_fres_flex): Update all
		callers to use the new CTRLWORD macros.
	libsframe/testsuite/
		* libsframe.decode/be-flipping-v3.c: Use renamed macros.

	(cherry picked from commit 4edeb9be08afae397e6c0dd1a57399b18ca29e35)

2026-02-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-02-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-31  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-29  Jan Beulich  <jbeulich@suse.com>

	Revert "ld: testcase for .note.GNU-stack wanting to be SHT_NOTE" etc
	This reverts commits a1c2fa92ac93bf50227941bd82094e6997c5fd56,
	bc6e40a093e700e84b549902d55e73bfe92a113b
	("amend "ELF: give .note.GNU-stack proper section type""), and
	c8db2c887b4129732341c4a1a51cdcd3191db271
	("ELF: give .note.GNU-stack proper section type"). They're deemed
	to require a little more testing before being ready for a release.

2026-01-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-28  Alan Modra  <amodra@gmail.com>

	PR 33852 Different objects for same input
	Testcase:
	$ cat aff.s
	 .quad x@ntpoff
	$ gas/as-new -m64 aff.s -o t.o
	with MALLOC_PERTURB_ this reliably shows uninitialised memory making
	its way into the output.

	R_390_TLS_LE64 howto was sized incorrectly, resulting in the
	initialisation in s390_elf_cons zeroing only the first four bytes.

		* elf64-s390.c (elf_howto_table <R_390_TLS_LE64>): Correct
		size and bitsize.

	(cherry picked from commit 0e245c72b774658c48a14b05d78a4e0943a8a9b1)

2026-01-28  Alan Modra  <amodra@gmail.com>

	gas: segmentation fault in as_report_context
	After input_scrub_end when next_saved_file is NULL, it is possible
	that macro_nest will be non-zero on files with errors.  If
	output_file_close then has an error and reports it with as_fatal we
	hit the segfault.

		PR 33746
		* input_scrub.c (as_report_context): Don't assume
		next_saved_file is non-NULL.
		(as_where): Likewise.

	(cherry picked from commit ea96771a0188a235645558ae10d6885c91c1ac00)

2026-01-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-27  Alan Modra  <amodra@gmail.com>

	regen pot files

2026-01-27  Alan Modra  <amodra@gmail.com>

	Re: PR 33840 typo in elfnn-loongarch.c
	The second string with the typo was unused (and had unescaped %).
	Remove it.

	(cherry picked from commit 6f8d261d200b59f0cc55581ad6cefe3912a05fa9)

2026-01-27  Alan Modra  <amodra@gmail.com>

	PR 33840 typo in elfnn-loongarch.c
	s/marching/matching/

	(cherry picked from commit 5c9b48f2eda429b3ef09a8239a472f6a72541a53)

2026-01-27  Alan Modra  <amodra@gmail.com>

	PR 33838 Truncated translation in objcopy.c
	The only macros allowed are the ones specially handled by gettext,
	such as PRId64.

		* objcopy.c (copy_usage): Don't use string literal
		concatenation of macros in translated strings.

	Patch from Andreas Schwab <schwab@linux-m68k.org>

	(cherry picked from commit 1c8cfb3d217aee87562c4f4c4dbc1e4d60e8eadb)

2026-01-27  Than McIntosh  <thanm@golang.org>

	PR 33835 readelf incorrect handling of DWARF5 CU DIE addr_base attribute
	Users of "readelf" report problems running the tool's DWARF dump flag
	on binaries built with the most recent version of the Go compiler (1.25),
	Go bug report here https://github.com/golang/go/issues/77246

		dwarf.c (skip_attribute <DW_FORM_string>): Skip terminating NUL too.

	(cherry picked from commit a72b83ab3792532b66cc5c472a20476a8a2fd969)

2026-01-27  Alan Modra  <amodra@gmail.com>

	Hard-coded plural in readelf.c
		PR 33837
		* readelf.c (process_got_section_contents): Use ngettext.

	(cherry picked from commit 795593e667b00334e7b3fa8b11ea0e844e01b5af)

2026-01-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-26  Matthieu Longo  <matthieu.longo@arm.com>

	bfd/ELF: fix BFD library build --enable-shared
	The patch series that added support for Object Attributes v2 introduced
	regressions when building the BFD library as a shared object.

	Incorrect usages of ATTRIBUTE_HIDDEN caused the following link-time errors:

	/usr/bin/ld: config/obj-elf-attr.o: in function `obj_attr_v2_record':
	obj-elf-attr.c: undefined reference to `bfd_elf_obj_attr_v2_init'
	obj-elf-attr.c: undefined reference to `_bfd_obj_attr_v2_find_by_tag'
	obj-elf-attr.c: undefined reference to `obj_attr_v2_t_append'
	/usr/bin/ld: config/obj-elf-attr.o: in function `obj_attr_v2_subsection_record':
	obj-elf-attr.c: undefined reference to `obj_attr_subsection_v2_t_append'
	obj-elf-attr.c: undefined reference to `obj_attr_subsection_v2_t_remove'
	obj-elf-attr.c: undefined reference to `obj_attr_subsection_v2_t_append'

	This patch fixes the symbols visibility so that the BFD library links
	correctly when built with --enable-shared.
	The ATTRIBUTE_HIDDEN annotations were removed from bfd_elf_obj_attr_v2_init
	and _bfd_obj_attr_v2_find_by_tag, and _bfd_obj_attr_v2_find_by_tag was renamed
	to reflect the belonging to the public BFD API using the 'bfd_' prefix. The
	doubly linked list helpers remain hidden and are instead exposed through wrapper
	functions.

2026-01-26  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	binutils: xfail "gnu-debuglink (objdump 1)" on Solaris/amd64 [PR33243,PR33389]
	As reported in PR binutils/33243, one test FAILs on Solaris/amd64:

	FAIL: gnu-debuglink (objdump 1)

	30c30,32
	<   400660:     ff 35 b2 15 00 00 ff 25 b4 15 00 00 0f 1f 40 00     .5.....%......@.
	---
	>   400660:     ff 35 b2 15 00 00       push   0x15b2(%rip)        # 401c18 <_GLOBAL_OFFSET_TABLE_+0x8>
	>   400666:     ff 25 b4 15 00 00       jmp    *0x15b4(%rip)        # 401c20 <_GLOBAL_OFFSET_TABLE_+0x10>
	>   40066c:     0f 1f 40 00             nopl   0x0(%rax)

	This is another instance of PR binutils/33389, so this patch xfail's the
	test.

	Tested on {amd64,i386}-pc-solaris2.11 and {x86_64,i686}-pc-linux-gnu.

	2026-01-25  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		binutils:
		PR binutils/33243
		PR binutils/33389
		* testsuite/binutils-all/compress.exp (test_gnu_debuglink): xfail
		on Solaris/amd64.

	(cherry picked from commit aa3291fceac4a53054a6337a577a882b078db9be)

2026-01-25  Nick Clifton  <nickc@redhat.com>

	Update version to 2.45.90

	Add 2.46 release markers to NEWS files.  Update BRANCHES.  Update README.

2026-01-25  Indu Bhagat  <indu.bhagat@oracle.com>

	ld: sframe: do not generate .sframe for PLT if no .sframe is in input BFDs
	GNU ld creates SFrame stack trace info for the PLT. For x86 the linker-
	created .sframe section is created in setup_gnu_properties.  For s390 it
	is created in create_dynamic_sections.  For both, the section data is
	itself emitted a bit later in late_size_sections.  Note that for aarch64 the
	linker does not create .sframe for PLT yet.

	Recall that a previous patch 832ca9ef670 uncoupled
	--no-ld-generated-unwind-info from the linker-generated .sframe
	sections.  This means that the linker now generates .sframe section (for
	.plt*) for the first input BFD enthusiatically even when none of the
	input BFDs have any .sframe section, unless --discard-sframe is also
	added.  The issue is that these (unexpected) linker-generated .sframe
	sections (on x86_64, and s390) may now trip the linking process, e.g.,
	when using --orphan-handling=error together with a linker script that
	treats .sframe differently than the default linker script.
	https://sourceware.org/pipermail/binutils/2026-January/147826.html

	Further, with SFrame sections to be soon marked KEEP for fixing
	GC/SFrame (PR ld/32769), the presence of these linker generated SFrame
	sections will also cause emission of an empty .sframe (for x86_64 and
	s390x), even when all input bfd's have no .sframe section.

	This patch avoids creation of .sframe for .plt* if none of the input
	BFDs had any .sframe section.  This then avoids creation of empty
	.sframe in linked objects on x86_64 and s390x, when none of the inputs
	have SFrame sections.  This also fixes PR ld/33830.

	For the code changes:
	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	New testcases have (since the above Reviewed-by) been added.  Since
	--no-ld-generated-unwind-info is not supported on aarch64, add
	target-specific ld tests.  Additionally add a generic test (for all
	targets that support SFrame) to ensure no output .sframe is generated if
	users says no --gsframe or similar.

	bfd/
		PR ld/33830
		* elf-bfd.h (_bfd_elf_sframe_present_input_bfds): New
		declaration.
		* elf-sframe.c (_bfd_elf_sframe_present_input_bfds): New
		definition.
		* elf64-s390.c (elf_s390_create_dynamic_sections): Do not
		generate .sframe for .plt unconditionally.
		* elfxx-x86.c (_bfd_x86_elf_link_setup_gnu_properties):
		Likewise.
	ld/testsuite/
		PR ld/33830
		* ld-s390/no-sframe.ld: Linker script with no specification for
		SFrame sections.
		* ld-s390/s390.exp: Add new test.
		* ld-s390/sframe-command-line-2.d: New testcase that uses
		--no-ld-generated-unwind-info and a linker script that has no
		specific rules for .sframe.
		* ld-x86-64/no-sframe.ld: Likewise for x86_64.
		* ld-x86-64/sframe-command-line-2.d: Likewise for x86_64.
		* ld-x86-64/x86-64.exp: Add new test.
		* ld-sframe/no-ld-generated-sframe.d: Ensure no .sframe in
		output if no .sframe in input.
		* ld-sframe/no-sframe.ld: Linker script with no specification
		for SFrame sections.
		* ld-sframe/test.s: Add new test.

2026-01-25  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: aarch64: i386: s390: sframe: adjust sframe_ra_tracking_p
	Like the previous commit b600229503 which adjusted the implementation of
	flex fde hook, make a similar change for sframe_ra_tracking_p.

	Simply providing the definition to use boolean value direcly is
	sufficient for the purpose, and helps generate better code.

	gas/
		* config/tc-aarch64.c (aarch64_sframe_ra_tracking_p): Remove.
		* config/tc-aarch64.h (aarch64_sframe_ra_tracking_p): Remove.
		(sframe_ra_tracking_p): Set to true.
		* config/tc-i386.c (x86_sframe_ra_tracking_p): Remove.
		* config/tc-i386.h (x86_sframe_ra_tracking_p): Remove.
		(sframe_ra_tracking_p): Set to false.
		* config/tc-s390.c (s390_sframe_ra_tracking_p): Remove.
		* config/tc-s390.h (s390_sframe_ra_tracking_p): Remove.
		(sframe_ra_tracking_p): Set to true.

2026-01-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-24  John David Anglin  <danglin@gcc.gnu.org>

	hppa64: Fix Linux link
	The "BFD_ASSERT (r_symndx != STN_UNDEF)" assert is incorrect and
	triggers linking Linux kernel.

	2026-01-24  John David Anglin  <danglin@gcc.gnu.org>

	bfd/ChangeLog:

		* elf64-hppa.c (elf64_hppa_relocate_section): Remove asserts.

2026-01-24  Alice Carlotti  <alice.carlotti@arm.com>

	gas/NEWS: Add AArch64 updates

	aarch64: Tidy architecture extensions documentation
	Document mops_go, add some missing full stops, and fix alphabetization
	mistakes.

	aarch64: Fix sme2p3 and f16f32dot feature dependencies
	These are changed to match the dependencies we agreed with LLVM.

	aarch64: Add -march=armv9.7-a option

	aarch64: Fix documentation of armv9.6-a dependencies
	The sve2p2 and fprcvt extensions were removed from -march=armv9.6-a, but
	we forgot to update the documentation at the same time.

	aarch64: Remove redundant macros
	We no longer encode flags in the aarch64_hint_options value field, so
	delete the HINT_VAL, HINT_FLAG and HINT_ENCODE macros.

2026-01-24  Srinath Parvathaneni  <srinath.parvathaneni@arm.com>

	aarch64: Add support for TLBID system registers
	This patch adds support for following TLBID system registers.

	* tlbididr_el1 (RO)
	* vtlbid0_el2
	* vtlbid1_el2
	* vtlbid2_el2
	* vtlbid3_el2
	* vtlbidos0_el2
	* vtlbidos1_el2
	* vtlbidos2_el2
	* vtlbidos3_el2

2026-01-24  Srinath Parvathaneni  <srinath.parvathaneni@arm.com>

	aarch64: TLBI Domains changes for PLBI instruction
	For the PLBI instruction with optional register argument
	<Rt> == 0b1111, with FEAT_TLBID enabled they are permitted to
	have an Rt value which is not 0b11111 and this is allowed for
	all the TLBI instructions with a <type> of ALLE1*, ALLE2* and
	VMALL* and a <shareability> of IS or OS.

	aarch64: Enable TLBIP instructions with tlbid option
	TLBI Domains feature changes TLBI and TLBIP system instructions.
	For all TLBIP *E1IS*, TLBIP *E1OS*, TLBIP *E2IS* and TLBIP *E2OS*
	instructions that are currently dependent on FEAT_D128 (+d128),
	will also be available with FEAT_TLBID (+tlbid).

2026-01-24  Srinath Parvathaneni  <srinath.parvathaneni@arm.com>

	aarch64: Add support for FEAT_TLBID feature
	TLBI Domains feature changes TLBI and TLBIP system instructions.
	For the TLBI instruction with optional register argument
	<Rt> == 0b1111, with FEAT_TLBID enabled they are permitted to
	have an Rt value which is not 0b11111 and this is allowed for
	all the TLBI instructions with a <type> of ALLE1*, ALLE2*,
	VMALL*, VMALLS12* or VMALLWS2* and a <shareability> of IS or OS.

	This patch add support for FEAT_TLBID feature, which is enabled
	by new +tlbid option.

2026-01-24  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	ld: testsuite: Relax libgot-1-i386 test for Solaris [PR33350]
	When running the ld testsuite with -melf_i386_sol2 instead of -melf_i386
	on Solaris, one test regresses:

	FAIL: Build libgot-1-i386.so

	The issue is that one line in the --got-contents output differs
	unexpectedly:

	 Global Offset Table '.got.plt' contains 4 entries:
	    Index:  Address      Reloc             Sym. Name + Addend/Value
	-       0: 00200200                        20016c
	-       1: 00200204                        0
	-       2: 00200208                        0
	-       3: 0020020c R_386_JUMP_SLOT        bar + 156
	+       0: 00200270                        2001dc
	+       1: 00200274                        0
	+       2: 00200278                        0
	+       3: 0020027c R_386_JUMP_SLOT        bar + 1c6

	While ld-i386/libgot-1.rd already allows for differences in the
	addresses, the addend is assumed to be fixed.  However, this is not the
	case with -melf_i386_sol2.  The difference is that .hash, .dynsym, and
	.symtab have additional entries as required by the Solaris ABI:

	* In .dynsym and .symtab, _DYNAMIC, _GLOBAL_OFFSET_TABLE_, and
	  _PROCEDURE_LINKAGE_TABLE_ are added.

	* .symtab also gains _END_ and _START_.

	This explains the differences in addresses and addends, but they are
	completely benign.

	This patch thus allows for arbitrary addends.

	Tested on {i386,amd64}-pc-solaris2.11 with both -melf_i386_sol2 and
	-melf_i386, and {i686,x86_64}-pc-linux-gnu.

	2026-01-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		ld:
		PR ld/33350
		* testsuite/ld-i386/libgot-1.rd: Allow for different
		R_386_JUMP_SLOT addends.

2026-01-24  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	ld: testsuite: Skip pr33577 tests with GNU extensions on Solaris [PR33577]
	Several of the ld-elfvers pr33577 tests FAIL on Solaris, for either or
	both of two reasons:

	* Tests using ld --hash-style=gnu cannot work on Solaris:
	  .gnu.hash/SHT_GNU_HASH sections are a GNU extension not supported by
	  Solaris ld.so.1.

	* Similarly, binding different implementations of the same symbol to
	  different symbol versions is a GNU extension that wasn't in the
	  original Solaris specification of symbol versioning.  ld.so.1 doesn't
	  support it and never will.

	  This can be seen in the elfdump output for the .dynsym section:

	Symbol Table Section:  .dynsym
	  index     value size  type bind oth ver shndx         name

	    [8]     0x630  0xd  FUNC GLOB  D   1H .text         foo
	   [10]     0x620  0x6  FUNC GLOB  D    2 .text         foo

	  foo is bound to both version 1 (the Base version) and version 2 (VERS_1
	  from pr33577.map).

	  Same for .symtab:

	Symbol Table Section:  .symtab
	  index    value size  type bind oth ver shndx       name

	   [28]     0x620  0x6  FUNC GLOB  D    0 .text         foo
	   [35]     0x630  0xd  FUNC GLOB  D    0 .text         foo@

	  As I said, ld.so.1 doesn't support <symbol>@<version> (in this case the
	  Base version) at all.

	Therefore the tests that employ those extensions are guarded with
	supports_gnu_osabi.

	Tested on sparc{,v9}-sun-solaris2.11, sparc{,64}-unknown-linux-gnu,
	{i386,amd64}-pc-solaris2.11, and {x86_64,i686}-pc-linux-gnu.

	2026-01-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		ld:
		PR ld/33577
		* testsuite/ld-elfvers/vers.exp (base_symbol_test): Only run
		pr33577a with libpr33577-versioned.so test on ELFOSABI_GNU
		systems.
		Likewise for run base_symbol_tests with --hash-style=gnu.

2026-01-24  Hans-Peter Nilsson  <hp@axis.com>

	ld: Make separate clauses where a label was before a declaration
	The default behavior of gcc changed from gcc-11.  With gcc-10 and
	earlier versions, you got:

	In file included from ../bfd/bfd.h:45,
	                 from /src/ld/ldmisc.c:23:
	/src/ld/ldmisc.c: In function 'vfinfo':
	/src/ld/ldmisc.c:186:8: error: a label can only be part of a statement and a declaration is not a statement
	  186 |        bool ll_type = false;
	      |        ^~~~
	/src/ld/ldmisc.c:581:8: error: a label can only be part of a statement and a declaration is not a statement
	  581 |        bool ll_type = false;
	      |        ^~~~
	make[4]: *** [Makefile:1606: ldmisc.o] Error 1

	Since gcc-10 matches the binutils/README requirement ("a C99 compliant
	compiler and library") and as binutils policy is to adjust code to
	handle earlier gcc versions, an obvious fix is to make a compound
	statement for the code after the case-label.

	ld:

		* ldmisc.c (vfinfo) <case 'l' - two cases>: Make separate
		compound statements where case-labels were part of a declaration.

2026-01-24  H.J. Lu  <hjl.tools@gmail.com>

	elf: Set has_local_dynsyms for forced local symbol
	bfd_elf_link_record_dynamic_symbol may be called by mips backend after
	a global symbol has been forced to local.  Set has_local_dynsyms to true
	in this case.

	bfd/

		PR ld/33793
		* elflink.c (bfd_elf_link_record_dynamic_symbol): Set
		has_local_dynsyms to true for forced local symbol.

	ld/

		PR ld/33793
		* testsuite/ld-mips-elf/mips-elf.exp: Run pr33793.
		* testsuite/ld-mips-elf/pr33793.d: New file.
		* testsuite/ld-mips-elf/pr33793.s: Likewise.

2026-01-24  Alibek Omarov  <a1ba.omarov@gmail.com>

	windres: quote the angled brackets to avoid confusing shell
	When invoking windres with a preprocessor parameter that contains angled
	brackets, the shell will try to interpret them, leading to an error.

	For example with an empty test.rc file:

	$ i686-w64-mingw32-windres '-DTEST=<foo>' -o test.o -i test.rc
	sh: 1: cannot open foo: No such file
	i686-w64-mingw32-windres: preprocessing failed.

	After patch it correctly complains about no resources baked in:

	$ ./i686-w64-mingw32-windres '-DTEST=<foo>' -o test.o -i test.rc
	./i686-w64-mingw32-windres: no resources

2026-01-24  Michal Sobon  <msobon@hex-rays.com>

	opcodes: Fix branch displacement mask in M*Core disassembler
	The BT, BF, BR, and BSR instructions use the Scaled 11-Bit Displacement
	addressing mode. According to the Motorola M*Core Reference Manual,
	the instruction format has:
	- bits 15-11: opcode
	- bits 10-0: 11-bit signed displacement field

	The displacement calculation is: PC <- PC + 2 + (sign-extended disp11 << 1)

	The disassembler was incorrectly masking with 0x3FF (10 bits) instead of
	0x7FF (11 bits). This masked off bit 10, which is the sign bit for the
	11-bit signed displacement. As a result, negative (backward) branches
	were incorrectly disassembled as forward branches.

	opcodes/
		* mcore-dis.c (print_insn_mcore): Fix displacement mask from
		0x3FF to 0x7FF in BR case to correctly extract all 11 bits
		including the sign bit.

2026-01-24  Alan Modra  <amodra@gmail.com>

	amend supports_oa targets
	Add vxworks and windiss to supported targets.  is_elf_target excludes
	them as a hack to work around multiple other elf test failures.

	On these targets, fixes
	FAIL: GNU attributes v1/v2: no support for directive .gnu_attribute

2026-01-24  Indu Bhagat  <indu.bhagat@oracle.com>

	sframe: doc: prepare SFrame specification for release
	Remove the DRAFT marker before release.  Currently needs to be done
	manually.

	libsframe/
		* doc/sframe-spec.texi: Remove DRAFT marker.

2026-01-24  Alan Modra  <amodra@gmail.com>

	gas: move obj_begin earlier
	csky wants to set up ELF object attributes in its md_begin.

		* as.c (perform_an_assembly_pass): Move obj_begin earlier.
		* testsuite/gas/mmix/builtin1.d,
		* testsuite/gas/mmix/builtin3.d: Adjust expected output.

2026-01-24  Alan Modra  <amodra@gmail.com>

	fix fail of X32 DSO from x86-64 sframe.o
	The testcase assumes binutils is configured without
	--disable-separate-code.  Pass -z separate-code to generate the
	expected output.

2026-01-24  Alan Modra  <amodra@gmail.com>

	score: segfault on null hi16_rel_addr
	On a fuzzed input object we hit a segfault when a LO16 reloc doesn't
	have the required preceding HI16 reloc.

	move score static hi16_rel_addr to elf_section_data, and check that
	it is non-NULL before dereferencing.

2026-01-24  Alan Modra  <amodra@gmail.com>

	asan: mips ecoff integer overflow
	Silence an inconsequential oss-fuzz complaint.

		* ecofflink.c (lookup_line): Make lineno unsigned to avoid
		integer overflow.  Sign extend without a conditional.

2026-01-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-23  Indu Bhagat  <indu.bhagat@oracle.com>

	sframe: doc: minor typos and cosmetic fixes
	libsframe/
		* doc/sframe-spec.texi: Minor edits.

2026-01-23  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: rename sframe_fre_* internal APIs to use data word instead of offset
	Rename three internal functions:
	  - sframe_fre_get_offset_count to sframe_fre_get_dataword_count
	  - sframe_fre_get_offset_size to sframe_fre_get_dataword_size
	  - sframe_fre_offset_bytes_size to sframe_fre_datawords_bytes_size.

	libsframe/
		* sframe.c: Rename functions and variables.

2026-01-23  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: rename flip_fre_stack_offsets to flip_fre_datawords
	Also adjust function level comment for flip_fre_datawords.

	libsframe/
		* sframe.c (flip_fre_stack_offsets): Rename to
		flip_fre_datawords.

2026-01-23  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: rename offset in user-facing sframe_frame_row_entry struct
	This patch is the first patch to align libsframe with the terminology
	change of moving from 'offset' to 'data word'.  With the introduction of
	flexible FDE type SFRAME_FDE_TYPE_FLEX, the variable-length data
	following an SFrame FRE header can now represent signed offsets or
	unsigned control data. Consequently, 'data word' is adopted as the more
	generic term.

	This change updates the names used in the user-facing
	sframe_frame_row_entry structure.  While some API function names remain
	unchanged to preserve existing contracts, the underlying data buffers
	and size macros now reflect the data word' terminology.

	libsframe is a tricky spot for such a terminology change: some of APIs
	are still used to read (may be followed by endian swap) for dumping
	SFrame V2 sections in textual format.  Some classic examples are
	sframe_decode_fre, and flip_fre (both are static functions).  But moving
	forward, using the term 'data word' for such APIs and their internal too
	may be better.  Subsequent commits will achieve just that.

	include/
		* sframe-api.h (MAX_NUM_DATAWORDS): Rename from
		MAX_NUM_STACK_OFFSETS.
		(MAX_DATAWORD_BYTES): Rename from MAX_OFFSET_BYTES.
		(struct sframe_frame_row_entry): Rename fre_offsets to
		fre_datawords.
	libsframe/
		* sframe.c (sframe_fre_sanity_check_p): Use MAX_NUM_DATAWORDS.
		(sframe_get_fre_offset): Update internal pointers to use
		'offsets' and access fre_datawords.
		(sframe_get_fre_udata): Rename local variables to
		dataword_cnt/dataword_size and update to use
		SFRAME_FRE_DATAWORD_* constants.
		(sframe_decode_fre): Use fre_datawords and MAX_DATAWORD_BYTES.
		(sframe_encoder_add_fre): Use fre_datawords.
		(sframe_encoder_write_fre): Use fre_datawords.

2026-01-23  Indu Bhagat  <indu.bhagat@oracle.com>

	include: gas: sframe: fix terminology from offset to data word
	In SFrame V3, with the addition of flexible FDE type, the
	variable-length array of bytes trailing the SFrame FRE header are no
	longer exclusively interpreted as signed offsets. This data can now
	include unsigned control data, unsigned padding word data or signed
	offset data. Consequently, using the term "offsets" to describe this
	trailing data is inaccurate and can be confusing.

	This patch switches the terminology to 'Data Word' across the assembler
	and the SFrame header file. Note that, the term 'Word' is used
	colloquially here, the actual size (1, 2, or 4 bytes) remains determined
	by the applicable bits in the FRE info byte.

	gas/
		* gen-sframe.c: Rename SFrame FRE 'offset' to 'data word'.
	include/
		* sframe.h (SFRAME_FRE_DATAWORD_1B, SFRAME_FRE_DATAWORD_2B,
		SFRAME_FRE_DATAWORD_4B): New constants.
		(struct sframe_fre_info): Update bitfield documentation.
		(SFRAME_V3_FRE_DATAWORD_COUNT): New macro.
		(SFRAME_V3_FRE_DATAWORD_SIZE): New macro.

2026-01-23  Indu Bhagat  <indu.bhagat@oracle.com>

	sframe: doc: terminology change from offset to data word
	ChangeLog:
		* libsframe/doc/sframe-spec.texi

2026-01-23  Tom Tromey  <tom@tromey.com>

	Simplify cp_print_class_member
	I noticed that cp_print_class_member's calling convention can be
	simplified.  In particular it seems cleaner for it to simply take a
	value and a stream; and the "prefix" argument is only ever set to one
	value.

	This version also renames the function, to indicate a bit more clearly
	what it actually does.

	Regression tested on x86-64 Fedora 40.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Add aarch64-windows support
	This makes most debugging work, except unwinding doesn't always work
	from inside dlls where no debug info is available, because SEH unwinding
	is not implemented.

	The number of available hardware breakpoints is taken from
	ID_AA64DFR0_EL1 (registry key "CP 4028").
	As for hardware watchpoints, even though ARM64_MAX_WATCHPOINTS is 2,
	testing showed that only 1 ever works, so it's fixed to that value.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Move setting size of long to windows-tdep
	It's 32bit for all (non-cygwin) Windows ABIs.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Move auto_wide_charset gdbarch method to windows-tdep
	It's UTF-16 for all Windows ABIs.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Move software breakpoint recognition code into x86-windows-nat.c
	Approved-By: Tom Tromey <tom@tromey.com>
	Reviewed-By: Christina Schimpe <christina.schimpe@intel.com>

	Move x86 selector code into x86-windows-nat.c
	Approved-By: Tom Tromey <tom@tromey.com>
	Reviewed-By: Christina Schimpe <christina.schimpe@intel.com>

	Move x86 register code into x86-windows-nat.c
	Reviewed-By: Christina Schimpe <christina.schimpe@intel.com>
	Approved-By: Tom Tromey <tom@tromey.com>

	Move x86 debug registers and related code into x86-windows-nat.c
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Create x86-windows-nat.c
	Also creates the x86_windows_per_inferior and x86_windows_nat_target
	derived classes in there which will then hold the arch-specific data and
	function overrides.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Move struct declarations into windows-nat.h
	This is done as preparation for aarch64-windows-nat, since both x86 and
	aarch64 will use them as base (after the x86 parts are split off into
	x86-windows-nat).

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Simplify windows_nat_target::resume
	Now the thread context is only needed for setting the trace bit, so move
	the rest out of the with_context lambda.

	Approved-By: Tom Tromey <tom@tromey.com>
	Reviewed-By: Christina Schimpe <christina.schimpe@intel.com>

2026-01-23  Hannes Domani  <ssbssa@yahoo.de>

	Remove duplicate code from windows_nat_target::resume
	Updating the debug registers and calling SetThreadContext is already
	done in windows_continue, called directly afterwards, so this removes it
	from windows_nat_target::resume.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Tom Tromey  <tom@tromey.com>

	Some cleanups to "pretend language" handling
	I noticed that the "pretend language" handling in the DWARF reader
	doesn't work as intended; the problem code in dwarf2_per_cu::set_lang
	is:

	  if (unit_type () == DW_UT_partial)
	    return;

	The issue here is that this subverts the very purpose of having a
	"pretend" language.

	Some background: when Jakub wrote dwz, we also added support for this
	style of DWARF compression to gdb.  Now, dwz only shares DIEs in a
	"top level" way -- i.e., at the time (and as far as I know, continuing
	to today), it would not emit a DW_TAG_imported_unit inside a
	namespace.  So, when implementing this we also implemented an
	optimization, namely that gdb would not re-read every imported unit a
	la '#include', but instead would make symtabs for each included unit
	(partial units didn't yet exist).

	However, an imported/partial unit might not have a language -- but a
	language is necessary for interpreting the DIEs.  This is where the
	"pretend" language comes from.  When reading a CU, any included
	partial units that do not have a language of their own will inherit
	that CU's language.

	This patch started by removing the DW_UT_partial check.  This of
	course caused assertion failures in some modes, as set_lang also
	asserts that the language cannot change.  But, it's possible for a CU
	to be prepared multiple times, and for different invocations to
	provide different languages.

	This is not a scenario we allowed for in the early days.  Nowadays,
	though, it seems to me that it's basically fine in practice, with the
	reason being that sharing DIEs that differ semantically but not
	syntactically across different languages is hard to achieve.

	We do see this some cross-language sharing in a limited way -- "dwz
	-5" will emit inclusions from both C and C++ CUs for the
	gdb.fortran/mixed-lang-stack.exp test -- but note that this sharing is
	limited to things that are common between C and C++, like "float".

	Therefore this patch replaces the assertions in set_lang with some
	compare-exchanges.

	Finally I changed cutu_reader to use a std::optional for the pretend
	language.  I think this makes it more clear what is happening.  And,
	while doing this I found a spot in the cooked indexer where
	language_minimal was passed in, but where the importing CU's language
	should have been used.

	I regression tested this on x86-64 Fedora 40 using the default board,
	plus the cc-with-gdb-index, cc-with-debug-names, and cc-with-dwz-5
	boards.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33661

2026-01-23  Tom Tromey  <tromey@adacore.com>

	Update black to 26.1.0
	"pre-commit autoupdate" suggests a new version of black.  This version
	seems to want to change how destructuring assignments are formatted.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-23  Matthieu Longo  <matthieu.longo@arm.com>

	aarch64 test: fix clashing test name

	fix build failures due to incorrect format specifier for uint64_t

2026-01-23  Nick Clifton  <nickc@redhat.com>

	Reword the section of the AI Acceptance Policy that refers to labelling submissions.

2026-01-23  Andrew Burgess  <aburgess@redhat.com>

	gdb/tui: return std::string from tui_get_function_from_frame
	Update tui_get_function_from_frame to return a std::string rather than
	a pointer into a static buffer.

	The value returned from tui_get_function_from_frame is passed to
	tui_location_tracker::set_location, which already stores the data in a
	std::string; this just moves the string creation earlier.

	I don't think there was anything particularly wrong with the old code,
	but I'm not a huge fan of returning data in static buffers unless
	there's a really good reason, and it doesn't feel like there's a
	really good reason in this case.

	The current approach in tui_get_function_from_frame is to call
	print_address_symbolic, and then to pull the function name from the
	result.  There is an argument that this approach could be improved,
	but I've not done that in this commit, nor do I plan to do that any
	time soon.  As such the new code should do exactly what the old code
	did.

	There should be no user visible changes after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-23  Matthieu Longo  <matthieu.longo@arm.com>

	ld: bring vfinfo() in parity with printf() for format specifiers ll[d|i|x]
	vfinfo() does not currently support the double-'l' ('ll') length
	modifier for 'd', 'u', and 'x' conversion specifiers. This caused
	incorrect behavior when using PRI[d|u|x][32|64] on some platforms,
	and is error-prone for developers who reasonably expect
	printf-compatible semantics.

	This patch adds support for ll[d|u|x] to align vfinfo() with printf()
	and improve portability and robustness.

2026-01-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	binutils: testsuite: Fix is_elf_format indentation
	One line in is_elf_format isn't indented correctly.

	Fixed thus.

	Tested on x86_64-pc-linux-gnu.

	2026-01-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		binutils:
		* testsuite/lib/binutils-common.exp (is_elf_format): Fix
		indentation.

2026-01-23  Eli Zaretskii  <eliz@gnu.org>

	gdb: Document recent enhancements when using Windows Terminal
		* gdb/NEWS:
		* gdb/doc/gdb.texinfo (Output Styling): Document support for
		24-bit colors and UTF-8 output, including emoji styling.

2026-01-23  H.J. Lu  <hjl.tools@gmail.com>

	x32: Allow R_X86_64_PC64 for SFrame V3
	SFrame V3 generates R_X86_64_PC64 relocation, instead of R_X86_64_PC32,
	in .sframe section for x86-64.  Although x32 doesn't support SFrame,
	.sframe section can be found in x32 object converted from x86-64 object
	with objcopy, which only changes the ELF file class from ELFCLASS64 to
	ELFCLASS32 with all section contents unchanged.

	Update elf_x86_64_scan_relocs to allow R_X86_64_PC64 for x32 so that
	x32 object file with .sframe section can be used as x32 linker input.

	bfd/

		PR ld/33807
		* elf64-x86-64.c (elf_x86_64_scan_relocs): Allow R_X86_64_PC64
		for x32.

	ld/

		PR ld/33807
		* testsuite/ld-x86-64/sframe.rd: New file.
		* testsuite/ld-x86-64/sframe.s: Likewise.
		* testsuite/ld-x86-64/x86-64.exp: Run PR ld/33807 tests.

2026-01-23  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Force elf headers in linux core dump
	I've got a test setup consisting of a chromebook with a MediaTek MT8183
	processor, running Debian userland with a custom kernel [1].

	The custom kernel doesn't have CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS enabled,
	and consequently the default coredump_filter is 0x23 instead of 0x33, in other
	words bit 4 (which enables the dumping of ELF headers) is not set.

	The testsuite relies on the dumping of ELF headers in core files to get the
	build-ID of the executable and shared libraries, and consequently some
	test-cases fail.

	Fix this in core_find, by adding bit 4 in the coredump_filter, if necessary.

	Fixes test-cases:
	- gdb.base/corefile-exec-mismatch.exp
	- gdb.base/corefile-find-exec.exp
	- gdb.debuginfod/corefile-mapped-file.exp
	- gdb.debuginfod/solib-with-soname.exp
	- gdb.python/py-corefile.exp
	- gdb.python/py-missing-objfile.exp

	Tested on aarch64-linux.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

	PR testsuite/33772
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33772

	[1] https://github.com/hexdump0815/linux-mainline-mediatek-mt81xx-kernel

2026-01-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-22  John David Anglin  <danglin@gcc.gnu.org>

	hppa64: Implement support for DT_TEXTREL
	This fixes ld-elf/pr19539, DT_TEXTREL in shared lib, and DT_TEXTREL
	map file warning tests on hppa64.

	2026-01-22  John David Anglin  <danglin@gcc.gnu.org>

	bfd/ChangeLog:

		* elf64-hppa.c (allocate_dynrel_entries): Set DF_TEXTREL
		if it isn't already set and we encounter a relocation
		against a readonly section.
		(elf64_hppa_late_size_sections): Add DT_TEXTREL dynamic
		entry if we have relocs and DF_TEXTREL is set in info->flags.

2026-01-22  Tom Tromey  <tromey@adacore.com>

	Fix typo in fetch-exec-and-args.exp
	pre-commit points out a typo in this file.

2026-01-22  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	ld: testsuite: Enable ld-sparc tests on Solaris
	The ld-sparc tests aren't currently run on Solaris to avoid PR
	binutils/27666.  This has been fixed, so they can be enabled there, too.

	Tested no sparc{v9,}-sun-solaris2.11 and sparc{64,}-unknown-linux-gnu.

	2026-01-17  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		ld:
		* testsuite/ld-sparc/sparc.exp: Run sparctests, sparc64tests on
		Solaris.

2026-01-22  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: sframe: graceful handling of bogus sleb128 input
	Currently, sframe_xlate_escape_sleb128_to_offsetT () uses a gas_assert
	to sanity check that a DWARF sleb128 value was successfully read from a
	single-byte buffer. However, if the byte provided has the highest bit
	set (e.g., bogus input of 0x80), the value of 'read' variable will be 0,
	triggering an assertion failure.  This concern was raised during the
	review of SFrame-V3 patches
	https://inbox.sourceware.org/binutils/807b5641-87c2-4109-9d33-bb8fa28ed5ef@suse.com/T/#u

	Change the internal API sframe_xlate_escape_sleb128_to_offsetT () to return
	an error code. Callers now check for SFRAME_XLATE_ERR_INVAL and proceed
	to a warning/exit path rather than aborting.

	gas/
		* gen-sframe.c (sframe_xlate_escape_sleb128_to_offsetT): Return int
		status. Handle read failure gracefully.
		(sframe_xlate_do_escape_cfa_expr): Check returned error code of
		read_sleb128_to_int64 and jump to warn_and_exit on error.
		(sframe_xlate_do_escape_expr): Likewise.

2026-01-22  Tom Tromey  <tom@tromey.com>

	Constify gdbserver "monitor" commands
	I noticed that the gdbserver "monitor" commands should take a const
	parameter.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-22  Andrew Burgess  <aburgess@redhat.com>

	gdb/testsuite: fix failure in gdb.server/fetch-exec-and-args.exp
	Bug PR gdb/33792 reported a gdb.server/fetch-exec-and-args.exp FAIL
	when using the native-gdbserver board:

	  FAIL: gdb.server/fetch-exec-and-args.exp: packet=on: set_remote_exec=false: test_server_with_no_exec: show remote exec-file

	The actual test output looks like this:

	  (gdb) show remote exec-file
	  The remote exec-file is unset, using automatic value "/tmp/build/gdb/testsuite/outputs/gdb.server/fetch-exec-and-args/fetch-exec-and-args".
	  (gdb) FAIL: gdb.server/fetch-exec-and-args.exp: packet=on: set_remote_exec=false: test_server_with_no_exec: show remote exec-file

	This test actually fails with native-gdbsever and
	native-extended-gdbserver boards.  The problem is that these boards
	clear the sysroot.

	This exact test has the following conditions:

	  + The qExecAndArgs is in use (see 'packet=on').

	  + We're not explicitly doing 'set remote exec-file ...' (see
	    'set_remote_exec=false').

	  + The test starts gdbserver without an executable (see
	    'test_server_with_no_exec').

	  + And because of the native-gdbsever board, the sysroot is "".

	What this means is that GDB knows that gdbserver doesn't have an
	executable thanks to qExecAndArgs, the user hasn't set an executable
	for GDB to use when starting a new inferior, but GDB does know that
	GDB and gdbserver can see the same filesystem due to the sysroot
	setting.  GDB will then automatically use the current executable as
	the remote executable name.  The test script doesn't expect this case,
	and so the test fails.

	Fix this by adjusting the script to expect the 'using automatic value
	...' text when appropriate.

	I also extended the test_server_with_no_exec proc to take a new flag
	'clear_sysroot', we now run the test with the sysroot set to 'target:'
	and with the sysroot set to "", even when using the 'unix' board.

	Additionally, I ran the test through check-all-boards and found one
	additional failure, when using --host_board=local-remote-host-native
	and --target_board=local-remote-host-native.  In this case GDB copies
	the executable to the remote host, which changes its filename.  When
	the filename appears in the 'using automatic value ...' text, I was
	expecting the filename assuming a local host.

	I could fix this, but it doesn't seem worth the extra complexity for
	this one test, so I've just set the test to be skipped for that one
	configuration.

	Now, when using check-all-boards, I'm seeing no failures.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33792

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-22  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	bfd: Use PRIu64 to print uint64_t in elf-attrs.c
	elf-attrs.c has two more errors when built on 32-bit hosts:

	In file included from bfd/elf-attrs.c:140:
	bfd/elf-attrs.c: In function ‘oav2_parse_subsection’:
	bfd/elf-attrs.c:2752:29: error: format ‘%lu’ expects argument of type ‘long unsigned int’, but argument 4 has type ‘uint64_t’ {aka ‘long long unsigned int’} [-Werror=format=]
	 2752 |       _bfd_error_handler (_("%pB: error: bad subsection length (%u > max=%lu)"),

	In file included from bfd/sysdep.h:165,
	                 from bfd/elf-attrs.c:140:
	bfd/elf-attrs.c: In function ‘_bfd_elf_parse_attributes’:
	bfd/elf-attrs.c:2910:12: error: format ‘%lld’ expects argument of type ‘long long int’, but argument 4 has type ‘bfd_size_type’ {aka ‘unsigned int’} [-Werror=format=]
	 2910 |         (_("%pB: error: attribute section '%pA' too big: %" PRId64),

	Fixed like this.

	Tested on sparc-sun-solaris2.11, i386-pc-solaris2.11, and i686-pc-linux-gnu
	with --enable-64-bit-bfd.

	2026-01-22  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		bfd:
		* elf-attrs.c (oav2_parse_subsection): Use PRIu64 to print
		uint64_t.
		(_bfd_elf_parse_attributes): Use PRIu64.
		Cast bfd_size_t arg to uint64_t.

2026-01-22  Andrew Burgess  <aburgess@redhat.com>

	gdb: pagination fix for emoji and unicode box output
	I noticed that, on a 24 line terminal, the new unicode boxed hint text
	was causing the pager to trigger unexpectedly:

	  $ gdb -nx -nh
	  GNU gdb (GDB) 18.0.50.20260107-git
	  Copyright (C) 2026 Free Software Foundation, Inc.
	  License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
	  This is free software: you are free to change and redistribute it.
	  There is NO WARRANTY, to the extent permitted by law.
	  Type "show copying" and "show warranty" for details.
	  This GDB was configured as "x86_64-pc-linux-gnu".
	  Type "show configuration" for configuration details.
	  For bug reporting instructions, please see:
	  <https://www.gnu.org/software/gdb/bugs/>.

	  ┏━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┓
	  ┃ Find the GDB manual online at:                                            ┃
	  ┃ http://www.gnu.org/software/gdb/documentation/.                           ┃
	  ┃ For help, type "help".                                                    ┃
	  ┃ Type "apropos <word>" to search for commands related to <word>.           ┃
	  --Type <RET> for more, q to quit, c to continue without paging--

	At this point there are 6 unused lines remaining in my terminal, so
	the pager should not have triggered yet.

	There are two problems here, both in pager_file::puts (in utils.c).
	Lets start with the easy problem first.  When content is written to
	the pager_file we process it within a loop looking for a newline
	character.  We handle some special cases, but if none of them apply we
	handle all general, printable, content with this block:

	  else
	    {
	      m_wrap_buffer.push_back (*linebuffer);
	      chars_printed++;
	      linebuffer++;
	    }

	This copies one byte from LINEBUFFER to M_WRAP_BUFFER, and increments
	CHARS_PRINTED.  The problem is that the unicode box characters are
	multi-byte, this means we are over incrementing CHARS_PRINTED by
	counting each byte of the unicode character as one output character.

	GDB believes that the top line of the box is actually going to span
	over multiple screen lines due to the large number of bytes within the
	line.  In reality of course, the multi-byte characters fill exactly
	one screen line.

	I propose fixing this by making use of mbrlen to spot multi-byte
	characters and count them as a single character.

	If mbrlen returns anything less than 1 (which indicates a null
	character, or an invalid character), then I just treat this as a
	single byte character and continue as before.  This means if any
	"weird" output is sent to the pager then it will still be printed.

	The null wide character case shouldn't occur as the null wide
	character is still all zeros, which the outer control loop in ::puts
	should catch, so all I'm really concerned about is the invalid wide
	character case.

	Handling multi-byte wide characters does make things a little better,
	but doesn't fix everything.  The pager still activates unnecessarily,
	but just a little later.  On the same 80x24 terminal, the output is
	now:

	  $ gdb -nx -nh
	  GNU gdb (GDB) 18.0.50.20260107-git
	  Copyright (C) 2026 Free Software Foundation, Inc.
	  License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
	  This is free software: you are free to change and redistribute it.
	  There is NO WARRANTY, to the extent permitted by law.
	  Type "show copying" and "show warranty" for details.
	  This GDB was configured as "x86_64-pc-linux-gnu".
	  Type "show configuration" for configuration details.
	  For bug reporting instructions, please see:
	  <https://www.gnu.org/software/gdb/bugs/>.

	  ┏━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┓
	  ┃ Find the GDB manual online at:                                            ┃
	  ┃ http://www.gnu.org/software/gdb/documentation/.                           ┃
	  ┃ For help, type "help".                                                    ┃
	  ┃ Type "apropos <word>" to search for commands related to <word>.           ┃
	  ┗━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━┛
	  --Type <RET> for more, q to quit, c to continue without paging--

	We managed to get an extra line of output printed, but there is still
	enough room on the terminal to print everything, so why is the pager
	triggering?

	The problem now is how we deal with lines that entirely fill the
	terminal, and how we handle newlines.

	Within the pager_file::puts inner loop we process input from
	LINEBUFFER and copy it to the M_WRAP_BUFFER, incrementing
	CHARS_PRINTED as we do.  This continues until we reach the end of
	LINEBUFFER, or until we reach a newline within LINEBUFFER.

	After each character is added to M_WRAP_BUFFER, we check CHARS_PRINTED
	to see if we have filled a line.  If we have then we flush
	M_WRAP_BUFFER and increment LINES_PRINTED.  If enough lines have now
	been printed then we activate the pager.

	Alternatively, if we encounter a newline character in LINEBUFFER then
	we flush M_WRAP_BUFFER and increment LINES_PRINTED, then we re-enter
	the inner loop, which includes performing a check to see if the pager
	should trigger.

	The problem here is that when we print the box, we entirely fill a
	screen line, and then print the newline character.  When we print the
	final non-newline character then this is enough to trigger the line
	full logic, this flushes the line and increments LINES_PRINTED.  The
	CHARS_PRINTED count is also reset to zero.

	Then we print the newline.  This never enters the inner loop, but just
	goes straight to the newline handling code, which increments
	LINES_PRINTED and also resets CHARS_PRINTED to zero.

	Notice that we've now incremented LINES_PRINTED twice.  This is the
	cause of the premature pager activation; lines that are exactly one
	screen width wide end up being double counted.

	My initial thoughts when trying to fix this were to move the full line
	check before the code which copies content from LINEBUFFER to
	M_WRAP_BUFFER, inside the pager_file::puts inner loop.  This would
	mean we only check for a full line when processing the next byte of
	output after we've filled a screen line, but we'd never encounter this
	check if the first byte after a full screen line was the newline
	character, as in this case we'd never enter the inner loop.

	And this does indeed fix the immediate problem, but I think, is still
	not correct.

	On an 80 character wide terminal, what we actually care about, is when
	we try to add the 81st _printable_ character.  If the 81st character
	was a tab then this doesn't wrap onto the next line.  Or if the 81st
	character was \r, then this certainly doesn't wrap to a new line, it
	just resets the current line.  And the same is true for the 82nd
	character, and so on.  The only time we need to trigger a new screen
	line is when we try to actually print something that will be displayed
	to the user.

	It turns out, I think, that we only want to check for a full line
	inside the block that I mentioned above, the one I just updated to use
	mbrlen.  This is the only place where printable content is copied from
	LINEBUFFER into M_WRAP_BUFFER.

	There are still some edge cases here that are not being handled
	correctly, some unicode characters are non-printable, or stack on the
	previous character, requiring zero width.  And even some of the basic
	ASCII characters that we don't cover are non-printable.  But I'm
	choosing to ignore all of these for now.  These cases were broken
	before this patch, and continue to be broken afterwards.  Broken here
	simply means that including these characters in GDB's output will
	confuse the pager, likely resulting in the pager triggering too
	early.

	But for printable characters that are 1 terminal character wide,
	things should now be a little better.  The pager will trigger only
	when we try to add the first character that wraps onto the next screen
	line.  In our original problem with the box, this means that when the
	top border of the box is printed this will no longer cause an
	increment of LINES_PRINTED.  When the newline is added then this does
	finish off the current line and increments LINES_PRINTED as expected.
	We now only increment LINES_PRINTED once for each line of the box,
	rather than twice, and so the pager no longer needs to trigger during
	startup.

	To make the code cleaner, I moved the full line check into a new
	function, pager_file::check_for_overfull_line(), and added comments in
	the LINEBUFFER handling code to explain when the new function should
	be called.

	The test gdb.python/py-color-pagination.exp needed some updates after
	this patch, the current expected output was tied to how the pager used
	to operate.  Now that we defer starting a newline until we see some
	printable characters GDB is better able to coalesce adjacent style
	changes, this accounts for the large volume of changes to this test.

	I've also added a couple of new tests to the
	gdb.python/py-color-pagination.exp file.  An initial failed idea I had
	for fixing this problem caused a bug such that empty lines would never
	have triggered the pager, there's a new test that covers this case.
	There's also a test that lines can exceed the screen width so long as
	the extra content is non-printable; the test fills a line then prints
	some tabs and a '\r' before filling the same line a second time.

	There are also a couple of new pager self tests that I added.  I wrote
	these because early on while investigating this issue, I thought I'd
	spotted a bug in pager_file::wrap_here, so I wrote these tests to
	expose that bug.  It turned not to be a bug, but a gap in my
	understanding.  I think retaining these tests isn't going to hurt, and
	increases coverage.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-22  Tom de Vries  <tdevries@suse.de>

	[gdb/build] Declare gdb_get_ncolors
	Since a recent commit, I run into:
	....
	gdb/ui-style.c: In lambda function:
	gdb/ui-style.c:597:20: error: ‘gdb_get_ncolors’ was not declared in this scope
	  597 |       int colors = gdb_get_ncolors ();
	      |                    ^~~~~~~~~~~~~~~
	make: *** [Makefile:2096: ui-style.o] Error 1
	....

	Fix this by adding the missing declaration.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	bfd: use correct format specifier for uint64_t

2026-01-22  Thiago C Silva  <opsrcodev@gmail.com>

	binutils: Fix broken bullet lists in objcopy documentation
	The documentation for --add-gnu-debuglink and --extract-symbol
	uses diverse formatting styles for list items, including @table and
	manual bullets. This looked broken in the generated man pages, showing
	raw text artifacts like "*<..>" instead of real bullet points.

	This patch unifies these sections to use @itemize @bullet, resulting in
	cleaner output and better readability for these options.

	binutils/
	        * doc/binutils.texi (objcopy): Use @itemize @bullet
	        for --add-gnu-debuglink and --extract-symbol.

2026-01-22  Thiago C Silva  <opsrcodev@gmail.com>

	binutils: Fix broken numbering in strip/objcopy --only-keep-debug doc
	The documentation for --only-keep-debug displayed the procedure steps as
	"1. 1. 1. 1." in the man pages, despite using the @enumerate command.

	This patch moves the item text to the line following the @item tag and
	adds whitespace between items. This forces the man page generator to
	correctly distinguish the items and increment the list counter.

	binutils/
	        * doc/binutils.texi (strip, objcopy): Reformat @enumerate list
	        to fix man page numbering.

2026-01-22  Eli Zaretskii  <eliz@gnu.org>

	gdb: Support UTF-8 output on MS-Windows terminal
	This detects when the Windows Terminal uses codepage 65001
	(a.k.a. "UTF-8") for output, and sets the default host
	charset to UTF-8 in that case.  It also enables Emoji
	styling, as the Windows terminal supports it in that case.

		* gdb/charset.c (INIT_GDB_FILE) [USE_WIN32API]: If the Windows
		console uses codepage 65001, set default host charset to UTF-8, and
		switch to the "C" locale, to prevent Windows from interpreting UTF-8
		sequences written to the console.
		* gdb/mingw-hdep.c (windows_initialize_console): Don't disable Emoji
		here...
		* gdb/charset.c (INIT_GDB_FILE) [USE_WIN32API]: ...disable them here
		instead, and only if the console doesn't use UTF-8.

2026-01-22  Eli Zaretskii  <eliz@gnu.org>

	gdb: Support 24-bit colors and other attributes on MS-Windows
	This enables Virtual Terminal Sequences on MS-Windows consoles
	when they are supported.  (All modern Windows versions since
	v10 support that.)  This allows to support 24-bit true-color
	and also other text attributes, like "dim" and "underline".

		* gdb/mingw-hdep.c (mingw_use_console_color_apis): Rename from
		mingw_console_initialized.
		(orig_console_mode, virt_mode_flags): New static variables.
		(windows_initialize_console): Setup the console for using Virtual
		Terminal Sequences if that is supported.
		(mingw_deinitialize_console, gdb_get_ncolors): New functions.
		* gdb/ui-style.c (colorsupport): Call gdb_get_ncolors to retrieve
		the number of colors supported by the terminal.  If the number of
		colors is greater or equal 16777216, consider 24-bit color
		supported.
		* gdb/top.c (undo_terminal_modifications_before_exit) [__MINGW32__]:
		Call mingw_deinitialize_console to restore original settings of the
		terminal.
		* gdb/posix-hdep.c (gdb_get_ncolors): New function, a trivial
		wrapper for tgetnum.

2026-01-22  Alan Modra  <amodra@gmail.com>

	libgot-1 testcases
	There is no need for multiple tests of readelf --got-contents,
	nor should the matching be so strict that changes in section layout
	force editing of the testsuite.

	It also looks to me that the i386 --got-contents output is wrong,
	at least it is confusing to have .rel.plt show
	0020020c  00000307 R_386_JUMP_SLOT   00000000   bar
	while the corresponding got-contents dump shows "bar + 156".
	     3: 0020020c R_386_JUMP_SLOT   bar + 156

		* testsuite/ld-i386/binutils.exp: Reduce number of tests.
		* testsuite/ld-i386/libgot-1.rd: New.
		* testsuite/ld-i386/libgot-1a.rd,
		* testsuite/ld-i386/libgot-1b.rd,
		* testsuite/ld-i386/libgot-1c.rd,
		* testsuite/ld-i386/libgot-1d.rd: Delete.
		* testsuite/ld-x86-64/binutils.exp: Reduce number of tests.
		* testsuite/ld-x86-64/libgot-1.rd: New.
		* testsuite/ld-x86-64/libgot-1a.rd,
		* testsuite/ld-x86-64/libgot-1b.rd,
		* testsuite/ld-x86-64/libgot-1c.rd,
		* testsuite/ld-x86-64/libgot-1d.rd: Delete.
		* testsuite/ld-x86-64/libgot-1-x32.rd: New.
		* testsuite/ld-x86-64/libgot-1a-x32.rd,
		* testsuite/ld-x86-64/libgot-1b-x32.rd,
		* testsuite/ld-x86-64/libgot-1c-x32.rd,
		* testsuite/ld-x86-64/libgot-1d-x32.rd: Delete.

2026-01-22  Andrew Burgess  <aburgess@redhat.com>

	gdb: fix 'info frame' for tail calls with no debug information
	If the inferior stack contains a tail call function.  And if the CU
	containing the tail call function doesn't have any debug information.
	And if the user uses 'info frame' to examine the tail call frame, then
	GDB will report the wrong function name, for example:

	  Breakpoint 1, 0x000000000040110a in callee ()
	  (gdb) bt
	  #0  0x000000000040110a in callee ()
	  #1  0x0000000000401116 in caller ()
	  #2  0x0000000000401140 in main ()
	  (gdb) up
	  #1  0x0000000000401116 in caller ()
	  (gdb) frame
	  #1  0x0000000000401116 in caller ()
	  (gdb) info frame
	  Stack level 1, frame at 0x7fffffffa440:
	   rip = 0x401116 in dummy_func; saved rip = 0x401140
	   called by frame at 0x7fffffffa450, caller of frame at 0x7fffffffa430
	   Arglist at 0x7fffffffa430, args:
	   Locals at 0x7fffffffa430, Previous frame's sp is 0x7fffffffa440
	   Saved registers:
	    rbp at 0x7fffffffa430, rip at 0x7fffffffa438
	  (gdb)

	Notice that 'info frame' claims that the current frame is 'dummy_func'
	rather than 'caller', as the 'backtrace', 'up', and 'frame' commands
	claim.

	This is because 'backtrace', 'up', and 'frame' all uses print_frame to
	print the frame details, which in turn uses find_frame_funname to get
	the frame's function name.

	In contrast, 'info_frame_command_core' contains an inlined copy of
	'find_frame_funname' with one key difference.  The code in
	info_frame_command_core uses get_frame_pc_if_available while
	find_frame_funname uses get_frame_address_in_block_if_available.  The
	latter function returns '$pc - 1' if the frame in question could be a
	tail call function, while get_frame_pc_if_available always returns
	$pc.  This difference means that, for a tail call function, GDB will
	lookup the wrong msymbol.

	Fix this by updating info_frame_command_core to use
	find_frame_funname.  We end up still keeping the call to
	get_frame_pc_if_available as 'info frame' still needs to print this
	address.  There should be no other noticeable changes after this
	commit.

	There's also a test in which I have tried to create a tail call
	function in a (relatively) target agnostic way.  I compile a test
	program, pull some addresses from it, then recompile the test to
	assembly, and augment the assembler output, changing one symbol size,
	and adding an entirely new function symbol.  The modified assembly
	file is then compiled, without debug information, to create the actual
	test executable.  This gives GDB the impression that the test contains
	a tail call function.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	gnu directives: bfd: generic tests for merge of gnu attributes v2
	These tests are a copy-paste of the generic tests for AArch64.

	Test cases:
	    - only one input object is copied to the output object
	    - merge two inputs with optional subsections of both types
	      ULEB128 and NTBS, which contains same, additional, and
	      missing attributes.
	    - mismatch subsection properties.
	    - combine matching required subsections.
	    - combine non-matching required subsections.
	    - prune unknown attributes in known subsections.
	    - prune unknown subsections.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	gnu directives: bfd: generic tests for objcopy of gnu attributes v2

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	gnu directives: gas/readelf tests for gnu attributes v2
	These tests are a copy-paste of the generic parsing tests for AArch64.

	The added tests cover the parsing of the new assembly directives
	(gnu_subsection and gnu_attribute), the serialization of the
	Object Attributes v2 (OAv2) data into an object file, and the
	dumping of those data via readelf.

	The parsing tests focus on the following points:
	- the syntax of the new directives.
	- the recognition of generic tokens like: NTBS, ULEB128, required,
	  optional.

	The dumping tests focus on:
	- the OAv2 population into the correct section assigned by the backend.
	- the merge of the subsections and attributes when they are declared
	  several times inside respectively the same compilation unit, and
	  subsection.
	- the sorting of OAv2 before the serialization.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	gnu directives: add support for .gnu_attribute and .gnu_subsection in OAv2 context
	This patch adds support for the GNU directives .gnu_attribute and
	.gnu_subsection, used respectively for OAv1 and OAv2, and for OAv2
	only. These directives behave like their AEABI counterparts, as
	they are aliases intended for use by any backends supporting OAv1
	and/or OAv2. Their availability is controlled by the TC_OBJ_ATTR_v1
	and TC_OBJ_ATTR_v2 macros.

	Previously, the "gnu_" subsection namespace was used only for
	"gnu_testing_" and defaulted to a private scope. This patch updates
	the scope recognition to correctly distinguish between private usage
	(e.g., testing) and public usage (e.g., actual GNU subsections
	storing public information).

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	ld tests for AArch64-specific merge coverage for AEABI Build Attributes
	Test cases:
	- coverage of required subsection 'aeabi_pauthabi'.
	- coverage for BTI, PAC, GCS used along GNU properties.
	- warn on unknown attributes, and prune them from output.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	aarch64: merge of Object Attributes v2 during linkage
	This patch adds support to AArch64 backend to process AEABI Build
	Attributes and raise any compatibility issue.

	AArch64 backend declares 2 vendor subsections, and their associated tags:
	- aeabi_feature_and_bits: contains tags that describe the same optional
	  bits as the GNU_PROPERTY_AARCH64_FEATURE_1_AND. For now, the following
	  attributes are recognized:
	    - Tag_Feature_BTI: means that all the executable sections are
	      compatible with Branch Target Identification (BTI) mechanism.
	    - Tag_Feature_PAC: means that all the executable sections have been
	      protected with Return Address Signing.
	    - Tag_Feature_GCS: means that all the executable sections are
	      compatible with the Guarded Control Stack (GCS) extension.
	- aeabi_pauthabi: contains information about the Pointer Authentication
	  Signing schema when the object uses an extension to ELF, PAUTHABI64,
	  which is currently not supported by GCC toolchain. The pointers that
	  are signed as well as the modifiers and key used for each type of
	  pointer are known as the signing schema. The support of this
	  subsection is there for completeness with the AEABI Build Attributes
	  document, and allows readelf to dump the data nicely, and the linker
	  to detect a use of a signing schema, and error.
	    - Tag_PAuth_Paltform: the platform vendor id.
	    - Tag_PAuth_Schema: the version numner of the schema.

	For backward-compatibilty purpose, AArch64 backend translates
	GNU_PROPERTY_AARCH64_FEATURE_1_AND in input files to its OAv2 equivalents.
	The frozen set of OAv2 is populated with values derived from command-line
	options for BTI (-z force-bti) and GCS (-z gcs=*).
	It also reports incompatibilities for BTI and GCS, and set BTI PLT type
	depending on the OAv2 merge result.
	Regarding incompatibilities, only the ones detected in objects constituting
	the output link unit will be reported. Supports for detecting incompatibilities
	in shared objects might be a future work to bring it in pair with the GNU
	properties merge. However, since OAv2 are translated to GNU properties,
	detection will still happen so this feature seems redundant and of little
	value given the backward compatibility support for GNU properties is
	required (see next paragraph).
	Finally, it translates OAv2s in subsection "aeabi_feature_and_bits" to
	GNU_PROPERTY_AARCH64_FEATURE_1_AND as GNU properties are required for
	the dynamic linker (it does not understand OAv2s yet).

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	ld tests for generic merge coverage of Object Attributes v2
	Test cases:
	- only one input object is copied to the output object
	- merge two inputs with optional subsections of both types
	  ULEB128 and NTBS, which contains same, additional, and
	  missing attributes.
	- mismatch subsection properties.
	- combine matching required subsections.
	- combine non-matching required subsections.
	- prune unknown attributes in known subsections.
	- prune unknown subsections.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: translate GNU properties to Object Attributes v2 (and vice versa)
	Some input objects may contain inconsistencies, i.e. they might include
	GNU properties but lack the corresponding object attributes, or inversely.
	The later case is never produced by Gas, but the former can occur with
	older Gas versions that do not support object attributes.

	To keep consistency during the merge process, each input object's GNU
	properties are translated into their object attributes equivalents (if
	they exists). Also, after object attributes have been merged at the file
	scope, they are translated back to GNU properties to keep the GNU
	properties merge process consistent. This final translation occurs before
	merging the input with the global merge accumulator (a.k.a. REF) and the
	global configuration (a.k.a FROZEN).

	Note: the first parameter of translate_obj_attrs_to_gnu_props(), bfd *,
	should be 'const', but this implies that _bfd_elf_get_property() should
	also be constified, and this is out of scope.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: prune unsupported or invalid subsections and attributes
	During the merge, each subsection and attribute is assigned a status.
	If the status is OK, the item is retained and serialized into the
	output object. Otherwise, unsupported or invalid subsections and
	attributes are pruned before serialization.

	When a subsection or attribute is pruned, ld emits information-level
	messages to inform the user, preventing confusion about the absence
	of elements that were present in the input objects.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: merging Object Attributes
	The Object Ottributes merge process must handle both optional and
	required subsections. It also treats the first merge of the frozen set
	specially, as the OAv2 list in the input BFD serves as the accumulator
	for subsequent merges.

	** Optional subsections

	Optional subsections are processed as if merging two ordered sets — by
	iterating linearly through both, checking whether an element of a given
	ordinality is present in the opposite set, and adding it to the
	accumulator. The added diffuculty with subsections and attributes lies
	in the fact that missing elements have default values, and these must be
	merged with existing ones to produce the final value to be stored.

	** Required subsections

	Required subsections are processed slightly differently from the
	optional subsections, as they cannot be pruned since they are mandatory,
	hence an error will be raised by the linker if it is not recognized.

	For now, the subsection for PAuth ABI is the only one use case, and
	no merge is applied on the values. The values simply need to match.
	This implementation choice might be challenged in the future if required
	subsections can have the same diversity as optional subsections. If the
	case arises, the refactoring to handle this new behavior should consist
	in adding a new merge policy MERGE-EQUAL, or something similar. Some "if
	required" should be added in the optional subsections merge logic to
	error on any missing elements, or mismatch, and messages should also be
	rephrased to point out that the error is for a required subsection.

	** Important note regarding support for testing

	In order to test this generic logic, AArch64's use cases are not
	offering enough coverage, so a "GNU testing namespace" which corresponds
	to the name of the subsection was introduced. It follows the following
	pattern:
	  gnu_testing_<XXXXXX>_MERGE_<POLICY>
	with:
	  - <XXXXXX>: an arbitrary name for your testing subsection.
	  - <POLICY>: the name of the merging policy to apply on the values in
	    the subsection. The currently supported merge policy are:
	      * _MERGE_AND: bitwise AND applied on numerical values.
	      * _MERGE_OR: bitwise OR applied on numerical values.
	      * _MERGE_ADD: concatenates strings together with a '+' in-between.
	    Note: "_MERGE_ADD" does not make really sense, and will very likely
	    never be used for a real merge. Its only purpose is to test the
	    correct handling of merges with strings.
	Any subsection name matching neither names supported by the backend, nor
	following the pattern corresponding GNU testing namespace will be considered
	unknown and its status set to obj_attr_subsection_v2_unknown. This will
	have for consequence the pruning of this subsection.

	Additionally, the first two tags in gnu_testing namespace, GNUTestTag_0
	and GNUTestTag_1, are known, and so have a name and can be initialized
	to the default value ('0' or NULL) depending on the encoding specified
	on the subsection. Any tags above 1 will be considered unknown, so will
	be default-initialized in the same way but its status will be set to
	obj_attr_v2_unknown. This behavior of the testing tags allows to test
	the pruning of unknown attributes.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: mark unknown subsections
	In Object Attributes v2, the merge policy is not encoded within the
	subsection definition. It is therefore up to the linker to determine
	the appropriate policy based on the subsection's name and properties.
	Unless a subsection is explicitly recognized by the linker, the
	spefication of OAv2 provides no means to infer its merge policy.
	Furthermore, in theory, this merge policy could vary between
	attributes within the same subsection.

	As a result, before beginning the merge process, ld inspects each
	subsections, and attempts to identify them as either a GNU subsection,
	or a backend-specific one. If this identification fails, the status
	of the subsection is set to 'UNKNOWN'. Subsections marked as unknown
	are then skipped during the merge process, and later pruned from the
	output before the serialization.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: merge subsections and tags at file scope
	Before merging input object files together, each input's object
	attributes must be sanitized to ensure that duplicate subsections and
	attributes are merged and properly sorted.  Indeed, uniqueness and
	ordering of subsections and attributes are required prerequisites for
	the merge process.
	This operation also handles, on a best-effort basis, exotic objects
	produced by non-GNU assemblers, where duplicate subsections may appear
	across different sections, and similarly, duplicate attributes across
	subsections.
	It is importand to note that such cases are not covered by the Object
	Attributes specification, and the resulting behavior is implementation
	-defined.  Other linkers may handle these inputs differently.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: create a section for object attributes
	bfd copies object attributes to the output BFD only if the input BFD —
	used to store the merge result— contains an object attribute section.
	bfd_linear_find_first_with_obj_attrs() returns an input BFD that may or
	may not already include such a section.  If no object attributes section
	is found, the merge process must create one.

	This patch implements create_object_attributes_section(), which constructs
	the missing section with the appropriate flags, type, and alignment.  The
	implementation is adapted from _bfd_elf_link_create_gnu_property_sec() in
	bfd/elf-properties.c.  The code preserves the different alignment
	requirements for 32-bit and 64-bit ELF formats, although the rationale for
	this distinction remains unclear in the original source and patch history.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: find first input containing an object attributes section
	During the merge process, the linker first scans the list of input files
	to identify ELF object files that contain object attributes. If no such
	object file is found, the merge process terminates. Otherwise, the first
	matching file is used as the placeholder for the global merge result.

	This patch implements a linear search to locate the first input BFD
	containing an Object Attributes section, while recording a good candidate
	otherwise.

	It is worth noting that the position of the object file in the list, as
	well as whether it contains object attributes or not, or whether it
	contains an object attributes section or not, are not significant. Any
	input ELF object files could serve this placeholder purpose if the merge
	process was performed in parallel.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	OAv2 merge: plumbing of generic merge logic during linkage
	This patch adds the plumbing for the OAv2 generic merge logic in the
	linker. The linker is an "advanced" consumer of OAv2. After parsing,
	it deduplicates the attributes, merges them, detects any compatibility
	issues, and finally translates them to GNU properties.

	This patch only prepares the infrastructure required to support that
	processing. All operations described below rely on helpers or stubs,
	and their implementation details will be added in the subsequent
	patches.

	** Intended pipeline

	Disclaimer: the description below documents the intended processing
	pipeline. This commit only establishes the phases boundaries, and
	call sites. The actual logic of each step is implemented in subsequent
	patches.

	The OAv2 processing pipeline follows a map-reduce pattern. Obviously,
	the actual processing in GNU ld is not multi-threaded, and the
	operations are not necessarily executed directly one after another.

	* Phase 1, map: successive per-file operations applied on the list of
	  compatible input objects.
	  1. Parsing of the OAv2 section's data (also used by objcopy).
	  2. Translation of relevant GNU properties to OAv2. This is required
	     for the backward-compatibility with input objects only marked
	     using GNU properties.
	  3. Sorting of the subsections and object attributes. Further
	     operations rely on the ordering to perform some optimization in
	     the processing of the data.
	  4. Deduplication of subsections and object attributes, and detection
	     of any conflict between duplicated subsections or tags.
	  5. Translation of relevant OAv2 to GNU properties for a forward
	     -compatibility with the GNU properties merge.
	  6. Marking of unknown subsections to skip them during the merge
	     (in phase 2), and to prune them before the output object's
	     serialization (in phase 3).

	* Phase 2, reduce: OAv2 in input objects are merged together.
	  1. Gathering of "frozen" values (=coming from the command-line
	     arguments) into a virtual read-only list of subsections and
	     attributes.
	  2. Merging of OAv2 from an input file and the frozen input.
	  3. Merging of the results of step 2 together. Since the OAv2 merge
	     is commutative and associative, it can be implemented as a reduce.
	     However, GNU ld implements it as an accumulate because it does
	     not support multithreading.
	  Notes: the two merge phases also perform a marking of unsupported/
	  invalid subsections and attributes. This marking can be used for
	  debugging, and also more practically, to drop unsupported optional
	  subsections from the output.

	* Phase 3, finalization of the output.
	  1. Pruning of the unknown / unsupported / invalid subsections and
	     attributes.
	  2. Serialization of OAv2 data (also used by objcopy).
	  Notes:
	   - There is no translation of the merged OAv2 to GNU properties
	     at this stage, as the GNU properties merge process has already
	     all the needed information (translated in step 5 of stage 1) to
	     produce the GNU properties equivalents.
	   - The GNU properties are currently required as the runtime linker
	     does not understand OAv2 yet.
	   - Phase 3 should also include a compatibility check between the
	     final merge result of the current link unit and input shared
	     objects. I opted for postponing this compatibility check, and
	     GNU properties merge will take care of it as it already does.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	objcopy tests for Object Attributes v2

	bfd: add support for copying Object Attributes v2
	The OAv2 section's content of the source file is copied to the
	destination object file without any alteration of the attributes
	or subsections (no deduplication nor sorting of subsections or
	object attributes is performed).
	For now, only ELF format is supported.

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	bfd: parse Object Attributes v2's section in input object files
	This patch adds to BFD the capability of parsing the Object Attributes v2
	(OAv2) stored into the section defined by the backend (i.e. .ARM.attributes
	for AArch64).

	An OAv2 section is organized with the following syntactic structure:
	  <format-version: uint8>
	  [ <subsection-length: uint32>
	    <subsection-name: NTBS>
	    <optionality: uint8>
	    <encoding: uint8>
	    <attribute>*
	  ]*

	Once parsing is completed, OAv2 are stored in a list of subsections in
	elf_obj_tdata.

	Regarding ULEB128 parsing, the implementation of _bfd_safe_read_leb128
	has known shortcomings. In particular, it may accept malformed ULEB128
	values if the 8th bit is set while meeting the end condition "data < end".
	The error handling could be improved, but this function is old and used
	in more than 50 places. The same issue applies to _bfd_read_unsigned_leb128
	and _bfd_read_signed_leb128, which likewise do not report errors in
	this case. Since this is long-standing behavior and fixing it would
	require broader changes outside the scope of this patch series, the
	issue is acknowledged but not addressed here, and is considered
	acceptable as this patch does not worsen the situation.

2026-01-22  Richard Ball  <richard.ball@arm.com>

	Serialization and dumping tests of Object Attributes v2
	The added tests cover the parsing of the new assembly directives
	(aeabi_subsection and aeabi_attribute), the serialization of the
	Object Attributes v2 (OAv2) data into an object file, and the
	dumping of those data via readelf.

	The parsing tests focus on the following points:
	- the syntax of the new directives.
	- the recognition of generic tokens like: NTBS, ULEB128, required,
	  optional.
	- the recognition of backend-specific tokens like Tag_Feature_(BTI,
	  PAC,GCS).

	The dumping tests focus on:
	- the OAv2 population into the correct section assigned by the backend
	  (i.e. .ARM.attributes for AArch64).
	- the merge of the subsections and attributes when they are declared
	  several times inside respectively the same compilation unit, and
	  subsection.
	- the sorting of OAv2 before the serialization.

	Co-Authored-By: Matthieu Longo <matthieu.longo@arm.com>

2026-01-22  Richard Ball  <richard.ball@arm.com>

	readelf: dump Object Attributes v2
	This patch adds support to readelf for displaying Object Attributes v2
	on AArch64. The list of known tags and subsections match the ones in
	the document "Build Attributes for the Arm 64-bit Architecture (AArch64)"
	available at [1].

	[1]: https://github.com/ARM-software/abi-aa

	Co-Authored-By: Matthieu Longo <matthieu.longo@arm.com>

2026-01-22  Richard Ball  <richard.ball@arm.com>

	bfd: write Object Attributes v2
	This patch adds the serialization logic to write Object Attributes v2 (OAv2)
	into the ELF section specified by the backend (.ARM.attributes for AARch64).

	OAv2, once processed by the parser, are stored in the order they were
	declared in the assembly, so not necessarily sorted. Sorting them
	simplifies the comparison of the data between several files. Since
	sorting OAv2 is clearly not the responsibility of readelf, they need
	to be sorted by the producers (i.e. gas or ld).
	The linker sorts the subsections and attributes as a pre-requisite of
	the merge. Since the merge preserves the ordering, no final sort is
	required before the serialization, contrarilly to the assembler.

	Moving the final sort for gas into set_obj_attr_contents would mean
	that a sort would be performed on an already-sorted collections. To
	avoid this redundant operation at link time, we check whether the
	output BFD is a linker output (is_linker_output = 1). If it is not
	(i.e., it is gas), we perform a finalization step that sorts the
	subsections and attributes before writing.

	As previously mentioned, the logic of OAv1 and OAv2 is kept separated.

	Co-Authored-By: Matthieu Longo <matthieu.longo@arm.com>

2026-01-22  Matthieu Longo  <matthieu.longo@arm.com>

	gas: use common code for object attribute v1 & v2 parsing
	Since the previous patch added all the code to be able to parse both
	OAv1 and OAv2 directives, this patch switches OAv1 to use this common
	code.
	Additionally to the common code in obj-elf.c, the following backends
	using a custom object attribute directive were impacted.
	  - ARC
	  - Arm
	  - m68k
	  - PowerPC
	  - RISC-V
	  - TI C6X
	A parsing test for Arm had to be adapted to the error messages of the
	new parser.

	The gas and ld test suites were successfully run for the following
	backends: S390, ARC, Arm, CSky, m68k, msp430, PowerPC, TI C6X, RISC-V,
	AArch64, MIPS, SPARC.

2026-01-22  Richard Ball  <richard.ball@arm.com>

	gas: implement parsing of object attributes v2
	This patch adds the parsing logic for Object Attributes v2 (OAv2), enabling
	Gas to interpret and process these attributes correctly. It also updates the
	AArch64 backend to utilize the new parsing capabilities, and handle the new
	AArch64-specific directives.

	This patch relies on the abstractions introduced in the previous patch to
	store the data. Its scope is limited to parsing the new assembly directives,
	checking the inputs, and storing the data into the relevant OAv2 abstractions.
	Note that, for now, the new parsing capabilities are only available for AArch64.
	Even if the implementation was splitted into a generic part available in
	gas/config/obj-elf.c, and an AArch64-specific one in gas/config/tc-aarch64.c,
	the lack of GNU generic directives to handle OAv2 prevented the capability
	from being exposed to others backends.

	** GNU assembler interface for aeabi subsections

	OAv2 introduced two new directives for AArch64:
	- .aeabi_subsection name, comprehension, encoding
	  Create or switch the current subsection to 'name'.
	  Comprehension values can be 'required' or 'optional'.
	  Encoding values are limited for now to 'ULEB128', and 'NTBS'
	  The comprehension and encoding are mandatory arguments on the first
	  declaration of the subsection, but become optional for subsequent
	  ones.
	- .aeabi_attribute tag, value
	  Set 'tag' to 'value' in the current subsection.
	  Tag can either be an integer, or one of the defined symbols in the backend.

	The usage of those directives will error if the following requirements
	are breached:
	- If the subsection X has been previously declared, the comprehension and
	  encoding parameters of the current .aeabi_subsection that redeclares X
	  have to match with the previous declaration. If those parameters are
	  omited, no check is performed.
	- The type of the value set via .aeabi_attribute has to align with
	  the current subsection.
	- If the tag N has already been declared for the current subsection, a
	  later assignment to tag N is tolerated only if the newly set value is
	  equal to the former one. This check is stricter than needed. Ideally,
	  the tag N's values should be merged together, and an error should be
	  raised only if an incompatibility is detected. Because the attributes
	  are set in one chunk by GCC, there is no real use case for such a merge.

	The new parsing code is enabled/disabled via the TC_OBJ_ATTR_v1 and
	TC_OBJ_ATTR_v2 defines, and supports the following configurations:
	- enable both OAv1 and OAv2 parsing. This is currently used by no
	  target, but is useful for migration from OAv1 to OAv2.
	- enable OAv1 parsing only. This is used by all targets supporting OAs
	  except for AArch64.
	- enable OAv2 parsing only. This is only used by AArch64.

	** Regarding the implementation

	The logic of OAv1 does not always keep separated the different data processing
	steps: parsing, convertion to internal abstractions, error checking and further
	processing (if any) on those abstractions, and their serialization into the
	object files.
	This patch takes into account the specifities of syntax for OAv1 and OAv2, but
	mutualize as much as possible the common behavior so that the same methods can
	be used for parsing the OAv1 and OAv2 directives.
	However, the mutualization of the code is limited by a different internal model
	for OAv1 and OAv2. Even if it is technically feaseable to have only one middle
	-end for OAv1, OAv2 and even GNU properties, sharing the same data model to
	perform the merge logic with the same code, it is a significant amount of work.
	This extra work was not considered as a part of this new feature, so this patch
	series will stick with the minimum of mutualization as possible.

	Co-Authored-By: Matthieu Longo <matthieu.longo@arm.com>

2026-01-22  Richard Ball  <richard.ball@arm.com>

	Object Attributes v2: new abstractions for subsections and attributes
	This patch lays the groundwork for the support of Object Attributes v2 (OAv2).
	OAv2 is an enhancement of OAv1. They retain successful aspects of OAv1, define
	the relationship between object attributes and existing GNU properties, separate
	architectural requirements from software ABI requirements, and simplify the
	format to make it easier for OAv2 consumers to parse, and skip subsections and
	attributes. Interestingly, OAv2 have only one scope: the whole relocatable file
	where they were specified. For the reason behind this choice, see [1], "Build
	attributes at file scope only". This document also provides more insights into
	the design rationale for OAv2.

	Even if OAv2 was designed primarily for AArch64, this implementation splits the
	generic core logic from the backend-specific one, and aims at facilitating OAv2
	adoption by others backend. This logic will apply for any subsequent OAv2 patch.

	New abstractions for attributes and subsections are introduced in bfd/elf-attrs.h
	Those align with the format of OAv2 proposed in [2].

	An object attribute obj_attr_v2 is a tag-value pair:
	 - tag: a key, i.e. a unique identifier for the attribute in the
	   subsection.
	 - value: a variant for which the interpretation depends on the encoding
	   set in the subsection it was stored in. 2 types of values are possible:
	   ULEB128 (Unsigned Little Endian Base 128) or a string encoded as NTBS
	   (Null-Terminated Byte String).

	A subsection obj_attr_subsection_v2 has the following members:
	 - name: the name of this subsection.
	 - scope: the prefix in the subsection name determines whether the
	   subsection is public or private.
	 - optionality: is this subsection optional or required ? Depending on
	   whether the subsection is public or private, it can be ignored by the
	   consumer.
	 - encoding: see previous note regarding the value of an attribute. This
	   encoding applies to all the attributes in this subsection.
	 - list of object attributes.

	Even if OAv1 and OAv2 data structures are similar, their processing is
	different. Thus refactoring the code of OAv1 and OAv2 to share it does not
	seem the right approach for clarity and maintainability, and minimalization
	of the risk of introducing regressions.
	Consequently, utility functions to initialize, copy, swap, free, compare,
	mutate, and sort those structures won't be shared between OAv1 and OAv2.

	Finally, the version ID used to identify the storage format of the object
	attributes is object and backend dependent. This approach allows mixing
	OAv1 and OAv2 in input objects. Then the deserializer translates the input
	data to the internal model (currently OAv2, but it could be a more generic
	one in the future) to perform the merge. In the end, the output format is
	set by the backend: OAv2 for AArch64, OAv1 for others. The only exception
	for this is objcopy, which won't change the format of the object attributes,
	and will preserve the format of the data during the copy.
	Hopefully, this mechanism will make easy the migration from OAv1 to OAv2 if
	anyone is interested.

	[1]: [Design Rationale for Build Attributes for the Arm 64-bit Architecture (AARCH64)]
	     (https://github.com/ARM-software/abi-aa/blob/eec881270d5e3b23e58a6250640d06ff545ec1fc
	      /design-documents/buildattr64-rationale.rst)
	[2]: [Build Attributes for the Arm® 64-bit Architecture (AArch64)](https://github.com
	      /ARM-software/abi-aa/blob/eec881270d5e3b23e58a6250640d06ff545ec1fc/buildattr64
	      /buildattr64.rst)

	Co-Authored-By: Matthieu Longo <matthieu.longo@arm.com>

2026-01-22  Tom de Vries  <tdevries@suse.de>

	[gdb/symtab] Fix segfault in cutu_reader::read_toplevel_die
	PR 33818 reports a problem when running test-case
	gdb.ada/uninitialized-variable-record.exp:
	...
	(gdb) print y2
	dwarf2/read.c:14073:20: runtime error: member access within null pointer of \
	  type 'struct dwarf2_cu'
	ERROR: GDB process no longer exists
	...
	bisecting to commit 2f23cf07253 ("[gdb] Add regression test for PR
	symtab/33777").

	I managed to reproduce it using target board readnow.

	The problem is here in cutu_reader::read_toplevel_die:
	...
	  m_new_cu.get ()->per_objfile->per_bfd->nr_toplevel_dies_read++;
	...

	Class cutu_reader has two fields pointing to a dwarf2_cu:
	...
	  /* The CU of the DIE we are parsing.  */
	  struct dwarf2_cu *m_cu;
	...
	and:
	...
	  dwarf2_cu_up m_new_cu;
	...
	and m_new_cu is not always set.

	Fix this by using m_cu instead.

	Reported-By: Jan Vrany <jan.vrany@labware.com
	Suggested-By: Simon Marchi <simon.marchi@efficios.com>

	Tested on x86_64-linux.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33818

2026-01-22  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix regression in gdb.base/maint.exp
	After commit 2f23cf07253 ("[gdb] Add regression test for PR symtab/33777"),
	test-case gdb.base/maint.exp regressed:
	...
	FAIL: gdb.base/maint.exp: maint print statistics
	...

	Fix this by updating the expected output.

	Tested on x86_64-linux.

	Reported-By: Jan Vrany <jan.vrany@labware.com

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33818

2026-01-22  Alan Modra  <amodra@gmail.com>

	PR 33821 use after free commit e6357caf7579
	reset_resolved_wilds didn't clear out matching_sections in output
	sections with constraint -1.  Fix that and tidy call sites of
	obstack_init and obstack_free for matching_obstack so that the obstack
	is allocated later and freed completely.  Also tidy ptroot.

		PR 33821
		* ldlang.c (the_root): Delete, replacing with..
		(ptroot): ..this, no longer a pointer.  Update all uses.
		(lang_for_each_statement_worker): Add "constrained" param.
		Ignore os.constraint if false.
		(reset_resolved_wilds): Use lang_for_each_statement_worker.
		Move obstack_init..
		(lang_init): ..and this obstack_init of matching_obstack..
		(resolve_wilds): ..to here.
		* ldlang.h (lang_for_each_statement_worker): Update declaration.
		(lang_for_each_statement): Update.
		* emultempl/xtensaelf.em: Update lang_for_each_statement_worker
		calls throughout.

2026-01-22  Alan Modra  <amodra@gmail.com>

	sframe fre sanity checks
	I noticed the fre esz check in flip_sframe_fdes_with_fres_* was wrong,
	testing against the full buffer size rather than the remaining size.
	It is also ineffective at stopping buffer overflows to check after the
	buffer accesses have occurred.

	Likely many more buffer overflow checks in the sframe code are needed
	before anyone can claim it is secure.  Even in the fre code, I see
	things like sframe_decoder_get_fres_buf merrily iterating over fres
	without a concern for buffer overflow.

		* sframe.c (flip_fre): Add fp_size param.  Use it to avoid
		buffer overflow on fuzzed input.
		(flip_sframe_fdes_with_fres_v2): Pass remaining buffer size to
		flip_fre.  Remove now redundant and wrong esz check.
		(flip_sframe_fdes_with_fres_v3): Likewise.

2026-01-22  Tom Tromey  <tom@tromey.com>

	Remove lookup_transparent_type lang hook
	C++ was the only user of the lookup_transparent_type lang hook, so it
	can be removed entirely.  basic_lookup_transparent_type and its helper
	function are renamed as appropriate.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-22  Tom Tromey  <tom@tromey.com>

	Remove cp_lookup_transparent_type
	cp_lookup_transparent_type seems to be a workaround for bugs in very
	old compilers.  A comment mentions that the bugs are fixed in GCC 3.4
	-- released in 2004.

	I think this is long past due for removal, which this patch does.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-21  Alan Modra  <amodra@gmail.com>

	hppa64 root.u.def assertions
	The aim here is to add assertions when root.u.def is accessed that
	the field is valid, ie. we have a bfd_link_hash_defined or
	bfd_link_hash_defweak symbol.  On doing so I found the assertion
	triggering on one of the ld undefweak tests, fixed with the
	elf64_hppa_finish_dynamic_symbol change.

	The patch also refactors code using text_hash_entry and
	data_hash_entry.

		* elf64-hppa.c (elf64_hppa_finish_dynamic_symbol): Use zero
		value for both undefined and undefweak symbols, and when
		non-pic too.  Assert when accessing root.u.def that the symbol
		is the correct type.
		(elf64_hppa_finalize_opd, elf64_hppa_finalize_dlt),
		(elf64_hppa_finalize_dynreloc): Similarly assert here.
		(elf64_hppa_finalize_dlt): Move duplicate code involving
		text_hash_entry and data_hash_entry out of conditionals.
		(elf64_hppa_finalize_dynreloc, elf_hppa_dlt_dynrel_reloc),
		(elf_hppa_final_link_relocate): Likewise.

2026-01-21  Indu Bhagat  <indu.bhagat@oracle.com>

	aarch64: s390: x86_64: sframe: adjust flex fde hook implementation
	A previous commit added new backend hook sframe_support_flex_fde_p by
	defining a new function for each backend that supports SFrame stack
	trace format:

	  commit 2f9b3987db53d7e0606f89bfe2527dd3d0915568
	  [SFrame-V3] gas: sframe: add new backend hook
	  sframe_support_flex_fde_p for FLEX FDEs

	As pointed out in a review comment, simply providing the definition to
	use true/false (as applicable) is sufficient for the purpose, and helps
	generate better code.  So do that.
	https://inbox.sourceware.org/binutils/80404871-53b4-4f5c-9d86-7a3a4d0a920e@suse.com/

	ChangeLog:
		* gas/config/tc-aarch64.c (aarch64_support_flex_fde_p): Remove.
		* gas/config/tc-aarch64.h (aarch64_support_flex_fde_p): Remove.
		(sframe_support_flex_fde_p): Define to false.
		* gas/config/tc-i386.c (x86_support_flex_fde_p): Remove.
		* gas/config/tc-i386.h (x86_support_flex_fde_p): Remove.
		(sframe_support_flex_fde_p): Define to true.
		* gas/config/tc-s390.c (s390_support_flex_fde_p): Remove.
		* gas/config/tc-s390.h (s390_support_flex_fde_p): Remove.
		(sframe_support_flex_fde_p): Define to true.

2026-01-21  Tom Tromey  <tromey@adacore.com>

	Remove angle brackets from "apropos" text
	I didn't notice during review, but the boxing patch introduced this
	change:

	-	      styled_string (command_style.style (), "apropos word"));
	+	      styled_string (command_style.style (), "apropos <word>"));

	GNU doesn't generally use the "<...>" convention, but instead uses
	upper case for "metasyntactic variables".  See the GNU coding
	standards for this topic.

	In this particular spot, though, I think the old form using quotes is
	preferable.  This patch reverts this change.

	Reviewed-By: Tom de Vries <tdevries@suse.de>

2026-01-21  John David Anglin  <danglin@gcc.gnu.org>

	hppa64: Fallback to .text if .dynamic isn't found
	Commit a1c2fa92ac93bf50227941bd82094e6997c5fd56 broke the ld
	testcase for .note.GNU-stack wanting to be SHT_NOTE.  Fix this
	by falling back to .text if .dynamic isn't available to define
	the text segment base.

	2026-01-21  John David Anglin  <danglin@gcc.gnu.org>

	bfd/ChangeLog:

		* elf64-hppa.c (elf64_hppa_late_size_sections): Fallback
		to .text if .dynamic section isn't found.

2026-01-21  Tom de Vries  <tdevries@suse.de>

	[gdb] Ignore .sframe section in dtrace_static_probe_ops::get_probes
	On aarch64-linux (Debian testing), with test-case gdb.base/fission-macro.exp I
	run into:
	...
	(gdb) set complaints 5^M
	(gdb) file fission-macro-v4-b32-s0^M
	Reading symbols from fission-macro-v4-b32-s0...^M
	During symbol reading: \
	  skipping section '.sframe' which does not contain valid DOF data.^M
	(gdb) FAIL: $exp: lang=c: dwarf_version=4: dwarf_bits=32: strict_dwarf=0: \
	  No complaints
	...

	The problem is that there's an overlap between:
	...
	./include/elf/common.h:#define SHT_SUNW_dof                 0x6ffffff4
	...
	and:
	...
	./include/elf/common.h:#define SHT_GNU_SFRAME		     0x6ffffff4
	...

	So when dtrace_static_probe_ops::get_probes tries reading an SHT_SUNW_dof
	section, it fails to read the corresponding magic number and bails with this
	complaint:
	...
	During symbol reading: \
	  skipping section '.sframe' which does not contain valid DOF data.^M
	...

	But the section actually being read is not an SHT_SUNW_dof section, but an
	SHT_GNU_SFRAME section:
	...
	[Nr] Name      Type            Address          Off    Size   ES Flg Lk Inf Al
	[17] .sframe   GNU_SFRAME      00000000000008f0 0008f0 000035 00   A  0   0  8
	...

	Fix this by checking for the section name .sframe in
	dtrace_static_probe_ops::get_probes.

	Tested on aarch64-linux.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33813

2026-01-21  Matthieu Longo  <matthieu.longo@arm.com>

	readelf: constify read cursor for all object attribute parsing and display helpers

	aarch64: fix build issue raised by -Werror=maybe-uninitialized

2026-01-21  Jan Beulich  <jbeulich@suse.com>

	dwarf: constify read_leb128()'s first parameter
	It's not clear why the 2nd one is, but the 1st one isn't.

2026-01-21  Michal Sobon  <msobon@hex-rays.com>

	opcodes: Fix BMASKI disassembly for immediate 32 on M*Core
	The BMASKI instruction has three encoding variants (OMa, OMb, OMc).
	The OMa encoding (0x2C00, mask 0xFFF0) specifically represents
	BMASKI with immediate 32, encoded as IMM5=0.

	Per Motorola M*Core specification: "An IMM5 value of 0 is interpreted
	as a value of 32."

	Previously, all three variants extracted the immediate the same way,
	causing OMa to incorrectly display 0 instead of 32.

	Before: 0x2c04 -> bmaski r4, 0
	After:  0x2c04 -> bmaski r4, 32

	opcodes/
		* mcore-dis.c (print_insn_mcore): Handle OMa encoding to display
		immediate 32 instead of 0 for BMASKI.

	gas/testsuite/
		* gas/mcore/allinsn.s: Add test for bmaski with immediate 32.
		Replace two clrc padding instructions with one for 4-byte alignment.
		Fix missing newline at end of file.
		* gas/mcore/allinsn.d: Update expected output.

2026-01-21  Evgeny Karpov  <evgeny@kmaps.co>
	    Martin Vejbora  <mvejbora@microsoft.com>

	aarch64: Add bigobj support to AArch64 COFF
	During Boost library testing on aarch64-w64-mingw32, it appeared that 2^16
	sections are not enough. It can be handled by using the bigobj format to extend
	the total amount of sections to 2^32. This patch adds bigobj support to
	AArch64 COFF in a similar way to how it is done for x86_64.

2026-01-21  Jan Beulich  <jbeulich@suse.com>

	ld: testcase for .note.GNU-stack wanting to be SHT_NOTE
	If --noexecstack is removed and instead of empty.s a source file is used
	which explicitly creates a @progbits .note.GNU-stack, the test fails (for
	the absence of a NOTE segment).

2026-01-21  H.J. Lu  <hjl.tools@gmail.com>

	amend "ELF: give .note.GNU-stack proper section type"
	PR ld/33780
	Correct the section's special_sections[] entry as well, and further
	constrain ld's setting of the section type.

2026-01-21  Jan Beulich  <jbeulich@suse.com>

	readelf: don't (silently) fail on empty SHT_NOTE sections
	Them containing no entries is not an error. Such sections simply have
	nothing to dump. (Exiting with non-zero status but no error message isn't
	quite appropriate anyway.)

2026-01-21  Matthieu Longo  <matthieu.longo@arm.com>

	aarch64: silence GCS warnings on shared libraries for -z gcs=implicit
	Dynamic library incompatibilities should not be reported when no GCS
	option is provided (defaults to '-z gcs=implicit') and no explicit
	diagnostic is provided via '-z gcs-report-dynamic'.

	Binary Linux distributions do not rebuild all packages from scratch
	when rolling out a new feature or creating a new release; only
	modified packages get rebuilt. In the context of GCS deployment, this
	meant that some packages were rebuilt with GCS enabled while their
	dependencies were not yet GCS-compatible, resulting in warnings. These
	warnings caused build failures for packages that treat linker warnings
	as errors. Those errors slowed down the GCS deployment, and Linux
	distribution maintainers requested that no GCS option provided should
	be equivalent to '-z gcs=implicit -z gcs-report-dynamic=none'.

	In contrast, '-z gcs=always' should continue to report such issues by
	default. Warnings can still be disabled or promoted to errors by
	explicitly setting '-z gcs-report-dynamic' to respectively 'none' or
	'error'.

	This patch preserves the existing behaviour for '-z gcs=never', changes
	the default behaviour of '-z gcs=implicit' or no GCS option, and removed
	the inheritance mechanism between '-z gcs-report' and '-z gcs-report-dynamics'.
	The expected behaviour with the different possible combinations is as
	follows:
	* -z gcs=never:
	  No diagnostic messages are emitted.
	* -z gcs=implicit:
	  No diagnostic messages are emitted for input static objects.
	  However, if all the input static objects are marked for GCS, the
	  output object will also be marked for GCS.
	  In this case the output is marked with GCS, '-z gcs-report-dynamic'
	  defaults to 'none' and no diagnostics are emitted. Diagnostics can
	  be enabled by explicitly providing the option.
	* -z gcs=always:
	  Warning diagnostics for both static and dynamic input objects are
	  enabled by default. The two options are independent of one another,
	  and the diagnostic level can be adjusted for each by explicitly
	  providing the desired level to '-z gcs-report-dynamic' and '-z
	  gcs-report'.

	The patch also updates the existing tests, removes redundant test cases,
	and adds new tests covering cases with no report option provided, or
	report options explicitly set.

2026-01-21  Alan Modra  <amodra@gmail.com>

	s390 gas cfi-regnames test
	Fix failure on 32-bit s390-linux where addresses are shown with eight
	fewer leading zeros, and the CIE is smaller.

2026-01-21  Claudiu Zissulescu  <claudiu.zissulescu-ianculescu@oracle.com>

	sframe: Use UNRESOLVED instead of FAIL
	Fix for PR ld/33784.

	The SFrame test for PR ld/33401 is a two-step link test where the
	second link depends on the output of the first. In the first step, the
	linker process generates R_*_NONE relocs for .sframe section, while
	the second link process should pass without any issue.

	This patch reworks the PR ld/33401 test by removing the call to
	run_cc_link_tests, and use individual command invocation for
	compilation, assembling and linking. It introduces the UNRESOLVED
	status if the first step contains a linking or assembling error. The
	UNTESTED status is emitted if the first stage doesn't produce R_*_NONE
	relocs in .sframe section to test the original issue.

	ld/

		PR ld/33784
		* testsuite/ld-sframe/sframe.exp (check_pr33401): Rework the
		procedure for UNRESOLVED and UNTESTED cases.
		(check_dump): New procedure.
		* testsuite/ld-sframe/pr33401.rd: Add extra line at the end of the
		file.

2026-01-21  Claudiu Zissulescu  <claudiu.zissulescu-ianculescu@oracle.com>

	sframe: Add -nostdlib when testing PR 32789
	As a result of the mail exchange in
	https://sourceware.org/pipermail/binutils/2026-January/147439.html,
	the run_cc_link_test procedure may want to link standard libs
	too. However, this is not required for running PR 32789 tests. Add
	-nostdlib option.

	ld/

		* testsuite/ld-sframe/sframe.exp: Add nostdlib when testing PR
		32789.

2026-01-21  Alan Modra  <amodra@gmail.com>

	libsframe misaligned uint32_t
	I saw asan complaints about misaligned loads and stores when taking a
	quick look at pr33810 before Jens' patch was applied.  They have
	disappeared now, but it looks to me like a FRE can start on any
	address boundary and there is no padding or suchlike to align the
	FRE fields.

		* sframe.c (flip_fre_stack_offsets): Let the compiler know
		that integers may be misaligned.

2026-01-21  Alan Modra  <amodra@gmail.com>

	tidy hppa64 XPASSes
	Remove a bunch of xfails that now result in XPASS.

2026-01-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-20  Alan Modra  <amodra@gmail.com>

	vms-alpha store immediate repeated
	Speed up parsing of fuzzed object with ridiculous repeat counts,
	particularly when the object will later fail alpha_vms_object_p for
	some reason.

		* vms-alpha.c (image_write_section): New function, extracted..
		(image_write): ..from here.
		(_bfd_vms_slurp_etir <ETIR__C_STO_IMMR>): Optimise sizing.

2026-01-20  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: sframe: fix inaccurate function-level comment
	gas/
		* gen-sframe.c (sframe_xlate_do_register): Fix code comments.

	gas: sframe: add code comment for rep block size

2026-01-20  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: add unit_lists structure to index writer
	I think it makes the code more readable than the pair of vector.  Also,
	I'm considering adding a third list (foreigh type units), which will be
	easier with the structure.

	Change-Id: I38ec4ddf8f786a2ba10c5b371cfe04c2baaa7da9
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-20  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: rename some abbrev-related things in debug_names writer
	I think it would be clearer for some of these things to be called
	"abbrev", rather than "idx".

	Change-Id: Ic128a77dc7ce14a6179c049a2de21f3f9636405d
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-20  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: add comments to debug_names::build
	These help me follow what is going on, when following with the spec on
	the side.

	Change-Id: I0da0047eefd233e8f7635118d67622f07c29ce01
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-20  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: move DWP htab nullptr check to lookup_dwo_unit_in_dwp
	cutu_reader::lookup_dwo_cutu gets hold of the right htab for the kind of
	unit to look up (CU or TU), but then just uses the pointer to know if it
	should call lookup_dwo_unit_in_dwp or not.  lookup_dwo_unit_in_dwp then
	uses the same condition to obtain the correct htab.  I think it would
	make more sense to return early from lookup_dwo_unit_in_dwp instead, if
	the required htab does not exist.

	Change-Id: I6f8f96aba2452f8261b3c60667e72fb21b97c89d
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-20  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: merge one CU/TU code path
	Simplify the code by merging the paths for CUs and TUs.  It is also not
	necessary to check if the maps are empty.

	Change-Id: I43e2cf4bb1217a72dda8a03957ed733f87bf57b2
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-20  Andrew Burgess  <aburgess@redhat.com>

	gdb: fail for 'maint print frame-id LEVEL' of an invalid frame
	I noticed that 'maint print frame-id LEVEL' will always print a
	frame-id, just not always for LEVEL, for example:

	  (gdb) bt
	  #0  woof () at stack.c:4
	  #1  0x000000000040111f in bar () at stack.c:10
	  #2  0x000000000040112f in foo () at stack.c:16
	  #3  0x000000000040113f in main () at stack.c:22
	  (gdb) maintenance print frame-id 4
	  frame-id for frame #3: {stack=0x7fffffffa640,code=0x0000000000401131,!special}
	  (gdb)

	Notice that the request was for the frame-id of #4, which doesn't
	exist, but what I got was the frame-id for #3.

	Fix this by adding a check to maintenance_print_frame_id (frame.c), so
	the new behaviour is:

	  (gdb) maintenance print frame-id 4
	  No frame at level 4.
	  (gdb)

	This matches the behaviour of the 'frame' command:

	  (gdb) frame 4
	  No frame at level 4.
	  (gdb)

	I've added a new test to cover this case.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  John David Anglin  <danglin@gcc.gnu.org>

	hppa64: Improve relocation handling for local symbols and add gc_section support
	With this patch, gcc-16 can be built and there are significant
	improvements in test results.  I spent a lot of time trying to
	fix the EH exception support.  While there are still issues with
	handling relocations in linkonce sessions, exception handling
	mostly works if pc-relative and text relative encoding is used
	in .eh_frame.  The main problems are the HP-UX dynamic linker
	relocates the text and data segements indpendently, and it does
	not support unaligned dynamic relocations.

	Due to a configure bug in libstdc++-v3, the lack of gc_section
	support caused many test failures, so I added the gc_section
	support form elf32-hppa.c.

	I also move the HP_LOAD_MAP scratchpad to the end of the .bss
	section and fixed a number of issues with the linker scripts.

	2026-01-20  John David Anglin  <danglin@gcc.gnu.org>

	bfd/ChangeLog:

		* elf64-hppa.c (elf64_hppa_check_relocs): Drop NEED_PLT
		from R_PARISC_LTOFF_FPTR relocations.  Revise R_PARISC_FPTR64
		relocation to use maybe_dynamic.  Add support for
		R_PARISC_GNU_VTINHERIT and R_PARISC_GNU_VTENTRY relocations.
		Add code to handle dynamic relocations of local symbols.
		(elf64_hppa_gc_mark_hook): New.
		(ensure_undef_dynamic): New.
		(allocate_dynrel_entries): Revise checks to determine when
		to discard relocs.
		(elf64_hppa_late_size_sections): Revise allocation of local
		PLT, DLT and OPD entries.
		(elf64_hppa_finalize_opd): Remove assert.
		(elf64_hppa_finalize_dlt): Change type of dynindx to long.
		(elf64_hppa_finalize_dynreloc): Likewise.  Add check for
		discarded sections.  Correct handling of  R_PARISC_FPTR64
		relocation.  Remove assert.  Add new assert to check that
		we don't allocate more relocs in .rela.data than it can
		hold.
		(elf64_hppa_finish_dynamic_sections): Move allocation for
		DT_HP_LOAD_MAP to end of .bss section.  Only allocate on
		HP-UX.
		(elf_hppa_dlt_dynrel_reloc): Add dynrel_type argument.
		Change type of dynindx.  Drop use of value.  Remove assert.
		(elf_hppa_opd_dynrel_relocs): Rename to elf_hppa_opd_eplt_reloc.
		Drop code to to emit R_PARISC_FPTR64 relocation.
		(elf_hppa_opd_fptr_reloc): New.
		(elf_hppa_final_link_relocate): Add SYM arguement.  Move
		check for SEC_DEBUGGING.  Rework DLT, LTOFF, FPTR and DIR64
		relocation handling.
		(elf64_hppa_relocate_section): Add asserts to ensure symbol
		isn't undefined and input_section hasn't been discarded.
		(elf_backend_gc_mark_hook): Define.
		(elf_backend_can_gc_sections): Define.

	ld/ChangeLog:

		* emulparams/elf64hppa.sh (DATA_ADDR): Revise value to match
		HP-UX 11 value.
		(SHLIB_DATA_ADDR): Likewise.
		(NOP): Define.
		(OTHER_READONLY_SECTIONS): Add .data.rel, .HP.init, .preinit,
		.init and .fini sections to list.
		(__SYSTEM_ID_D, __TLS_SIZE_D, __FPU_REVISION, __FPU_MODEL,
		__CPU_REVISION, __CPU_KEYBITS_1, __LOAD_INFO, __ARGC, __ARGV,
		__ENVP, __libdl_jmp_tbl, __systab): Provide.
		(DATA_START_SYMBOLS, OTHER_SYMBOLS, INIT_START): Delete.
		(PREINIT_START, PREINIT_END, INIT_START): Define.
		emulparams/hppa64linux.sh (NOP): Define.
		(DATA_START_SYMBOLS): Delete.
		scripttempl/elf64hppa.sc: Delete .init and .fini sections
		from script.  Allocate 16 bytes at end of .bss for HP_LOAD_MAP.

2026-01-20  Tom Tromey  <tom@tromey.com>

	Move puts_tabular to obj-lang.c
	Only objc-lang.c uses puts_tabular.  This patch moves the function
	there and makes it 'static'.  It is also updated not to depend on the
	global (but private to utils.c) chars_printed, and not to call
	begin_line.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Use n_spaces in puts_tabular
	This changes puts_tabular to use n_spaces rather than alloca.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Remove right justification from puts_tabular
	No caller of puts_tabular uses the right-justified feature, so remove
	it.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Constify puts_tabular
	This changes puts_tabular to accept a 'const char *'.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Change is_import_fixup_symbol to return bool
	This changes the is_import_fixup_symbol in coffread.c to return bool
	rather than int.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Remove all globals from coffread.c
	This patch changes coffread.c to add a reader object type.  All
	globals are moved into this type, and the majority of functions in
	coffread.c are changed to be methods.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Remove coff_symfile_init
	coff_symfile_init is an empty function, and rather than give it a
	name, just use a lambda in coff_sym_fns.

	I've occasionally considered adding a do_nothing template function for
	all our empty function needs, but still haven't bothered.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Use coffread_objfile throughout coffread.c
	coffread.c:coff_symtab_read sets a global objfile while working.  It
	seemed nicer to me to hoist this so that it is set by the main entry
	point, and then used throughout the file.

	Normally I wouldn't encourage the use of globals, but shortly we'll be
	replacing these with an object.

	Note that while coff_symtab_read cleared coffread_objfile when it was
	finished, I haven't preserved this in the new patch.  First, this
	should have been done with a scoped_restore.  Second, this is the only
	global to get this treatment.  Third, it's not necessary at all.  And,
	finally, this will be moot anyway when the globals are removed.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Use symfile_bfd in more places
	Since coffread.c is setting symfile_bfd, it might as well use it
	everywhere.  This changes all other BFD references in coffread.c to
	use the global.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Remove redundant nlist_bfd_global
	coffread.c has two BFD globals: nlist_bfd_global and symfile_bfd.
	There's no need for both, and since symfile_bfd is set early (in
	coff_symfile_read, the entry point), this removes nlist_bfd_global and
	replaces all the uses.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Change coffread.c:pe_file to bool
	This changes coffread.c:pe_file to use bool.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Fix indentation in coffread.c
	A couple of spots in coffread.c were indented incorrectly.  This also
	fixes the placement of a comment in coff_symbol.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Clean up a comment in coffread.c
	This comment in coffread.c refers to some things that are no longer
	used.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tromey@adacore.com>

	Constify coffread.c:getsymname
	I noticed that the symbol name in coffread.c can be const.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Maciej W. Rozycki  <macro@redhat.com>

	BFD: Remove extraneous BFD struct member setup from `bfd_make_readable'
	Complementing commit 3097045a18a8 ("ld plugin bfd_make_readable leak")
	remove assignments to BFD struct members from `bfd_make_readable' that
	now duplicate ones unconditionally made by `_bfd_free_cached_info'
	called earlier on.

	BFD: Remove null pointer checks for `bfd_hash_table_free' calls
	Given that as from commit 90e5645309be ("libiberty: Make `objalloc_free'
	`free'-like WRT null pointer") `bfd_hash_table_free' now returns with no
	action taken when called for a hash table with no allocation present,
	remove null pointer checks guarding invocations.

2026-01-20  Jens Remus  <jremus@linux.ibm.com>

	s390: gas: Remove support for register names "ap" and "cc" in CFI directives
	The assembler erroneously converted the special register names "ap" and
	"cc" to the DWARF register numbers 32 and 33 respectively, which are
	actually assigned to the control registers c0 and c1 according to both
	the s390 32-bit (s390) ELF ABI [1] and s390 64-bit (s390x) ELF ABI [2].

	Register numbers 32 and 33 are used internally by GCC as "argument
	pointer" (ap) and "condition code" (cc).  Very early GCC versions leaked
	this out into DWARF.  However, those GCC-internal special register names
	should never be actually used in CFI, especially given their resulting
	DWARF register numbers have a different meaning in DWARF (CFI).

	[1]: s390 ELF ABI, section "DWARF definition",
	     https://refspecs.linuxbase.org/ELF/zSeries/lzsabi0_s390.html
	[2]: s390x ELF ABI, subsection "DWARF Register Numbers",
	     https://github.com/IBM/s390x-abi/releases

	gas/
		* config/tc-s390.c (tc_s390_regname_to_dw2regnum): Remove
		support for register names "ap" and "cc" in CFI directives.

	Suggested-by: Ulrich Weigand <ulrich.weigand@de.ibm.com>

2026-01-20  Jens Remus  <jremus@linux.ibm.com>

	s390: gas: Support access register names in CFI directives
	Convert access register (AR) names a0-a15 to DWARF register numbers when
	used in CFI directives.  Convert an access register number (0..15) to
	its corresponding DWARF register number (48..63) as specified in the
	s390 64-bit (s390x) ELF ABI [1] by adding 48.

	[1]: s390x ELF ABI, https://github.com/IBM/s390x-abi/releases

	gas/
		* config/tc-s390.c (tc_s390_regname_to_dw2regnum): Convert
		access register names (a0..a15) to DWARF register numbers.

	gas/testsuite/
		* gas/s390/cfi-regnames.d: Add test for AR names in in CFI
		directives.
		* gas/s390/cfi-regnames.s: Likewise.
		* gas/s390/cfi-regnames-err.l: Likewise.
		* gas/s390/cfi-regnames-err.s: Likewise.

2026-01-20  Jens Remus  <jremus@linux.ibm.com>

	s390: gas: Support vector register names in CFI directives
	Convert vector register names v0-v31 to DWARF register numbers when used
	in CFI directives.  Convert a vector register number (0..31) to its
	respective DWARF register number (16..31, 68..83) as specified in the
	s390 64-bit (s390x) ELF ABI [1] as follows:
	Right rotate the least significant three bits and add 16 for register
	numbers 0..15 or 68 for register numbers 16..31.

	Add a test case for the use of vector register (VR) names in CFI
	directives.

	[1]: s390x ELF ABI, https://github.com/IBM/s390x-abi/releases

	gas/
		* config/tc-s390.c (tc_s390_regname_to_dw2regnum): Convert
		vector register names (v0..v31) to DWARF register numbers.

	gas/testsuite/
		* gas/s390/cfi-regnames.d: Add test for VR names in in CFI
		directives.
		* gas/s390/cfi-regnames.s: Likewise.
		* gas/s390/cfi-regnames-err.l: Likewise.
		* gas/s390/cfi-regnames-err.s: Likewise.

2026-01-20  Jens Remus  <jremus@linux.ibm.com>

	s390: gas: Fix conversion of FP register names to DWARF register numbers
	The assembler supports register names in CFI directives.  For floating-
	point (FP) registers f0..f15 the register numbers 0..15 are erroneously
	converted to DWARF register numbers 16..31 by adding 16.  This is wrong
	as the s390 64-bit (s390x) ELF ABI [1] specifies the DWARF register
	numbers for the FP registers as follows:

	  DWARF               BINARY    BINARY DWARF
	  REGISTER  REGISTER  REGISTER  REGISTER
	  NUMBER    NAME      NUMBER    NUMBER
	  16        f0        0b0000 -> 0b10000
	  17        f2        0b0010 -> 0b10001
	  18        f4        0b0100 -> 0b10010
	  19        f6        0b0110 -> 0b10011
	  20        f1        0b0001 -> 0b10100
	  21        f3        0b0011 -> 0b10101
	  22        f5        0b0101 -> 0b10110
	  23        f7        0b0111 -> 0b10111
	  24        f8        0b1000 -> 0b11000
	  25        f10       0b1010 -> 0b11001
	  26        f12       0b1100 -> 0b11010
	  27        f14       0b1110 -> 0b11011
	  28        f9        0b1001 -> 0b11100
	  29        f11       0b1011 -> 0b11101
	  30        f13       0b1101 -> 0b11110
	  31        f15       0b1111 -> 0b11111

	Convert a FP register number (0..15) to its respective DWARF register
	number (16..31) as follows:
	Right rotate the least significant three bits and add 16.

	Add a test case for the use of general register (GR; r0..r15) and
	floating-point register (FPR; f0..f15) names in CFI directives.

	[1]: s390x ELF ABI, https://github.com/IBM/s390x-abi/releases

	gas/
		* config/tc-s390.c (tc_s390_regname_to_dw2regnum): Fix
		conversion of FP register names to DWARF register numbers.

	gas/testsuite/
		* gas/s390/s390.exp (cfi-regnames, cfi-regnames-err): Run new
		tests.
		* gas/s390/cfi-regnames.d: New test for GR and FPR names in CFI
		directives.
		* gas/s390/cfi-regnames.s: Likewise.
		* gas/s390/cfi-regnames-err.l: Likewise.
		* gas/s390/cfi-regnames-err.s: Likewise.

2026-01-20  Jens Remus  <jremus@linux.ibm.com>

	libsframe: use proper FRE type when flipping SFrame V3 FREs
	flip_sframe_fdes_with_fres_v3 was erroneously using a fixed FRE type
	of 0 (= SFRAME_FRE_TYPE_ADDR1) when endianness byte-flipping the FREs,
	regardless of the actual FRE type (i.e. ADDR1, ADDR2, or ADDR4).  This
	only affected cross builds, where the .sframe section data may needed
	to be endianness byte-flipped (e.g. binutils cross-built for s390
	64-bit (s390x) on x86-64).

	As a consequence objdump/readelf with option --sframe could fail to dump
	e.g. s390 64-bit (s390x) .sframe section data on x86-64 with the
	following error message:

	  Error: SFrame decode failure: Buffer does not contain SFrame data.

	The linker ld-sframe test "PR ld/33401 (Step 1: Create relocatable
	object and check R_*_NONE)" cross-build for s390 64-bit (s390x) on
	x86-64 could fail with ld error message:

	  error in tmpdir/StatePlaying.o(.sframe); no .sframe will be created

	The linker ld-sframe test "PR ld/33401 (Step 1: Create relocatable
	object and check R_*_NONE)" cros-build for s390 64-bit (s390x) on
	x86-64 could fail with BDF assertion:

	  BFD (GNU Binutils) ... assertion fail .../bfd/elf-sframe.c:153

	Add a common cfi-sframe assembler test, that forces a FDE type of
	SFRAME_FRE_TYPE_ADDR2.  When the test is run cross-build it may
	exercise the SFrame FDE and FDE endianness byte flipping.

	libsframe/
		PR ld/33810
		* sframe.c (sframe_decode_fde_attr_v3): Decode and return FRE
		type from FDE attributes.
		(flip_sframe_fdes_with_fres_v3): Use proper FRE type from
		FDE attributes when flipping FREs.

	gas/testsuite/
		PR ld/33810
		* gas/cfi-sframe/cfi-sframe.exp (cfi-sframe-common-pr33810): Run
		new test.
		* gas/cfi-sframe/cfi-sframe-common-pr33810.d: New test.
		* gas/cfi-sframe/cfi-sframe-common-pr33810.s: Likewise.

	Bug: https://sourceware.org/pr33810
	Fixes: 8ab6e4c72ab6 ("[SFrame-V3] include: gas: libsframe: split FDE into idx and attr")
	Reported-by: Alan Modra <amodra@gmail.com>

2026-01-20  Tom de Vries  <tdevries@suse.de>

	[gdb] Add regression test for PR symtab/33777
	PR symtab/33777 reports a problem where toplevel DIEs of partial units are
	read many times.

	The problem manifest as a timeout when building gdb with -O0 and Asan, and
	running test-case gdb.base/tls-dlobj.exp with glibc debuginfo installed.

	Reproduce the problem in a simpler and quicker way, without relying on glibc
	debuginfo:
	- build an executable with 100 partial units
	- run info line "$file:$line" a 100 times
	- add a line to "maint print statistics" that tells us how many time a
	  toplevel DIE is read.

	Without the fix we have:
	...
	   Number of read units: 1
	   Number of unread units: 108
	   Number of read top-level DIEs: 10118
	...
	and with the fix we have:
	...
	   Number of read units: 1
	   Number of unread units: 108
	   Number of read top-level DIEs: 218
	...

	Detect the problem by asserting:
	...
	gdb_assert { $top_level_die <= 3 * ( $read_cu + $unread_cu ) }
	...

	The factor 3 is used because for some target boards $top_level_die is slightly
	more than 2 * ( $read_cu + $unread_cu ).

	Tested on x86_64-linux.

2026-01-20  Tom Tromey  <tom@tromey.com>

	Remove "value chain" from symbol
	The "value chain" code in struct symbol is no longer used and so it
	can be removed.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Inline add_symbol_to_list
	add_symbol_to_list is just a simple wrapper for push_back, so we might
	as well inline it.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Remove "alias" hack from add_symbol_to_list
	add_symbol_to_list has this code:

	  /* If this is an alias for another symbol, don't add it.  */
	  if (symbol->linkage_name () && symbol->linkage_name ()[0] == '#')
	    return;

	This appears to be an old stabs hack.  In the stabs removal patch
	(commit eaea19f98d8) we see:

	-  /* '#' is a GNU C extension to allow one symbol to refer to another
	-     related symbol.
	-
	-     Generally this is used so that an alias can refer to its main
	-     symbol.  */

	This is a classic example of an old style problem that gdb had:
	sometimes hacks were added to the gdb core to work around problems in
	symbol readers -- IMO this kind of thing should have always been
	handled by the stabs reader itself, not add_symbol_to_list.

	Anyway, this is obsolete now and this patch removes it.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Remove buildsym_compunit::free_pending
	buildsym_compunit::free_pending is only called from a single spot in
	buildsym.c, so let's inline it and remove the method.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Remove buildsym_compunit::release_macros
	buildsym_compunit::release_macros is only called from a single spot in
	buildsym.c, so let's inline it and remove the method.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  Tom Tromey  <tom@tromey.com>

	Remove unused methods from buildsym_compunit
	A few methods of buildsym_compunit are now unused and can be removed.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-19  Tom de Vries  <tdevries@suse.de>

	[gdb/symtab] Handle zero opcode_base in line number program header
	I build gdb with TSAN, and with test-case gdb.dwarf2/malformed-line-header.exp
	ran into a heap-use-after-free:
	...
	(gdb) info line 1
	==================
	WARNING: ThreadSanitizer: heap-use-after-free (pid=897504)
	  Write of size 1 at 0x72040000d000 by main thread:
	    #0 dwarf_decode_line_header() gdb/dwarf2/line-header.c:356 (gdb+0xa0618c)
	  ...

	  Previous write of size 8 at 0x72040000d000 by main thread:
	    #0 operator delete[](void*) <null> (libtsan.so.2+0xa6128)
	    #1 std::enable_if<std::is_convertible<unsigned char (*) [], unsigned char (*) []>::value, void>::type std::default_delete<unsigned char []>::operator()<unsigned char>(unsigned char*) const /usr/include/c++/15/bits/unique_ptr.h:134 (gdb+0xa08479)
	    #2 std::unique_ptr<unsigned char [], std::default_delete<unsigned char []> >::~unique_ptr() /usr/include/c++/15/bits/unique_ptr.h:685 (gdb+0xa07324)
	    #3 line_header::~line_header() gdb/dwarf2/line-header.h:86 (gdb+0xa0914a)
	    #4 std::default_delete<line_header>::operator()(line_header*) const /usr/include/c++/15/bits/unique_ptr.h:93 (gdb+0xa091a4)
	    #5 std::unique_ptr<line_header, std::default_delete<line_header> >::~unique_ptr() /usr/include/c++/15/bits/unique_ptr.h:399 (gdb+0xa07f18)
	    #6 dw2_get_file_names_reader gdb/dwarf2/read.c:1839 (gdb+0xa648ee)
	 ...

	  Location is heap block of size 0 at 0x72040000d000 allocated by main thread:
	    #0 operator new[](unsigned long) <null> (libtsan.so.2+0xa6b01)
	    #1 dwarf_decode_line_header() gdb/dwarf2/line-header.c:354 (gdb+0xa06159)
	...

	This is caused by allocating a zero-sized array (lh->opcode_base == 0), and
	writing to it:
	...
	  lh->standard_opcode_lengths.reset (new unsigned char[lh->opcode_base]);

	  lh->standard_opcode_lengths[0] = 1;  /* This should never be used anyway.  */
	...

	Fix this by skipping this code if lh->opcode_base == 0.

	Tested on x86_64-linux.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-19  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: remove unused includes from read-gdb-index.c
	There are reported as unused by clangd.

	Change-Id: I0e08e5d0eb5eab0fe67099c8fb1f47c827bdea3d

2026-01-19  Nick Clifton  <nickc@redhat.com>

	Release the data on the matching_objstack once it is no longer needed.

2026-01-19  Matthieu Longo  <matthieu.longo@arm.com>

	bfd: move elf_new_obj_attr to the BFD public API

2026-01-19  Jan Beulich  <jbeulich@suse.com>

	x86: restrict recently added ifunc gas tests
	These will fail on Solaris and other non-GNU targets.

	PPC: permit %dm0 as insn operand
	When the DM registers were added, sorting of the table was broken. With
	the present arrangement, this leads to (only) %dm0 not being found by the
	binary search that both use sites of the table entertain.

2026-01-19  Jan Vrany  <jan.vrany@labware.com>

	gdb/testsuite: fix FAILs in fileio.exp
	I'm experiencing intermittent FAILs in fileio.exp when running on (my)
	CI:

	    FAIL: gdb.base/fileio.exp: Open a file
	    FAIL: gdb.base/fileio.exp: Creating already existing file returns EEXIST
	    FAIL: gdb.base/fileio.exp: Open for write but no write permission returns EACCES
	    FAIL: gdb.base/fileio.exp: Writing to a file
	    ...

	The problem turned out to be the way the OUTDIR gets defined in fileio.c.
	The path is passed down "naked" and turned into string by STRINGIFY macro.

	However, if the path happens to contain name of unrelated pre-existing
	C macro, this macro gets expanded during the "stringification", resulting
	in (likely) different path than used in fileio.exp and therefore causing
	failures.

	For example, if the GDB is compiled and tested in directory

	    /var/lib/jenkins/workspace/binutils-gdb/build/x86_64-linux-gnu

	then fileio.c is compiled with

	   -DOUTDIR_=/var/lib/jenkins/workspace/binutils-gdb/build/x86_64-linux-gnu/gdb/testsuite/outputs/gdb.base/fileio

	But because there's also C macro named "linux" defined to 1, the resulting
	OUTDIR is actually:

	   /var/lib/jenkins/workspace/binutils-gdb/build/x86_64-1-gnu/gdb/testsuite/outputs/gdb.base/fileio

	This commit fixes this by defining the OUTDIR as string literal in first
	place (similarly to how it was done prior commit cc91060) and updating
	quote_for_host to handle strings that themselves contains quote (").

	Tested on x86_64-linux by running all tests using quote_for_host with
	both target board unix and host/target board local-remote-host-native.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-19  Alan Modra  <amodra@gmail.com>

	asan: vms-alpha buffer overflow
		* vms-alpha.c (_bfd_vms_slurp_etir): Sanity check ETIR__C_STO_IMM
		size.  Use unsigned "size" to better catch ETIR__C_STO_IMMR errors.
		Make cmd_length unsigned too, and avoid pointer overflow in
		existing sanity check.

2026-01-19  Alan Modra  <amodra@gmail.com>

	asan: coff-alpha use of uninitialised value
	I think this is a false positive as the "use" is reported at a
	_bfd_link_reloc_status_error call, and the value passed is not used
	except when bfd_reloc_dangerous.  Avoid the warning anyway.

		* coff-alpha.c (alpha_ecoff_get_relocated_section_contents):
		Avoid false positive warning.

2026-01-19  David Guillen Fandos  <david@davidgf.net>

	MIPS/opcodes: Fix floor/round exclusions for R5900
	MIPS R5900 does not feature ceil/floor/round instructions, but only
	ceil is correctly excluded at the moment.  Correct the other two.

2026-01-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-18  Tom Tromey  <tom@tromey.com>

	Remove extraneous semicolon from inferior.h
	I noticed an extra ";" in inferior.h, this removes it.

2026-01-18  Tom Tromey  <tom@tromey.com>

	Fix multiple-successive-infcall.exp with gdbserver
	PR gdb/33791 points out that my recent change to emit the thread ID in
	the thread notification message broke multiple-successive-infcall.exp
	when run with gdbserver.  This patch fixes the oversight.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33791
	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-18  Eli Zaretskii  <eliz@gnu.org>

	gdb/
	   PR gdb/33761
	   * gdb/ui-style.c (colorsupport) [__MINGW32__]: MS-Windows always
	   supports at least 8 colors, even if the "Co" capability is not in
	   the terminfo DB.  This fixes "set style FOO foreground COLOR"
	   commands in the Windows native build of GDB.

2026-01-18  Alan Modra  <amodra@gmail.com>

	PR 33801 strip doesn't remove .gnu.lto_.opts
	OK, so people want to be able to partly destroy gcc slim LTO object
	files.  I don't see why not, despite HJ's policy-setting slim lto
	strip -R tests.  I also don't see why it matters that objcopy/strip
	won't similarly break LLVM objects (pr33271).

	So out goes the slim lto strip -R tests, and the strip-debug test
	expecting slim lto files won't be modified in any way.  strip-debug
	now removes a FILE symbol, which isn't unreasonable.

		PR 33801
		PR 33271
		PR 33246
	binutils/
		* objcopy.c (copy_archive, copy_file): Do not special case
		gcc LTO IR files.
	ld/
		* testsuite/ld-plugin/lto-binutils.exp: Remove slim lto strip -R
		tests.
		(run_pr33246_test): Don't compare slim object files after
		strip-debug.
		* testsuite/ld-plugin/strip-1a-s-all.nd: Delete.

2026-01-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-17  H.J. Lu  <hjl.tools@gmail.com>

	gas: Update PR gas/33744 tests
	Since .set directive doesn't work on alpha and hpux has a non-standard
	common directive, skip the relevant tests on alpha and hpux.  Also allow
	2, 4, 8 byte section alignment for 1-byte section since some targets
	have a minimum section alignment.

		PR gas/33744
		* testsuite/gas/elf/sh-link-abs-1.d: Skip alpha and allow 1, 2,
		4, 8 byte section alignment.
		* testsuite/gas/elf/sh-link-abs-2.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-3-32.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-3-64.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-4-32.d: Likewise
		* testsuite/gas/elf/sh-link-abs-4-64.d: Likewise
		* testsuite/gas/elf/sh-link-common-1.d: Skip hpux and allow 1,
		2, 4, 8 byte section alignment.
		* testsuite/gas/elf/sh-link-common-2.d: Likewise
		* testsuite/gas/elf/sh-link-common-3-32.d: Likewise
		* testsuite/gas/elf/sh-link-common-3-64.d: Likewise
		* testsuite/gas/elf/sh-link-common-4-32.d: Likewise
		* testsuite/gas/elf/sh-link-common-4-64.d: Likewise

2026-01-17  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/i386: remove i386_dbx_reg_to_regnum
	Following the removal of gdbarch_sdb_reg_to_regnum,
	i386_dbx_reg_to_regnum is only used by i386_svr4_dwarf_reg_to_regnum to
	handle SSE and MMX registers.  Remove it and inline the relevant bits in
	i386_svr4_dwarf_reg_to_regnum.

	Change-Id: Id74fad6ef6798c4cd061905f1c01eadd90e0a118
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2026-01-17  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb: remove gdbarch_sdb_reg_to_regnum
	Following the removal of the COFF debug info support,
	gdbarch_sdb_reg_to_regnum is no longer used, remove it.

	Change-Id: I2cb43465f1fdf74863edfa4dd00fd5f28a5a26bd
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2026-01-17  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb: remove stale comments about COFF / stabs
	These comments appear to be stale and no longer relevant.

	Change-Id: I3470969b0c0f38d809fe074ffab93ac91202de18
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2026-01-17  Tom de Vries  <tdevries@suse.de>

	[gdb/tdep] Fix gdb.base/siginfo.exp on s390x-linux
	On s390x-linux (SLES 15 SP5), I'm running into:
	...
	FAIL: gdb.base/siginfo.exp: backtrace for nexti (pattern 2)
	FAIL: gdb.base/siginfo.exp: step out of handler
	...

	The first FAIL is caused by a failure to unwind:
	...
	 (gdb) bt^M
	 #0  handler (sig=26, info=0x3ffffffe428, context=0x3ffffffe4a8) at \
	   gdb.base/siginfo.c:31^M
	 Backtrace stopped: Cannot access memory at address 0x1a00000088^M
	 (gdb)
	...

	In contrast, on x86_64-linux I get instead:
	...
	 (gdb) bt^M
	 #0  handler (sig=26, info=0x7fffffffc170, context=0x7fffffffc040) at \
	   gdb.base/siginfo.c:31^M
	 #1  <signal handler called>^M
	 #2  0x0000000000401201 in main () at gdb.base/siginfo.c:67^M
	 (gdb)
	...

	The memory access error is triggered here in s390_sigtramp_frame_unwind_cache:
	...
	  /* Restore the previous frame's SP.  */
	  prev_sp = read_memory_unsigned_integer (
				info->saved_regs[S390_SP_REGNUM].addr (),
	                        word_size, byte_order);
	...
	while trying to read an "Old-style RT frame" (for syscall sigreturn).

	The problem is that we actually have a "New-style RT frame" (for syscall
	rt_sigreturn).

	[ See linux kernel source file arch/s390/kernel/signal.c for a detailed
	explanation of the two. ]

	The choice between the two is made earlier in that same function:
	...
	  /* New-style RT frame:
		retcode + alignment (8 bytes)
		siginfo (128 bytes)
		ucontext (contains sigregs at offset 5 words).  */
	  if (next_ra == next_cfa)
	    {
	      ...
	    }

	  /* Old-style RT frame and all non-RT frames:
		old signal mask (8 bytes)
		pointer to sigregs.  */
	  else
	...

	I'm not sure why the check gives the wrong result, but I noticed that
	s390_sigtramp_frame_sniffer is able to distinguish between the two, so fix
	this by:
	- factoring out new function s390_sigtramp_p out of
	  s390_sigtramp_frame_sniffer, and
	- using s390_sigtramp_p in s390_sigtramp_frame_unwind_cache to distinguish
	  between the "Old-style RT frame" and "New-style RT frame".

	This fixes the backtrace.

	The second failure is:
	...
	(gdb) step^M
	32      } /* handler */^M
	1: x/i $pc^M
	=> 0x1000772 <handler+50>:      nopr^M
	(gdb) step^M
	0x000003fffdffe490 in __kernel_rt_sigreturn ()^M
	1: x/i $pc^M
	=> 0x3fffdffe490 <__kernel_rt_sigreturn>:       svc     173^M
	(gdb) FAIL: gdb.base/siginfo.exp: step out of handler
	...

	There is some code in process_event_stop_test that is supposed to trigger:
	...
	  if (ecs->event_thread->control.step_range_end != 1
	      && (ecs->event_thread->control.step_over_calls == STEP_OVER_UNDEBUGGABLE
		  || ecs->event_thread->control.step_over_calls == STEP_OVER_ALL)
	      && get_frame_type (frame) == SIGTRAMP_FRAME)
	    {
	      infrun_debug_printf ("stepped into signal trampoline");
	      /* The inferior, while doing a "step" or "next", has ended up in
		 a signal trampoline (either by a signal being delivered or by
		 the signal handler returning).  Just single-step until the
		 inferior leaves the trampoline (either by calling the handler
		 or returning).  */
	      keep_going (ecs);
	      return;
	    }
	...
	but it doesn't because frame is a NORMAL_FRAME instead of a SIGTRAMP_FRAME.

	This is caused by the "dwarf2" unwinder triggering, which has higher priority
	than the "s390 linux sigtramp" unwinder:
	...
	(gdb) maint info frame-unwinders
	Name                        Type                      Class     Enabled
	dummy                       DUMMY_FRAME               GDB       Y
	dwarf2 tailcall             TAILCALL_FRAME            DEBUGINFO Y
	inline                      INLINE_FRAME              GDB       Y
	jit                         NORMAL_FRAME              EXTENSION Y
	python                      NORMAL_FRAME              EXTENSION Y
	dwarf2                      NORMAL_FRAME              DEBUGINFO Y
	dwarf2 signal               SIGTRAMP_FRAME            DEBUGINFO Y
	s390 linux sigtramp         SIGTRAMP_FRAME            ARCH      Y
	s390 stub                   NORMAL_FRAME              ARCH      Y
	s390 prologue               NORMAL_FRAME              ARCH      Y
	...

	I found some code in dwarf2_frame_sniffer:
	...
	  /* On some targets, signal trampolines may have unwind information.
	     We need to recognize them so that we set the frame type
	     correctly.  */

	  if (fde->cie->signal_frame
	      || dwarf2_frame_signal_frame_p (get_frame_arch (this_frame),
					      this_frame))
	    return self->type () == SIGTRAMP_FRAME;
	...
	and an example implementation i386_linux_dwarf_signal_frame_p, and after
	copying this approach, indeed the stepping failure was fixed, but the
	backtrace broken again.

	Instead, fix this by giving the "s390 linux sigtramp" unwinder a higher
	priority:
	...
	(gdb) maint info frame-unwinders
	Name                        Type                      Class     Enabled
	dummy                       DUMMY_FRAME               GDB       Y
	dwarf2 tailcall             TAILCALL_FRAME            DEBUGINFO Y
	inline                      INLINE_FRAME              GDB       Y
	jit                         NORMAL_FRAME              EXTENSION Y
	python                      NORMAL_FRAME              EXTENSION Y
	s390 linux sigtramp         SIGTRAMP_FRAME            ARCH      Y
	dwarf2                      NORMAL_FRAME              DEBUGINFO Y
	dwarf2 signal               SIGTRAMP_FRAME            DEBUGINFO Y
	s390 stub                   NORMAL_FRAME              ARCH      Y
	s390 prologue               NORMAL_FRAME              ARCH      Y
	...

	Also fixes test-case gdb.base/sigaltstack.exp and gdb.base/sigbpt.exp.

	Tested on s390x-linux.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

	PR tdep/33708
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33708

2026-01-17  Alan Modra  <amodra@gmail.com>

	fix new arm and aarch64 gas test failures
	aarch64-pe  +FAIL: gas/aarch64/fix-adj
	arm-pe  +FAIL: MVE vmlas instructions
	arm-wince-pe  +FAIL: MVE vmlas instructions

	These new tests use ELF directives.

		* testsuite/gas/aarch64/fix-adj.d: Only run on ELF targets.
		* testsuite/gas/arm/mve-vmlas.d: Likewise.

2026-01-17  Alan Modra  <amodra@gmail.com>

	ld: put wild matching_sections on an obstack
	so that the memory can be reclaimed easily when reset_resolved_wilds
	throws it all away.

		* ldlang.c (matching_obstack): New static var.
		(add_matching_section): Rewrite to use matching_obstack.
		(lang_init): Init matching_obstack.
		(reset_resolved_wilds): Free matching_obstack.

2026-01-17  Alan Modra  <amodra@gmail.com>

	Make some ldlang functions inline
	These are small, and making them inline lets me call
	lang_statement_append without adding a forward declaration in the
	next patch.

		* ldlang.c (lang_for_each_statement, lang_list_init),
		(lang_statement_append): Move to..
		* ldlang.h: ..here making them inline functions.
		(bfd_input_just_syms): Group with other inlines.

2026-01-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-16  Richard Ball  <Richard.Ball@arm.com>

	aarch64: Add support for FEAT_MTETC
	This patch adds two new DC operations:

	   *gbva
	   *zgbva

2026-01-16  Richard Ball  <Richard.Ball@arm.com>

	aarch64: Add FEAT_SCR2 System registers
	This patch adds the system register "SCR2_EL3"
	Defined by FEAT_SCR2.

2026-01-16  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/hppa: replace bfd_map_over_sections with gdb_bfd_sections
	Replace bfd_map_over_sections with iteration over gdb_bfd_sections.

	Change-Id: I92ba6b5ef9e9ab3d2ebe364373aeaf459fd6e34c
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/windows: replace bfd_map_over_sections with gdb_bfd_sections
	Replace bfd_map_over_sections with iteration over gdb_bfd_sections.
	Change core_process_module_section's signature to take a cpms_data
	reference instead of a void pointer.

	Change-Id: Ic4f9a12c9c1479799ec87658fd88490106b61836
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/compile: replace bfd_map_over_sections with gdb_bfd_sections
	Replace bfd_map_over_sections with iteration over gdb_bfd_sections.
	Rename copy_sections to copy_section and change its signature to take
	explicit parameters instead of the callback-style void pointer.

	Change-Id: I30f1c3c051415722f2220b7fba48103101b640e8
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/mips-sde: replace bfd_map_over_sections with gdb_bfd_sections
	Replace bfd_map_over_sections with iteration over gdb_bfd_sections.

	Change-Id: If2e1141f2e9345fe50e2a63ce8f8682e82a60f21
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/mips: replace bfd_map_over_sections with gdb_bfd_sections (2)
	Replace bfd_map_over_sections with iteration over gdb_bfd_sections.

	Change-Id: I34182a67ee52da479c1868a5880709c401cbf34e
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/mips: replace bfd_map_over_sections with gdb_bfd_sections (1)
	Replace bfd_map_over_sections with iteration over gdb_bfd_sections.

	Change-Id: Ib236b364dc81f43cab8d27271d413eb61d6c703e
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Tom de Vries  <tdevries@suse.de>

	[gdb] Handle AT_HWCAP3/AT_HWCAP4 in default_print_auxv_entry
	On aarch64-linux, I run into:
	...
	(gdb) info auxv^M
	  ...
	26   AT_HWCAP2            Extension of AT_HWCAP          0x181^M
	29   ???                                                 0x0^M
	31   AT_EXECFN            File name of executable        0xffffffffffb9 ...
	  ...
	28   AT_RSEQ_ALIGN        rseq allocation alignment      32^M
	0    AT_NULL              End of vector                  0x0^M
	(gdb) WARNING: Unrecognized tag value: 29 ... ??? ... 0x0^M
	FAIL: gdb.base/auxv.exp: info auxv on live process
	...

	Fix this by handling AT_HWCAP3 in default_print_auxv_entry.  Likewise for
	AT_HWCAP4.

	Tested on aarch64-linux.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=32590

2026-01-16  Tom de Vries  <tdevries@suse.de>

	[include] Add AT_HWCAP3/AT_HWCAP4 in elf/common.h
	Since glibc 2.39, containing commit 3ab9b88 ("powerpc: Add HWCAP3/HWCAP4 data
	to TCB for Power Architecture."), glibc's elf/elf.h contains constants
	AT_HWCAP3/AT_HWCAP4.

	Add these in elf/common.h.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-16  Maximilian Bosch  <maximilian@mbosch.me>

	gdb/testsuite: add testcase for .debug_gdb_scripts being compressed
	This is a test-case to make sure that
	8eb1701823e46179e3adcb49abf57126b3c49f28
	("gdb: fix loading compressed scripts from `.debug_gdb_scripts`-section")
	doesn't regress.

	The test was mostly implemented by Tom Tromey, with the exception of the
	check to make sure that the sections are actually compressed and
	corrected compiler flags (-Wl,--compress-debug-sections=zlib-gabi was
	missing).

	This is an individual patch since the actual fix already landed in the
	repository.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/buildsym: patch_subfile_names
	This doesn't seem used anymore.

	Change-Id: I39e04f1f05fee3c6f7747923d5c1c2feef1fa315
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/buildsym: remove get_last_source_start_addr/set_last_source_start_addr methods
	Nothing seems to use this anymore.  However, the private field is still
	used internally by buildsym, so keep it.

	Change-Id: Ie6fbd96110a3c5603359a483855bbecc4008e5b4
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/buildsym: remove m_last_source_file
	Nothing seems to use this anymore.

	Change-Id: I6a767f2251ce9e683c231708466899a3e9ff4cb1
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb: remove buildsym-legacy
	With the removal of the COFF debug info support, nothing uses
	buildsym-legacy anymore, remove it.

	Change-Id: I46612509889b6868f5889a4347ad8d0a28d29127
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/coffread: remove debug info support
	This patch removes support for reading in the COFF debug info.

	I am not a specialist of the COFF format, but my understanding is that
	debug info in the COFF format consisted of extra symbol table entries
	describing the standard symbol table entries.  For instance, when
	compiling without debug info, a function would get a simple symbol
	entry, akin to an ELF symbol.  We would create a minimal symbol out of
	that.  When compiling with debug info, that symbol table entry would be
	followed by special additional entries, describing things like
	parameters and local variables (what would now be in DWARF).  We would
	create some full symbols out of that.

	This patch removes everything that reads this extra information, on the
	basis that any target still used today would not use it anymore, having
	switched to DWARF instead.  We still read the standard symbol table
	entries and create minimal symbols out of that.  This can be seen when
	loading a Windows executable (the only COFF executable kind I know how
	to produce):

	    $ ./gdb -nx -q --data-directory=data-directory -ex "set debug symtab-create 2" -ex "file a.exe"
	    ...
	    [symtab-create] record_full: recording minsym:  mst_file_bss                  0x140008018     6  argv
	    [symtab-create] record_full: recording minsym:  mst_file_bss                  0x140008008     6  managedapp
	    [symtab-create] record_full: recording minsym:  mst_text                      0x1400013e0     0  WinMainCRTStartup
	    [symtab-create] record_full: recording minsym:  mst_text                      0x140001400     0  mainCRTStartup
	    [symtab-create] record_full: recording minsym:  mst_text                      0x140001420     0  atexit
	    [symtab-create] record_full: recording minsym:  mst_file_data                 0x140005000     3  __EH_FRAME_BEGIN__
	    [symtab-create] record_full: recording minsym:  mst_file_bss                  0x140008060     6  obj
	    ...
	    [symtab-create] install: installing 299 minimal symbols of objfile /home/smarchi/src/binutils-gdb/gdb/a.exe

	I did not and can't easily test more than that.  At least, the remaining
	code is understandable enough that I think we would be able to fix any
	bug that comes up.

	This change should not alter the debugging experience on Windows.

	For more info on the COFF symbol table format:

	  https://www.delorie.com/djgpp/doc/coff/symtab.html

	Change-Id: I83220589b8e5b242a4ac42a842e504a4aa47aada
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/coffread: replace bfd_map_over_sections with iteration
	Replace two uses of bfd_map_over_sections with an iteration over
	gdb_bfd_sections.

	Re-use cs_to_bfd_section in cs_section_address to simplify it.

	Change-Id: I2b8f70cc1deba151b7b286affe78a43ac1a26375
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-16  Tom Tromey  <tromey@adacore.com>

	Use make_unique_xstrdup in tracepoint
	This changes the tracepoint code to use make_unique_xstrdup (and
	make_unique_xstrndup).  This meant changing the types of some members
	of uploaded_tp -- but it seems to me that using array types there did
	not add any value.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2026-01-16  Tom Tromey  <tromey@adacore.com>

	Use make_unique_xstrdup in more places
	This replaces a number of uses of 'ptr.reset (xstrdup ())'
	with 'ptr = make_unique_xstrdup ()'.

	The main motivation for this is that, IMO, it's better to avoid the
	reset method when possible.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2026-01-16  Richard Ball  <Richard.Ball@arm.com>

	aarch64: Add support for FEAT_CMH
	This patch adds the new instructions from FEAT_CMH
	These new instructions are hints, STCPH and SHUH.
	SHUH can have an operand PH or no operand.

2026-01-16  Richard Ball  <Richard.Ball@arm.com>

	arm: Fix MVE vmlas encoding
	Continuation of fix to VMLA

	Bit 12 of the first halfword in the VMLAS instruction is listed as (0)
	in the ARMARM (document DDI0553B.w, version ID07072023).
	This means that the instruction does not discriminate between signed
	and unsigned types and processing elements do not use the bit.
	The encoding used by gas was based on an older version
	of the document that made the sign important.
	This change makes it possible to use vmlas.i8 (16,32) in addition to
	vmlas.u8 and vmlas.s8 mnemonics, with the i8, i16 and i32 aliases becoming
	the default when disassembling.
	The generated encoding sets bit 12 to 0, compatibly with other
	assembler implementations.

2026-01-16  Richard Ball  <Richard.Ball@arm.com>

	aarch64: Add support for MLBI system instructions
	This patch adds support for MLB invalidate (MLBI) instruction.

	Syntax: MLBI <mlbi_op>{, <Xt>}

	This instruction is an alias to "SYS #4, C7, C0, #<op2>{, <Xt>}"
	and MLBI being the preferred disassembly.

	The following list of MLBI operations are supported in this patch for the
	MLBI instructions enabled by "+mpamv2"

	   * alle1
	   * vmalle1
	   * vpide1
	   * vpmge1

2026-01-16  Richard Ball  <Richard.Ball@arm.com>

	aarch64: Add FEAT_MPAMv2_VID system registers
	This patch adds the system registers defined by
	FEAT_MPAMv2_VID. These registers are:

	   *mpamvidcr_el2
	   *mpamvidsr_el2
	   *mpamvidsr_el3

2026-01-16  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Add FEAT_MPAMv2 system registers

2026-01-16  Jens Remus  <jremus@linux.ibm.com>

	s390: gas: sframe: do not reject .cfi_register REG_SP, REG
	On s390 64-bit (s390x) compilers may save the SP, FP, and RA registers,
	which are of interest in SFrame, in other registers, such as floating-
	point registers, for instance when in a leaf function.

	SFrame does not explicitly track the SP.  Instead SFrame relies on the
	architecture-specific CFA definition to recover the SP.  The s390x ELF
	ABI [1] defines the CFA as SP at call site + 160, which results in the
	implicit SP recovery rule SP = CFA - 160.

	Assuming that CFI on s390 64-bit (s390x) adheres to the CFA definition,
	it is safe to ignore any CFI directives, that specify the SP register at
	entry to be saved either on the stack or in another register, as the SP
	can then always be recovered using the implicit SP recovery rule.

	[1]: s390x ELF ABI, https://github.com/IBM/s390x-abi/releases

	Committed-by: Indu Bhagat <indu.bhagat@oracle.com>

	gas/
		* gen-sframe.c (sframe_xlate_do_register): Ignore .cfi_register SP
		on s390x.

	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp (cfi-sframe-s390x-err-4): Rename
		test to cfi-sframe-s390x-sp-register.
		* gas/cfi-sframe/cfi-sframe-s390x-err-4.d: Rename to ...
		* gas/cfi-sframe/cfi-sframe-s390x-err-4.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-sp-register.d: This.  Test
		that .cfi_register SP is ignored.
		* gas/cfi-sframe/cfi-sframe-s390x-sp-register.s: Likewise.  Add
		minimal assembler sample.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: testsuite: add new testcases for SFRAME_FDE_TYPE_FLEX
	This patch adds two new tests for SFrame V3 changes, focusing on the
	newly added flexible FDE TYPE SFRAME_FDE_TYPE_FLEX.

	Following tests are added:
	  - be-flipping-v3.c: Validates that big-endian SFrame V3 data is
	    correctly endian flipped when run on little-endian hosts.  It
	    verifies the decoding of CFA offsets and the new V3 register/offset
	    metadata bitfields using the SFRAME_V3_FLEX_FDE_OFFSET_REG_* macros.
	  - findfre-flex-1.c: Tests a variety of sframe_find_fre lookup
	    scenarios, apart from checking the basic encoder/decoder APIs.

	Documentation for the binary test data DATA-BE-V3 is provided in
	README-be-flipping-v3 to ensure reproducibility.

	libsframe/
		* Makefile.in: Regenerate.
		* testsuite/libsframe.decode/DATA-BE-V3: New test data.
		* testsuite/libsframe.decode/README-be-flipping-v3: New file.
		* testsuite/libsframe.decode/be-flipping-v3.c: New test.
		* testsuite/libsframe.decode/decode.exp: Run be-flipping-v3.
		* testsuite/libsframe.decode/local.mk: Add be-flipping-v3.
		* testsuite/libsframe.find/find.exp: Run findfre-flex-1.
		* testsuite/libsframe.find/findfre-flex-1.c: New test.
		* testsuite/libsframe.find/local.mk: Add findfre-flex-1.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>
	    Jens Remus  <jremus@linux.ibm.com>

	[SFrame-V3] sframe: s390: gas: testsuite: enable flex FDE for s390x
	This commit amalgamates a patch set proposed by Jens Remus to enable the
	SFrame Version 3 Flexible FDE Type (SFRAME_FDE_TYPE_FLEX) generation for
	the s390x ABI.

	Previously, s390x relied on architecture-specific encoding (shifting register
	numbers into offset fields) to represent register recovery rules.  This limited
	the complexity of CFI that could be supported.  With Flex FDE enabled:
	  - s390x can now represent .cfi_def_cfa using non-SP/FP registers.
	  - The architecture-specific function s390_sframe_xlate_do_register () in GAS
	    is replaced by the generic Flex FDE generation path.
	  - The SFrame V3 specific macros for s390x register encoding are removed
	    from libsframe/include, as the generic Flex FDE format handles explicit
	    register columns natively.

	The testsuite is updated to replace negative tests (which asserted
	warnings or empty SFrame generation for these patterns) with positive
	tests verifying valid Flex FDE generation.


	gas/
		* config/tc-s390.c (s390_support_flex_fde_p): Return true to
		enable Flex FDE generation.
		* gen-sframe.c (s390_sframe_xlate_do_register): Disable s390x
		specific implementation.
		(sframe_xlate_do_register): Invoke generic Flex FDE path now
		that flex FDE generation is supported.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-s390x-err-1.d: Removed.
		* gas/cfi-sframe/cfi-sframe-s390x-err-1.s: Moved to...
		* gas/cfi-sframe/cfi-sframe-s390x-non-spfp-cfa-1.s: ...here.
		* gas/cfi-sframe/cfi-sframe-s390x-err-2.d: Removed.
		* gas/cfi-sframe/cfi-sframe-s390x-err-2.s: Moved to...
		* gas/cfi-sframe/cfi-sframe-s390x-non-spfp-cfa-2.s: ...here.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-1.d: Update to
		expect Flex FDE output.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe.exp: Run renamed tests.
	include/
		* sframe.h (SFRAME_V3_S390X_OFFSET_IS_REGNUM): Remove.
		(SFRAME_V3_S390X_OFFSET_ENCODE_REGNUM): Remove.
		(SFRAME_V3_S390X_OFFSET_DECODE_REGNUM): Remove.
	libsframe/
		* sframe-dump.c (sframe_s390x_offset_regnum_p): Return false
		for SFrame V3.
		(sframe_s390x_offset_decode_regnum): Remove V3 support.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: doc: specification changes for SFrame version 3
	Update the SFrame specification to document Version 3. This version
	introduces fundamental changes to support additional scenarios (e.g.,
	s390x register-based recovery, x86_64 DRAP) using a 'Flexible FDE'
	definition while maintaining compactness for standard frames.

	Key changes documented include:
	  - The SFrame Function Descriptor Entry (FDE) is split into two
	    distinct structures:
	      [sframe_func_desc_idx] Fixed-size index for binary search.
	      [sframe_func_desc_attr] Variable-location attributes including new
	      info bytes.
	  - Flexible FDEs (SFRAME_FDE_TYPE_FLEX)
	    A new FDE type that interprets FRE bytes not as simple stack
	    offsets, but as pairs of "Control Data" and "Offset". This
	    allows encoding complex recovery rules (e.g., "CFA = *(RBP - 8)")
	    without bloating the format for standard cases.
	  - Provision for defining new FDE types in future.  A total of 5 bits
	    are reserved for this purpose.
	  - Make explicit distinction between FDE Types vs. PC Type
	      [FDE Type] Defines how to interpret stack trace data (Default vs. Flex).
	      [PC Type] Defines how PCs are advanced for an FDE (Increment vs. Mask).
	  - Other renames like sfde_func_start_address is renamed to
	    sfdi_func_start_offset to accurately reflect that it is a relative
	    offset, not an absolute address.
	  - Remove SFRAME_F_FRAME_POINTER from SFrame V3.  The corresponding bit
	    is now unused in SFrame V3.

	libsframe/doc/
		* sframe-spec.texi: Update text for SFrame Version 3.
		(Changes from Version 2 to Version 3): New section.
		(The SFrame FDE Index): New section documenting sframe_func_desc_idx.
		(The SFrame FDE Attribute): New section documenting
		sframe_func_desc_attr.
		(The SFrame FDE Info Bytes): Expanded to document sfda_func_info and
		sfda_func_info2 split.
		(The SFrame FDE PC Types): Document SFRAME_V3_FDE_PCTYPE_INC and
		SFRAME_V3_FDE_PCTYPE_MASK.
		(The SFrame FDE Types): Document SFRAME_FDE_TYPE_DEFAULT and
		SFRAME_FDE_TYPE_FLEX.
		(Interpretation of SFrame FREs): Split into Default and Flexible
		interpretation.
		(Flexible FDE Type Interpretation): Document the Control
		Data/Offset pair encoding.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] include: libsframe: remove SFRAME_F_FRAME_POINTER flag
	SFrame V3 has 8 precious flag bits, two of which are being used.  More
	flag byte (s) can be added to the auxiliary header when it comes to
	that.  But for now, it may be worthwhile to use the 8-bits frugally.

	SFRAME_F_FRAME_POINTER flag bit was added with the intention of marking
	binaries built with frame-pointer preserved.  A stack tracer could then
	use this information, to unambiguously ascertain whether frame-pointer
	based stack traces will be precise.  But such a marking of binary will
	ideally be done by the linker, and at the moment adding such a framework
	is not justified for such small gain.  The outcome of this is that
	SFRAME_F_FRAME_POINTER is never set in SFrame V2 binaries.

	Remove the definition SFRAME_F_FRAME_POINTER for SFrame V3.  The
	relinquished bit can be used (in future format incarnations) when
	reading/dumping SFrame V2 sections are no longer supported by consumers.
	Changing the values of existing flags, e.g.,
	SFRAME_F_FDE_FUNC_START_PCREL, is not being done for V3, to avoid
	version-specific flag bit reading (albeit doable) in consumers.

	Related changes to the specification are done in a subsequent commit.

	include/
		* sframe.h (SFRAME_V3_F_ALL_FLAGS): Remove
		SFRAME_F_FRAME_POINTER from the set of V3 flags.
	libsframe/
		* sframe-dump.c (dump_sframe_header_flags): Add a comment for
		clarity.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: binutils: ld: NEWS: add SFrame v3 related announcements
	Add NEWS entries related to the SFrame version 3 release.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] ld: testsuite: x86: sframe: check link of signal frame and outermost frames
	In this test, two "special" case FDEs are linked:
	  - Signal frame where the SFrame stack trace data is not
	    representable.
	  - _start like outermost frame function.

	This is useful test for sframe_encoder's merge input sections
	functionality and its associated write code-paths (sframe_encoder_write)
	too.

	ld/testsuite/
		* ld-x86-64/sframe-link-1.d: New test.
		* ld-x86-64/sframe-signal.s: New input file.
		* ld-x86-64/sframe-start.s: Likewise.
		* ld-x86-64/x86-64.exp: Add new test.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] ld: add --discard-sframe command line option
	Add a new command line option --discard-sframe to the linker.
	This option allows users to prevent the linker from generating an output
	.sframe section.

	The rationale for this option is: Consider the case when say, the distro
	is shipped with SFrame sections in the installed binaries/libraries. A
	user application using these installed libraries, but not enabling
	.sframe for itself just yet, will see an output .sframe corresponding to
	the pulled in libraries.  This is "partial" .sframe information for the
	application.  Adding such an option to the linker, gives user a way to
	turn off the .sframe section completely without relying on a linker
	script.

	Previously, the existing --no-ld-generated-unwind-info option
	controlled whether (not just .eh_frame for PLT entries, but also) SFrame
	for PLT entries. The new command line option,
	--discard-sframe now decouples SFrame from other unwind
	formats (like .eh_frame), allowing for more control over the output
	binary's SFrame data.

	The option is added for architectures that currently support SFrame:
	AArch64, s390x, and x86_64.

	bfd/
		* elf-sframe.c (_bfd_elf_parse_sframe): Mark with SEC_EXCLUDE if
		--discard-sframe is in effect.
		* elf64-s390.c (elf_s390_create_dynamic_sections): Use
		discard_sframe to guard .sframe section creation.
		* elfxx-x86.c (_bfd_x86_elf_link_setup_gnu_properties): Likewise.
	include/
		* bfdlink.h (struct bfd_link_info): Add discard_sframe bitfield.
	ld/
		* ldlex.h (enum option_values): Add OPTION_NO_LD_SFRAME_INFO.
		* lexsup.c (elf_sframe_list_options): New function.
		(ld_list_options): Add sframe_info argument. Update callers.
		* ld.texi: Update documentation.
		* emulparams/sframe-info.sh: New file.
		* emultempl/aarch64elf.em: Add --discard-sframe option
		listing and handling.
		* emulparams/elf64_s390.sh: Likewise.
		* emulparams/elf_x86_64.sh: Likewise.
		* Makefile.am: Update to handle sframe-info.sh and new list options.
		* configure.ac: Handle SFRAME_INFO target variable.
		* Makefile.in: Regenerate.
		* configure: Regenerate.
	ld/testsuite/
		* ld-x86-64/x86-64.exp: New test.
		* ld-x86-64/sframe-command-line-1.d: New test.
		* ld-aarch64/aarch64-elf.exp: New test.
		* ld-s390/s390.exp: New test.
		* ld-x86-64/x86-64.exp: New test.
		* ld-aarch64/sframe-command-line-1.d: New test.
		* ld-s390/sframe-command-line-1.d: New test.
		* ld-x86-64/sframe-command-line-1.d: New test.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: doc: testsuite: add new command line option --gsframe-3
	This option will allow users to select emission of SFrame stack trace
	information as per the SFrame version 3 specification.  Currenly, SFrame
	version 3 is also the default.

	In future, as SFrame evolves, similar command line args may be added for
	future versions.

	gas/
		* as.c (enum gen_sframe_version): New definition.
		(parse_args): Add option processing for --gsframe-3.
		* as.h (enum gen_sframe_version): New declaration.
		* doc/as.texi: Document the new option.
		* gen-sframe.c (sframe_set_version): Use enum gen_sframe_version
		as version.
		(output_sframe): Likewise.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp: New test.
		* gas/cfi-sframe/cfi-sframe-common-1d.d: Test new command line
		option --gsframe-3.
		* gas/cfi-sframe/cfi-sframe-common-1d.s: Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] include: gas: libsframe: split FDE into idx and attr
	This patch introduces a structural change to the SFrame V3 format. It
	shifts the SFrame Function Descriptor Entry (FDE) (a physical entity in
	SFrame V2) into a conceptual one in SFrame V3, such that an FDE is now
	split into two distinct parts to optimize the binary search table and
	data organization:
	 - FDE Index (sframe_func_desc_idx_v3): This structure contains the
	   essential indexing information: the function start address offset,
	   function size in bytes, and the offset to the SFrame FDE
	   attribute/Frame Row Entries (FREs) area for the function.
	 - FDE Attributes (sframe_func_desc_attr_v3): The metadata regarding the
	   function (number and size of FREs, FDE type, and repetition block
	   size etc.) is moved to a new structure.

	On-Disk Layout: In V3, the "Attributes" are now stored immediately
	preceding the SFrame FREs for that function. The sfde_func_start_fre_off
	now points to the attr structure, and the actual FREs follow immediately
	after.  IOW, the "Attributes" are now moved to the FRE sub-section,
	located immediately preceding the FREs for the respective function.

	The above layout has the advantage that:
	  a) its cleaner with separation between the index elements vs other data
	  b) the index has better cache locality (by virtue of it being smaller
	     than the layout in SFrame V2).
	  c) As the format evolves, the guarantees of alignment for FDE index
	     are easier to maintain.  FDE attr, being in the SFrame FRE
	     sub-section, carry no guarantees of alignment.

	This had been previously suggested and communicated in an earlier
	discussion on binutils mailling list
	https://inbox.sourceware.org/binutils/29b1f7b0-61ea-410c-8aca-d5dd6115e668@oracle.com/

	The read/write paths in sframe.c are updated to account for this split.

	sframe_fde_tbl_init now requires access to the FRE buffer to populate
	the internal FDE table, as the attributes are no longer resident in the
	FDE section.

	flip_sframe is refactored into version-specific handlers (_v2 and _v3)
	because the endian-swapping logic now differs significantly. In V3, the
	iterator must jump from the FDE table to the FRE section to swap the
	attributes.

	Lastly, the two entities generating SFrame sections (GAS and GNU ld)
	both now must _not_ set the sfde_func_start_fre_off to zero, when the
	number of FREs is zero.  This is because now there will be some valid
	attr data at that location.

	Backward Compatibility: Due to the need to support readelf/objdump for
	SFrame V2 sections, the patch explicitly maintains V2 support via
	separate code paths (e.g., flip_sframe_fdes_with_fres_v2)

	Note about alignment: Now that the sframe_func_desc_idx_v3 is refactored
	out of the conceptual SFrame FDE, SFrame FDE index member elements are
	at aligned boundaries again.  The alignment property for SFrame FDE was
	broken from an ealier patch "[08/36] sframe: gas: libsframe: use
	uint16_t for num_fres of FDE" up until this one.

	include/
		* sframe.h (sframe_func_desc_entry_v3): Remove sfde_func_num_fres,
		sfde_func_info, sfde_func_info2, and sfde_func_rep_size.  Rename
		to sframe_func_desc_idx_v3.
		(sframe_func_desc_attr_v3): New SFrame FDE attribute structure.
	libsframe/
		* sframe.c (sframe_fde_tbl_init): Add argument for FRE buffer.
		Read attributes from the FRE section for V3.
		(flip_fde_desc): Rename from flip_fde. Check size against
		sframe_func_desc_entry_v3.
		(flip_fde_attr_v3): New function.
		(sframe_decode_fde_desc_v2): New function extracted from
		sframe_decode_fde.
		(sframe_decode_fde_desc_v3): New function.
		(sframe_decode_fde_attr_v3): New function.
		(flip_sframe_fdes_with_fres_v2): New function for V2 flipping.
		(flip_sframe_fdes_with_fres_v3): New function for V3 flipping.
		(flip_sframe): Dispatch to version-specific flip functions.
		(sframe_decode): Pass FRE buffer to sframe_fde_tbl_init.
		(sframe_decoder_get_offsetof_fde_start_addr): Adjust for subset
		of sframe_func_desc_entry_v3 restructured into
		sframe_func_desc_idx_v3.
		(sframe_encoder_get_offsetof_fde_start_addr): Likewise.
		(sframe_find_fre): Skip attribute size to find FREs in V3.
		(sframe_decoder_get_fre): Likewise.
		(sframe_decoder_get_fres_buf): Likewise.
		(sframe_encoder_add_fre): Add attribute size to byte count.
		(sframe_encoder_add_fres_buf): Read attributes from buffer.
		(sframe_encoder_write_fde): Write only FDE index fields.
		(sframe_encoder_write_func_attr): New function.
		(sframe_encoder_write_sframe): Write FDE attributes before FREs.
	gas/
		* gen-sframe.c (output_sframe_funcdesc): Do not reset
		sfde_func_start_fre_off to zero when zero num FREs.
		(output_sframe_func_desc_attr): New refactored out function.
		(output_sframe_internal): Invoke output_sframe_func_desc_attr.
	libsframe/testsuite/
		* libsframe.decode/DATA2: Regenerate data file.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] bfd: ld: sframe: avoid unnecessary decoding of SFrame FREs at link time
	At link time, in _bfd_elf_merge_section_sframe (), it suffices to bring
	over the all per-function stack trace metadata (all FREs) as a blob into
	the SFrame encoder object.  There is no need to "decode" each SFrame
	FRE, only to add them in a serial fashion.

	This is an optimization, and not directly related to any SFrame V3
	related changes to the specification.  This should also bring us a step
	closer to supporting SFrame for targets which use linker relaxations.
	Removing the need to decode the input FREs can allow the linker to
	simply use the available set of FREs from (relocated) contents.  To
	support targets using linker relaxations in SFrame, other changes in the
	SFrame parse functionality time may also be necessary, but this brings
	us just a step closer.

	Add two new APIs to accomplish this:
	 - sframe_decoder_get_fres_buf, and
	 - sframe_encoder_add_fres_buf

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Get all FRE data
		and add it all in bulk.
	libsframe/
		* libsframe.ver: Add new APIs.
		* sframe.c (sframe_buf_fre_entry_size): New internal API to get
		size of one SFrame FRE at the indicated buffer location, without
		fully "decoding" the SFrame FRE.
		(sframe_decoder_get_fres_buf): New definition.
		(sframe_encoder_add_fres_buf): New definition.
	include/
		* sframe-api.h (sframe_decoder_get_fres_buf): New declaration.
		(sframe_encoder_add_fres_buf): New declaration.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: testsuite: handle .cfi_offset for RA
	With the introduction of flex FDE type, handling .cfi_offset for
	RA needs adjustment.

	On architectures like x86_64, the return address (RA) is typically saved
	at a fixed offset from the CFA. Previous versions of the SFrame format
	assumed this fixed offset was invariant for the entire function on such
	architectures. Consequently, GAS would warn and suppress SFrame
	generation if it encountered a .cfi_offset directive for the RA
	register that deviated from this fixed default.

	SFrame V3 introduces "Flex FDEs" which allows tracking the RA location
	explicitly even on architectures where it is usually fixed.

	This patch updates sframe_xlate_do_offset () to leverage Flex FDEs. When
	processing a .cfi_offset for the RA register:
	  - The check for non-representable RA offsets is relaxed. If the ABI
	    supports Flex FDEs (SFrame V3), GAS proceeds instead of issuing a
	    warning.
	  - For ABIs without explicit RA tracking (like AMD64), if the RA
	    offset differs from the default fixed offset, the FDE is marked as a
	    Flex FDE, and the new stack location is recorded.
	  - Logic is added to detect when the RA is restored to its standard
	    fixed offset. In this case, the tracking state is reset (ra_loc set
	    to SFRAME_FRE_ELEM_LOC_NONE), deferring to the ABI's default fixed RA
	    offset behavior.

	gas/
		* gen-sframe.c (sframe_xlate_do_offset): Support .cfi_offset for RA
		by switching to Flex FDEs when necessary.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-x86_64-6.d: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-6.s: New test to check
		transition of location of REG_RA from register to CFA-8 (default
		location on AMD64).  Flex FDE in effect.
		* gas/cfi-sframe/cfi-sframe.exp: Add new test.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: testsuite: skip SFrame FDE if .cfi_register SP, reg
	SFrame does not track the SP.  For recovery of the SP, SFrame relies on
	the architecture/ABI's CFA definition:

	  CFA = SP [+ offset   // on s390x]

	Which results in the following implicit CFA value offset rule for SP:

	  SP = CFA [- offset   // on s390x]

	Where offset is zero for most architectures/ABIs, except s390x.

	Therefore .cfi_register SP, reg directives must be rejected, as such
	semantics cannot be represented in SFrame yet.

	gas/
		* gas/gen-sframe.c (s390_sframe_xlate_do_register): Check for
		REG_SP and reject while generating a warning.
		(sframe_xlate_do_register): Likewise.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-s390x-err-4.d: New test.
		* gas/cfi-sframe/cfi-sframe-s390x-err-4.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-empty-5.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-empty-5.s: Likewise.
		* gas/cfi-sframe/cfi-sframe.exp: Add new tests.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: testsuite: handle .cfi_register FP/RA for flex FDE
	Use SFrame FDE of type SFRAME_FDE_TYPE_FLEX_TOPMOST_FRAME.

	When FP, RA were moved to a general-purpose register, the SFrame
	generation previously warned and skipped the FDE (except on s390x).
	This patch updates the translator to detect .cfi_register for RA (and
	FP), tracks the destination register in the SFrame row entry,
	and emits the register in the relevant FRE offsets in SFrame FDE type
	SFRAME_FDE_TYPE_FLEX.

	gas/
		* gen-sframe.c (sframe_row_entry_initialize): Propagate ra_reg
		and ra_deref_p.
		(sframe_xlate_do_register): Handle .cfi_register for RA/FP on
		AMD64 by setting flex_p and recording the register.
	gas/testsuite/gas/
		* cfi-sframe/cfi-sframe.exp: Run new test.
		* cfi-sframe/cfi-sframe-x86_64-5.d: New test.
		* cfi-sframe/cfi-sframe-x86_64-5.s: Simple test for checking
		FLEX FDE generation for `.cfi_register REG_RA, XX`.
		* cfi-sframe/cfi-sframe-x86_64-esc-expr-3.d: New test.
		* cfi-sframe/cfi-sframe-x86_64-esc-expr-3.s: New test with DWARF
		expression for REG_FP, followed by .cfi_register and .cfi_offset
		for REG_FP.
		* cfi-sframe/cfi-sframe-x86_64-ra-undefined-flex-1.d: New test.
		* cfi-sframe/cfi-sframe-x86_64-ra-undefined-flex-1.s: New test
		for FLEX FDE with undefined RA.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: x86: testsuite: add new testcases for SFRAME_FDE_TYPE_FLEX
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-x86_64-4.d: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-4.s: Non SP/FP based CFA.
		* gas/cfi-sframe/cfi-sframe-x86_64-esc-expr-1.d: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-esc-expr-1.s: DRAP pattern
		with both CFA expression and FP expression.
		* gas/cfi-sframe/cfi-sframe-x86_64-esc-expr-2.d: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-esc-expr-2.s: Test CFA
		expression with sleb128.
		* gas/cfi-sframe/cfi-sframe.exp: Add new tests.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: gas: translate specific CFI directives for SFRAME_FDE_TYPE_FLEX
	This patch updates the SFrame generation in GAS to translate specific
	.cfi_escape directives into the new SFrame V3 FDE type
	SFRAME_FDE_TYPE_FLEX.

	The primary goal is to support code patterns where:
	  - the Canonical Frame Address (CFA) is not defined by a simple offset
	    from the Stack Pointer (SP) or Frame Pointer (FP), or where the CFA
	    rule involves a dereference. Such patterns are generated by compilers
	    for stack realignment (e.g., DRAP on x86_64, or when mixing legacy
	    codes that keep 4-byte stack alignment with modern codes that keep
	    16-byte stack alignment for SSE compatibility).
	  - the Frame Pointer is not defined by a simple offset from the CFA,
	    but may even involve another register and/or dereferencing.
	  - the Return Address is not defined by a simple offset from the CFA,
	    but may even involve another register and/or dereferencing.

	Support for non-SP/FP based CFA: Update sframe_xlate_do_def_cfa () and
	sframe_xlate_do_def_cfa_register () to detect when a non-SP/FP register
	is used for the CFA.

	Support for CFA expressions: A vital part of supporting the
	above-mentioned cases on AMD64 is support for CFA expressions.  Add
	sframe_xlate_do_escape_cfa_expr () to parse simple
	DW_CFA_def_cfa_expression sequence in .cfi_escape.

	Support for FP expressions: Update sframe_xlate_do_escape_expr () to
	handle DW_CFA_expression involving DW_OP_breg6 (rbp) on AMD64,
	allowing for tracking of the Frame Pointer when it is saved with a
	dereference rule in the DRAP pattern.

	The "support" for both CFA expressions and FP expressions is quite
	minimal, and is tailored to the most commonly seen occurrences generated
	by GCC for AMD64.

	gas/
		* gas/gen-sframe.c (output_sframe_row_entry_offsets):
		(sframe_xlate_do_def_cfa): Handle non-SP/FP CFA registers by setting
		flex_p for AMD64.
		(sframe_xlate_do_def_cfa_register): Likewise.
		(sframe_xlate_escape_sleb128_to_int64): New definition.
		(sframe_xlate_do_escape_cfa_expr): New function to handle
		DW_CFA_def_cfa_expression of specific shapes.
		(sframe_xlate_do_escape_expr): Update to handle dereferenced FP rules.
		(sframe_xlate_do_cfi_escape): Invoke sframe_xlate_do_escape_cfa_expr ().
		(create_sframe_all): In case of error, but when signal frame is
		also true, there cannot be a flex FDE.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: add new backend hook sframe_support_flex_fde_p for FLEX FDEs
	For the newly added SFrame FDE type SFRAME_FDE_TYPE_FLEX, add a new
	backend hook so that the respective ABI/arch can opt out of the
	generation of SFRAME_FDE_TYPE_FLEX in GAS.

	AArch64 is an example of an ABI for which SFrame is supported, but one
	that does not need the flexible FDE representation for any of the
	current usecases currently.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	gas/
		* config/tc-aarch64.c (aarch64_support_flex_fde_p): New
		definition.
		* config/tc-aarch64.h (aarch64_support_flex_fde_p): New
		declaration.
		(sframe_support_flex_fde_p): Define.
		* config/tc-i386.c (x86_support_flex_fde_p): New definition.
		* config/tc-i386.h (x86_support_flex_fde_p): New declaration.
		(sframe_support_flex_fde_p): Define.
		* config/tc-s390.c (s390_support_flex_fde_p): New definition.
		* config/tc-s390.h (s390_support_flex_fde_p): New declaration.
		(sframe_support_flex_fde_p): Define.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: textual dump of fde type SFRAME_FDE_TYPE_FLEX
	Refactor the SFrame textual dumper in sframe-dump.c to properly handle
	the new FDE type.

	In SFrame V2, the textual dumper could afford to be oblivious to the
	exact DWARF register number for stack-pointer and frame-pointer
	registers in each ABI.  This is because a single bit was used to
	differentiate between the two (irrespective of the ABI), and the dumper
	could easily just use a:
	    const char *base_reg_str[] = {"fp", "sp"};
	to get the register name.

	With the introduction of new SFrame FDE type SFRAME_FDE_TYPE_FLEX, which
	carry DWARF register numbers if applicable, this needs to change.  E.g.,
	for some patterns on AMD64, one may see CFA is the value at 'r10+0'; or
	FP is the value at 'rbp+8'.  This means that for textual dump, we now
	need a mapping from:
	  - the ABI-specific frame-pointer to string "fp"
	  - the ABI-specific stack-pointer to string "sp"
	This is done via the SFRAME_ABI_REG_MAP helper macros and the new
	sframe_get_reg_name () API.

	For registers other than stack-pointer and frame-pointer, the SFrame
	textual dump does not print the register name (say, "rax"), but just the
	number (i.e., "r0").

	Check the func_info2 byte and dispatch the stack frame row entry (FRE)
	dumping to the correct function: either dump_sframe_func_fre_simple or
	dump_sframe_func_fre_flex.

	Ensure the display is consistent to previous semantics.  When flex FDE
	is in effect, there may not always be an RA offset (after the CFA
	offsets).  A padding offset for RA is present if FP offsets follow.  So
	if a padding offset for RA is seen, we will display "U".  If no RA
	offset is seen, however, we will display a "u" unless its an ABI where
	RA offset is fixed (in the latter case we display "f").

	libsframe/
		* sframe-dump.c (SFRAME_SP): Define mapping from stack-pointer
		register number to "sp".
		(SFRAME_FP): Define mapping from frame-pointer register number
		to "fp".
		(SFRAME_ABI_REG_MAP): Helper macro to define per-ABI-arch
		mappings.
		(sframe_get_reg_name): Helper API to get register name.
		(dump_sframe_func_with_fres): Refactor a bit...
		(dump_sframe_func_fre_simple): ..into this.
		(sframe_format_fre_disp): New definition.
		(dump_sframe_func_fre_flex): Likewise.
		(dump_sframe): Allow both SFrame version 2 and version 3.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: testsuite: add new argument to offset access APIs
	For FDE type SFRAME_FDE_TYPE_FLEX, the offsets are not only laid out
	differently, they also have different encoding:
	  - first data item is of unsigned type, it indicates the "Control Word"
	  - second data item is of signed  type, it indicates the "Offset Word"
	(The usage of "Word" above is colloquial, does not indicate a machine word of
	a specific size.)

	Adjust the APIs in libsframe to get stack frame offsets by adding a new
	argument type.  Also add a new API to read the data items as unsigned
	types of the specified size: sframe_get_fre_udata.

	At the moment, like the generation routines in GAS, the textual dump
	routines in sframe-dump.c are also unaware of the FDE type
	SFRAME_FDE_TYPE_FLEX.  In the next commits, these capabilities will be
	added.

	include/
		* sframe-api.h (MAX_NUM_STACK_OFFSETS): Increase the number of
		stack offsets to 6 to accommodate the FDE type
		SFRAME_FDE_TYPE_FLEX.
		(sframe_get_fre_udata): New declaration.
		(sframe_fre_get_cfa_offset): Add new arg.
		(sframe_fre_get_fp_offset): Likewise.
		(sframe_fre_get_ra_offset): Likewise.
	libsframe/
		* libsframe/sframe-dump.c (dump_sframe_func_with_fres): Pass
		SFRAME_FDE_TYPE_DEFAULT for FDE type.
		* sframe.c (sframe_fre_get_cfa_offset): Handle FDE type.
		(sframe_fre_get_fp_offset): Likewise.
		(sframe_fre_get_ra_offset): Likewise.
		* libsframe/libsframe.ver: Add new API sframe_get_fre_udata.
	libsframe/testsuite/
		* libsframe.find/findfre-1.c: Pass SFRAME_FDE_TYPE_DEFAULT for
		FDE type.
		* libsframe.find/findfunc-1.c: Likewise.
		* libsframe.find/plt-findfre-1.c: Likewise.
		* libsframe.find/plt-findfre-2.c: Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: output new FDE type SFRAME_FDE_TYPE_FLEX
	This patch updates the routines for emission of the new FDE type
	SFRAME_FDE_TYPE_FLEX in the SFrame output section.  The support for
	generating these flex FDEs themselves is added in a subsequent commit.

	Update struct sframe_row_entry to track additional state for CFA,
	FP, and RA.  Modify output_sframe_row_entry_offsets () to emit
	metadata/offset pairs for flexible FDEs or padding where applicable,
	ensuring the usual ordering (CFA, RA, FP).  The padding data, a.k.a.
	SFRAME_FRE_RA_OFFSET_INVALID is emitted in flexible FDEs when RA is
	untracked but FP offsets follow.  Trailing padding offsets should not
	occur.  Add a new function get_udata_size_in_bytes () to account for
	sizing of unsigned register metadata.

	gas/
		* gen-sframe.c (get_udata_size_in_bytes): Get size of unsigned
		int data in bytes.
		(get_fre_num_offsets): Handle SFRAME_FDE_TYPE_FLEX.
		(sframe_get_fre_offset_size): Account for register metadata
		in flexible FDEs.
		(output_sframe_row_entry_offsets): Add logic for flexible
		FDE offset pairs.
		(output_sframe_row_entry): Reset base register for flex FDEs.
		(output_sframe_funcdesc): Emit FDE type in func_info2.
		(sframe_xlate_ctx_init): Initialize flex_p.
		(sframe_xlate_ctx_finalize): Finalize flex_p status.
		(sframe_row_entry_initialize): Copy new deref tracking bits.
		(sframe_xlate_do_offset): Set deref bits during translation.
		* gen-sframe.h (struct sframe_row_entry): Add cfa_deref_p,
		fp_deref_p, and ra_deref_p.
		(struct sframe_func_entry): Add fde_flex_p.
		(struct sframe_xlate_ctx): Add flex_p.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: use three states for location tracking
	Up until now, for SFrame stack trace data generation (for default FDE
	type), keeping two states sufficed to distinguish between the following
	cases:
	  - the tracked entity is saved on a location on stack (identified by
	    SFRAME_FRE_ELEM_LOC_STACK)
	  - the tracked entity is in its designated register (identified by
	    SFRAME_FRE_ELEM_LOC_REG).

	Soon though, we will start to generate a new FDE type
	SFRAME_FDE_TYPE_FLEX, where in addition to above:
	  - the tracked entity may be saved in a temporary register
	  - the tracked entity may be saved at a "non-standard" location, e.g.,
	    not a simple CFA+offset based location
	  - and other cases

	To effectively distinguish between the various states (necessary to
	track for flex FDEs), define three states to track the location of each
	tracked entity:
	  - SFRAME_FRE_ELEM_LOC_NONE: the entity is in its desginated location
	    (e.g., in case of AMD64 where the RA is at fixed offset from CFA)
	  - SFRAME_FRE_ELEM_LOC_REG: the entity is in a location based off a
	    register
	  - SFRAME_FRE_ELEM_LOC_STACK: the entity is in a location based off the
	    CFA

	While at it, rather than asserting in sframe_xlate_do_offset (), reset
	the fp_reg state to SFRAME_FRE_REG_INVALID.  This is in preparation for
	upcoming flex FDE generation patches.

	Co-Authored-by: Jens Remus <jremus@linux.ibm.com>
	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	gas/
		* gen-sframe.c (sframe_xlate_do_offset): Reset other state.
		(sframe_xlate_do_same_value): Reset to SFRAME_FRE_ELEM_LOC_NONE.
		* gen-sframe.h (SFRAME_FRE_ELEM_LOC_REG): New definition.
		(SFRAME_FRE_ELEM_LOC_STACK): Likewise.
		(SFRAME_FRE_ELEM_LOC_NONE): Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: bfd: include: libsframe: fixup terminology 'PC Type' vs 'FDE Type'
	In SFrame V2, we did use the the term 'FDE Type' for the two designated
	'PC Type' for the SFrame FDEs (SFRAME_FDE_TYPE_PCINC,
	SFRAME_FDE_TYPE_PCMASK).  In hindsight, 'FDE Type' was an inappropriate
	term for the said intent.  Fix this terminology by defining two new
	constants:
	 - SFRAME_V3_FDE_PCTYPE_MASK
	 - SFRAME_V3_FDE_PCTYPE_INC

	The old constants from V2 (SFRAME_FDE_TYPE_PCINC,
	SFRAME_FDE_TYPE_PCMASK) remain, but are now unused in the codebase.

	The term 'FDE Type' should be used for the actual FDE Types.  In a
	subsequent commit, we will add SFRAME_FDE_TYPE_FLEX FDE Type for SFrame
	V3.

	bfd/
		* elf64-s390.c (_bfd_s390_elf_create_sframe_plt): Rename
		inappropriate SFRAME_FDE_TYPE_PCINC to SFRAME_V3_FDE_PCTYPE_INC.
		* elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Likewise.  Also
		rename inappropriate SFRAME_FDE_TYPE_PCMASK to
		SFRAME_V3_FDE_PCTYPE_MASK.
	gas/
		* gen-sframe.c (output_sframe_funcdesc): Likewise.
		* sframe-opt.c (sframe_convert_frag): Likewise.
	libsframe/
		* sframe-dump.c (dump_sframe_func_with_fres): Likewise.
		* sframe.c (sframe_fre_check_range_p): Likewise.
		(sframe_fde_create_func_info): Likewise.
	libsframe/testsuite/
		* libsframe.encode/encode-1.c: Likewise.
		* libsframe.find/findfre-1.c: Likewise.
		* libsframe.find/findfunc-1.c: Likewise.
		* libsframe.find/plt-findfre-1.c: Likewise.
		* libsframe.find/plt-findfre-2.c: Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] include: sframe: reserve 5 bits for new FDE types
	In SFrame V2, the FDE representation caters to the most common cases of
	stack trace metadata:
	  - CFA is SP/FP based,
	  - FP/RA offsets, if present are CFA based (except some cases in s390x
	    where reg can be encoded).

	Introduce an additional FDE type SFRAME_FDE_TYPE_FLEX, which can encode
	a more flexible set of CFA, FP and RA recovery rules.  Some of the
	patterns supported include:
	  - CFA may be non-SP/FP based.
	  - CFA, FP may encode dereferencing of register after offset adjustment
	  - RA may be in a non-default register.

	The important bit here is that since SFrame does not track all
	callee-saved registers, the above-mentioned recovery rules must only be
	done for topmost frames (by the stack tracer).

	Adding a new FDE type does have implications for a stack tracer in that
	it needs to:
	  - Check the FDE type before interpreting the variable length bytes
	    trailing the SFrame FRE header as stack offsets.
	  - If the FDE type is SFRAME_FDE_TYPE_FLEX, and the
	    recovery rules employ the use of any non-SP/FP based register, the
	    stack tracer must proceed only if it is the topmost frame on stack.

	For CFA, RA, and FP, up to two "offsets" may be used.  The two offsets
	represent the information as follows:
	  - (minimum 8-bit) offset1 to encode register like:
	    (regnum << 3) | unused << 2 | deref << 1 | reg_p (=1)
	  - offset2 to encode offset: offset

	reg_p = 1 indicates a register, reg_p = 0 indicates CFA.

	The offsets are in the usual order:  CFA, RA, FP if present.

	For example, for FP/RA tracking,

	a) If the reg is REG1 for FP/RA tracking,
	   - Encoding:
	     + offset1 to encode register: (REG1 << 3) | unused << 2 | deref << 1 | reg_p (=1)
	     + offset2 to encode offset: offset
	   - Action:
	     + if deref, FP/RA = \*(REG1 + offset) (e.g., seen for FP recovery
	       with certain DRAP patterns on x86_64)
	     + if no deref, FP/RA = REG1 + offset

	b) If the reg is CFA for FP/RA tracking,
	   - Encoding:
	     + [=Effectively Padding] offset1 to encode register:
	        (( 0 << 3 ) | unused << 2 | 0 << 1 | reg_p (=0))
	     + offset2 to encode offset: offset
	   - Action:
	     + if deref, FP/RA = *(CFA + offset)
	     + if no deref, FP/RA = CFA + offset (pattern shouldnt be seen for
	       RA)

	Next for CFA tracking,
	   - Action:
	     + if deref, CFA = *(reg + offset) (e.g., seen for CFA recovery in
	       some stack realignment patterns on AMD64)
	     + if no deref, CFA = reg + offset (e.g., for .cfi_def_cfa 2, 8, or
	       .cfi_def_cfa 10, 0)

	Expected usage of this FDE type is quite low (DRAP on x86_64).

	NB: In SFrame V2, we did use the the term 'FDE Type' for the two
	designated 'PC Type' for the SFrame FDEs (SFRAME_FDE_TYPE_PCINC,
	SFRAME_FDE_TYPE_PCMASK).  In hindsight, 'FDE Type' was inappropriate
	term.  In a subsequent commit, we will fix this terminology for SFrame
	V3.

	include/
		* sframe.h (SFRAME_FDE_TYPE_FLEX): New SFrame FDE type.
		(SFRAME_V3_FDE_TYPE_MASK): New constant definition.
		(SFRAME_V3_FDE_TYPE): New macro definition.
		(SFRAME_V3_SET_FDE_TYPE): Likewise.
		(SFRAME_V3_FLEX_FDE_REG_ENCODE): Macro to encode register in the
		SFrame offset data.
		(SFRAME_V3_FLEX_FDE_OFFSET_REG_NUM): New definition.
		(SFRAME_V3_FLEX_FDE_OFFSET_REG_DEREF_P): Likewise.
		(SFRAME_V3_FLEX_FDE_OFFSET_REG_P): Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] include: gas: libsframe: add 8-bits of func_info2 for extensibility in FDE
	The existing field func_info (in the SFrame FDE) is used to convey important
	information around the encoding and interpretation of the rest of the
	stack trace data for the respective SFrame FDE: the SFrame FRE type,
	SFrame FDE PC type, etc.

	Currently there is 1 bit left for AArch64, and 2 bits for AMD64, s390x
	(and other future ABIs to be supported).  Provision some additional
	space now (specifically an additional 8-bits) for future needs for V3
	and beyond.

	Compared to V2, this now increases the size of SFrame FDE by 1 byte in
	V3.  In this patch, the additional func_info2 byte is not used
	functionally yet.  Hence, rather mechanical changes in libsframe, bfd
	and libsframe/testsuite accompany.  We will put func_info2 into use in a
	later patch by reserving 5 of these bits for SFrame FDE types.

	With the addition of a new byte for additional func info (func_info2),
	add a new arg to allow usecases like textual dumper to get all data
	members in one API: sframe_decoder_get_funcdesc_v3.  To keep the APIs
	symmetric looking, add new arg to sframe_encoder_add_funcdesc_v3 too.

	Since bfd uses these APIs, carry out the mechanical change in the
	respective APIs too.  And of course, the testsuite which exercises these
	APIs.

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Get and set
		func_info2.
		* elf64-s390.c (_bfd_s390_elf_create_sframe_plt): Pass 0 for
		func_info2 for SFrame FDE for PLT.
		* elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Likewise.
	gas/
		* gen-sframe.c (output_sframe_funcdesc): Emit the uint8_t for
		func_info2.
	libsframe/
		* sframe-dump.c (dump_sframe_func_with_fres):
		* sframe.c (sframe_fde_tbl_init): Handle the new additional
		member.
		(sframe_encoder_write_fde): Likewise.
		* sframe.c (sframe_decoder_get_funcdesc_v3): Update func_info2.
	libsframe/testsuite/
		* libsframe.decode/DATA2: Update data file with SFrame section
		data.
		* libsframe.encode/encode-1.c: Pass 0 for func_info2 arg.
		* libsframe.find/findfre-1.c: Likewise.
		* libsframe.find/findfunc-1.c: Likewise.
		* libsframe.find/plt-findfre-1.c: Likewise.
		* libsframe.find/plt-findfre-2.c: Likewise.
	include/
		* sframe.h: Add new uint8_t sfde_func_info2 to
		sframe_func_desc_entry_v3.
		* sframe-api.h (sframe_decoder_get_funcdesc_v3): New arg.
		(sframe_encoder_add_funcdesc_v3): Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] gas: sframe: allow SFrame FDEs with 0 FREs for signal frames
	Update the SFrame generation logic in GAS to emit Function Descriptor Entries
	(FDEs) for signal frames even when no Frame Row Entries (FREs) could be
	generated.

	Previously, create_sframe_all () would discard any FDE that failed
	translation or resulted in zero FREs. However, for signal frames (marked
	with .cfi_signal_frame), preserving the FDE may be valuable even without
	stack offsets. The presence of the SFrame FDE with the 'Signal'
	attribute may allow stack tracers to identify the frame as a signal
	trampoline and potentially apply fallback handling, rather than treating
	the PC range as having no stack trace info at all.

	The patch modifies create_sframe_all () to detect translation errors for
	signal frames, effectively allowing the generation of an empty FDE (0 FREs)
	marked with the 'S' attribute.

	gas/
		* gen-sframe.c (sframe_fde_free): Add NULL check for safety.
		(create_sframe_all): Allow FDEs for signal frames even if translation
		encountered errors or produced no FREs.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-signal-1.d: New test ensuring
		signal frame FDE is emitted with 0 FREs.
		* gas/cfi-sframe/cfi-sframe-x86_64-signal-1.s: New test.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: gas: bfd: add support for signal frames
	Reserve a bit in function info byte in the SFrame FDE to designate
	signal frames.

	Also update the SFrame opt code in GAS and dumping routines in libsframe
	to handle signal frame bit.

	include/
		* sframe.h (SFRAME_V3_FDE_SIGNAL_P): Extract signal frame bit.
		(SFRAME_V3_FDE_UPDATE_SIGNAL_P): Set signal frame bit.
	gas/
		* gen-sframe.c (get_dw_fde_signal_p): New function to retrieve signal
		frame state from DWARF FDE.
		(sframe_v3_set_func_info): Renamed from sframe_v1_set_func_info.
		Accept signal_p argument and encode it.
		(sframe_set_version): Update ops to use sframe_v3_set_func_info.
		(sframe_set_func_info): Pass signal_p to the ops hook.
		(output_sframe_funcdesc): Retrieve signal frame marker and pass to
		sframe_set_func_info.
		* gen-sframe.h (struct sframe_version_ops): Update set_func_info
		signature.
		* sframe-opt.c (sframe_convert_frag): Preserve signal_p bit during
		fragment conversion.  While at it, use SFRAME_V3_* macros where
		applicable.
	libsframe/testsuite/
		* gas/cfi-sframe/cfi-sframe-common-13.d: New test.
		* gas/cfi-sframe/cfi-sframe-common-13.s: New test.
		* gas/cfi-sframe/cfi-sframe.exp: Run new test.
	libsframe/
		* sframe-dump.c (dump_sframe_func_with_fres): Decode signal frame bit
		and print "S" attribute in the dump output.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] include: libsframe: bfd: gas: testsuite: support for signed 64-bit offset in SFrame FDE
	This change enables support text > 2 GiB in SFrame format.

	Each SFrame FDE needs to hold information about the start PC of the
	function it pertains to.  Currently, the field 'sfde_func_start_address'
	in SFrame FDE is encoded as a 32-bit offset to the start PC of the
	function from the field itself.

	In SFrame V2, this offset was a signed 32-bit offset.  The signedness
	gives the flexibility of having .sframe ELF section before or after the
	.text* sections.  But the size of 32-bit puts the limitation that
	.sframe togther with the .text* sections must fit the 2 GiB range.

	Currently, if the linker sees the offset not representable as 32-bit
	signed offset, it issues an error (not seen in the wild, simulated by
	forcing a function to align via an '.align  2147483648' directive):

	  test.o:(.sframe+0x1c): relocation truncated to fit: R_X86_64_PC32 against `.text'
	  make: *** [Makefile:7: all] Error 1

	ATM, EH Frame also suffers with the same issue.

	Moving forward, some cloud applications have been shown to be nearing
	1.5 GiB threshold.  Extending the offset to int64_t now seems to be good
	choice to make now for future-proof'ing the sections.

	The use of int64_t offset is done for all SFrame V3 sections.  This
	bump from int32_t to int64_t should not lead to an increase in the size
	of SFrame sections, because of the following additional changes to the
	SFrame FDE specification:
	  - Reduce the type of sfde_func_num_fres (from uint32_t to uint16_t)
	  - Remove the 2 bytes of padding (sfde_func_padding2). These served the
	    two-fold purpose of keeping FDE data aligned _and_ unused space for
	    future needs.

	Now that the offset is int64_t, start using the
	sframe_decoder_get_funcdesc_v3 () instead of
	sframe_decoder_get_funcdesc_v2 () in GNU ld.

	This patch changes the offset type in the SFrame FDE definition to an
	int64_t.  No further changes in gas are necessary because the code
	already accounts for writing out as per the size of the member of the
	struct:

	  emit_expr (&exp, sizeof_member (sframe_func_desc_entry,
	                                  sfde_func_start_offset));

	bfd/
		* elf-sframe.c (sframe_read_value): Signed offset for start PC
		is 8-bytes now.
		(_bfd_elf_merge_section_sframe): Likewise.
		* elf64-s390.c (_bfd_s390_elf_create_sframe_plt): Use V3 API.
		(elf_s390_finish_dynamic_sections): Signed offset for start PC
		is 8-bytes now.
		* elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Use V3 API.
		(_bfd_x86_elf_finish_dynamic_sections): Signed offset for start
		PC is 8-bytes now.
	gas/
		* sframe.c (output_sframe_funcdesc): Rename to
		sfde_func_start_offset.
	libsframe/
		* libsframe/sframe.c (sframe_fde_tbl_init): Rename to
		sfde_func_start_offset.
		(flip_fde): Likewise.
		(sframe_decoder_get_secrel_func_start_addr): Use int64_t.
		(sframe_fre_check_range_p): Likewise.
		(sframe_decoder_get_offsetof_fde_start_addr): Rename to
		sfde_func_start_offset.
		(sframe_get_funcdesc_with_addr_internal): Use int64_t.
		(sframe_find_fre): Likewise.
		(sframe_encoder_get_offsetof_fde_start_addr): Rename to
		sfde_func_start_offset.
		(sframe_encoder_add_funcdesc_internal): Use int64_t.
		(sframe_encoder_add_funcdesc): Likewise.  And rename to
		sfde_func_start_offset.
		(sframe_encoder_write_fde): Rename to sfde_func_start_offset.
	libsframe/testsuite/
		* libsframe.decode/DATA2: Regenerate the data file.
		* libsframe.encode/encode-1.c: Use int64_t for start pc offset.
		* libsframe.find/findfre-1.c: Likewise.
		* libsframe.find/findfunc-1.c: Likewise.
		* libsframe.find/plt-findfre-1.c: Likewise.
		* libsframe.find/plt-findfre-2.c: Likewise.
	include/
		* sframe-api.h (sframe_find_fre): Update arg type to int64_t.
		(sframe_encoder_add_funcdesc): Likewise.
		* sframe.h: Change data type to int64_t.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: gas: libsframe: remove padding field from FDE
	Remove the unused sfde_func_padding2 member from the
	sframe_func_desc_entry_v3 structure.

	A later patch in this series reorganizes the members of the FDE
	structure in a way explicit padding is no longer necessary to keep
	natural alignment.  So remove the explicit padding now.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	include/
		* sframe.h: Remove sfde_func_padding2 from
		sframe_func_desc_entry_v3.
	gas/
		* gen-sframe.c (output_sframe_funcdesc): Stop writing
		sfde_func_padding2.
	libsframe/
		* sframe.c (sframe_encoder_write_fde): Stop writing
		sfde_func_padding2.
		* testsuite/libsframe.decode/DATA2: Regenerate binary test data.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: gas: libsframe: use uint16_t for num_fres of FDE
	Reduce the size of the num_fres field in the Function Descriptor Entry
	(FDE) from 32 bits to 16 bits.

	The number of Frame Row Entries (FREs) for a single function is extremely
	unlikely to exceed 65,535 in real-world scenarios. Reducing this field
	saves 2 bytes per FDE, contributing to a smaller overall SFrame section size.

	(BTW, these savings will be eaten up by a later commit which adds
	support for text > 2 GiB by increasing an offset from int32_t to
	int64_t).

	Safety checks are added to the assembler to warn and skip SFrame FDE
	generation if a function's FRE count exceeds UINT16_MAX.

	Note regarding alignment: With the current patch, the members of
	sframe_func_desc_entry_v3 are not at aligned boundaries anymore.  Recall
	that all sframe_func_desc_entry_v3 entries are stored together in the
	"SFrame FDE sub-section" forming an index.  Only after a later patch in
	the series "[29/36] [SFrame-V3] include: gas: libsframe: split FDE into
	desc and attr" will the alignment properties of SFrame index will be
	restored.

	include/
		* sframe.h (sframe_func_desc_entry_v3): Change sfde_func_num_fres
		type to uint16_t.
	gas/
		* gen-sframe.c (output_sframe_funcdesc): Write 2 bytes for num_fres
		and assert it fits in uint16_t.
		(sframe_do_fde): Add check to skip FDE emission if num_fres exceeds
		UINT16_MAX.
	libsframe/
		* sframe.c (sframe_encoder_write_fde): Cast num_fres to uint16_t
		to ensure correctly written out data.
		* testsuite/libsframe.decode/DATA2: Update binary test data.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: add V3 APIs for adding and getting SFrame FDE
	(Similar to V2) Add two new APIs for adding and getting SFrame FDE:
	 - sframe_encoder_add_funcdesc_v3
	 - sframe_decoder_get_funcdesc_v3

	Note the argument for the function start address is int64_t instead of
	int32_t (the latter is used in sframe_encoder_add_funcdesc_v2 and
	sframe_encoder_get_funcdesc_v2).  The new V3 APIs will be used in a
	subsequent commit to extend SFrame V3 to support text > 2 GiB by
	allowing int64_t offsets by default.

	Similar to the analogous V2 APIs, they return 0 on success and
	SFRAME_ERR (in case of sframe_decoder_get_funcdesc_v3) or error code (in
	case of sframe_encoder_add_funcdesc_v3) on failure.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	include/
		* sframe-api.h (sframe_decoder_get_funcdesc_v3): New
		declaration.
		(sframe_encoder_add_funcdesc_v3): Likewise.
	libsframe/
		* libsframe.ver: Add the new APIs.
		* sframe.c (sframe_decoder_get_funcdesc_v3): New definition.
		(sframe_encoder_add_funcdesc_v3): Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: bump so version to libsframe.so.3.0.0
	Consolidate the 2.0 and 2.1 nodes into a new 3.0 node.

	In subsequent patches for releasing SFrame V3, libsframe APIs will be
	affected.  A non-exhaustive list of noteworthy changes are mentioned
	next.

	Some existing APIs (breaking binary compatibility) by adding an
	additional arg to these:
	  - sframe_fre_get_ra_offset
	  - sframe_fre_get_fp_offset
	  - sframe_fre_get_cfa_offset

	Change of argument type:
	  - sframe_find_fre

	The behaviour of some APIs will change:
	 - sframe_encoder_write now writes out V3.

	And lastly removal of two APIs:
	  - sframe_decoder_get_funcdesc
	  - sframe_encoder_add_funcdesc

	Above make this release of the library binary incompatible with previous
	release, hence a version bump and new version node 3.0.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	libsframe/
		* libsframe.ver: Create a new 3.0 node.  Remove the 2.0 node.
		* libtool-version: Bump the so version.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: gas: bfd: ld: format bump to version 3
	Bump version to SFRAME_VERSION_3.  Introduce a new definition of SFrame
	FDE for version 3, which is a duplicate of SFrame FDE in V2, for now.
	In other words, no changes to the format specification yet.

	GNU as emits SFrame V3 by default.  SFrame encoder (ld) emits SFrame V3
	sections.  In a later commit, we will add a new command line option to
	gas: --gsframe-3 which will bind the implementation in gas to emit
	SFrame V3.

	Also, adjust the testcases for the new version string
	"SFRAME_VERSION_3".

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Linker emits
		the latest version by default.
		* elf64-s390.c (_bfd_s390_elf_create_sframe_plt): Linker emitted
		PLT sections are also SFRAME_VERSION_3.
		* elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Likewise.
	gas/
		* gen-sframe.c (sframe_set_version): GAS emits SFrame V3 by
		default.
		(output_sframe): Likewise.
	libsframe/
		* sframe-dump.c (dump_sframe): Enable dumping for both
		SFRAME_VERSION_2 and SFRAME_VERSION_3.
	include/ChangeLog:
		* sframe.h (SFRAME_VERSION_3): New definition.
		(SFRAME_VERSION): Current version is now SFRAME_VERSION_3.
		(SFRAME_V3_FDE_FUNC_INFO): New definition.
		(SFRAME_V3_FDE_FRE_TYPE): Likewise.
		(SFRAME_V3_FDE_PC_TYPE): Likewise.
		(SFRAME_V3_AARCH64_FDE_PAUTH_KEY): Likewise.
		(SFRAME_V3_FDE_UPDATE_PAUTH_KEY): Likewise.
	binutils/testsuite/
		* all affected tests: Replace SFRAME_VERSION_2 with
		SFRAME_VERSION_3.
	gas/testsuite/
		* all affected tests: Likewise.
	ld/testsuite/
		* all affected tests: Likewise.
	libsframe/testsuite/
		* all affected tests: Likewise.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] sframe: use const for sframe_decoder_ctx object arg
	As the library version will be bumped soon, include this change now.
	Note the arg names in sframe-dump.c APIs have 'sfd_ctx' instead of the
	usual 'dctx'.  We can address this cosmetic change at a later time.
	Other cosmetic changes, e.g. to make fixing function-level comments more
	consistent, are left out of the patch for now.

	Additionally, constify the return type of static function
	sframe_decoder_get_header, now that the call sites consistently use a
	const object.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: remove old sframe_decoder_get_funcdesc API
	sframe_decoder_get_funcdesc () was added for SFRAME_VERSION_1.  This has
	since been obsoleted by introduction of SFRAME_VERSION_2 and its
	corresponding sframe_decoder_get_funcdesc_v2 API.

	Remove from the version script file as well.  We will bump the version
	of the library to 3.0.0 in a subsequent patch (closer to release) and
	consolidate the entries into a new LIBSFRAME_3.0 node.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	include/
		* sframe-api.h (sframe_decoder_get_funcdesc): Remove.
	libsframe/
		* libsframe.ver: Likewise.
		* sframe.c (sframe_decoder_get_funcdesc): Remove definition.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] libsframe: testsuite: add a new test for SFrame V2
	The existing frecnt-2.c testcase reads the SFrame section from the
	provided DATA2 buffer.  It exercises the sframe_decode (),
	sframe_decoder_get_num_fidx (), and sframe_decoder_get_funcdesc_v2 ()
	APIs.  Currently DATA2 file is the SFrame section created from the test
	input (mentioned in the comments in the file) in SFrame version 2
	format.

	Moving forward, creating SFrame V2 section via GNU assembler and GNU ld
	will not be supported.  But textual dump of SFrame V2 sections via
	readelf/objdump will need to be supported.  Add a test similar to
	frecnt-2.c using SFrame version 2 binary data to the libsframe
	testsuite.  Such a test will help ensure that sframe_decode () and
	related APIs remain tested for multiple supported arches till the
	support for dumping V2 sections is to be maintained.

	Duplicate frecnt-2.c to create a frecnt-v2.c, the latter will test with
	a SFrame V2 input section always.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>

	libsframe/
		* Makefile.in: Regenerated.
	libsframe/testsuite/
		* libsframe.decode/decode.exp: Add new test.
		* libsframe.decode/local.mk: Likewise
		* libsframe.decode/DATA-V2: New SFrame V2 test data file.
		* libsframe.decode/frecnt-v2.c: New test.

2026-01-16  Indu Bhagat  <indu.bhagat@oracle.com>

	[SFrame-V3] readelf: testsuite: sframe: add new SFrame V2 test
	In subsequent commits, we will add support for SFrame V3.  In the next
	GNU Binutils release, GNU as and ld will only generate SFrame V3; SFrame
	V2 will not be supported for generation nor linking.

	For readelf/objdump, however, continue to support textual dump of SFrame
	V2 sections.  Add a binary file (with no debug data) with SFrame V2
	section to keep the dumping tested.

	Add ET_REL And ET_EXEC binary file based tests for x86_64 and s390x.
	Check that both readelf and objdump works on the SFrame V2 sections.

	binutils/testsuite/
		* binutils-all/s390/README-sframe-tests: New test.
		* binutils-all/s390/sframe.exp: New test.
		* binutils-all/s390/test-v2-ET_EXEC.sframe.bz2: New test.
		* binutils-all/s390/test-v2-ET_EXEC.sframe.dump: New test.
		* binutils-all/s390/test-v2-ET_REL.sframe.bz2: New test.
		* binutils-all/s390/test-v2-ET_REL.sframe.dump: New test.
		* binutils-all/x86-64/README-sframe-tests: New test.
		* binutils-all/x86-64/sframe.exp: New test.
		* binutils-all/x86-64/test-v2-ET_EXEC.sframe.bz2: New test.
		* binutils-all/x86-64/test-v2-ET_EXEC.sframe.dump: New test.
		* binutils-all/x86-64/test-v2-ET_REL.sframe.bz2: New test.
		* binutils-all/x86-64/test-v2-ET_REL.sframe.dump: New test.

2026-01-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-15  Simon Marchi  <simon.marchi@efficios.com>

	gdb/NEWS: mention DWP v1 support removal
	Support for DWP v1 was removed in commit 92a222b648d ("gdb/dwarf: remove
	support for DWP v1").

	Change-Id: I6ce341bb6a2238b434fb458b3e2aa81db74cd8ae
	Approved-By: Eli Zaretskii <eliz@gnu.org>

2026-01-15  Simon Marchi  <simon.marchi@efficios.com>

	gdb/NEWS: add missing newline
	Change-Id: Ib3714d1b75d42580460f5e4183d7801314aa4b9a

2026-01-15  Tom Tromey  <tom@tromey.com>

	Apply [noreturn] in more places
	I looked at adding -Wmissing-noreturn to the warning flags.  This
	resulted in too many false reports, IMO, so I am not planning to
	submit it.

	However, it did point out a few spots that legitimately should have
	[[noreturn]].

	In making this patch, my criterion was to mark up a function whose
	contract is that it always throws an exception.  I did not include
	functions that just happen to always throw (e.g.,
	default_infcall_mmap).  That is, this patch uses the attribute as a
	form of documentation and not really for its code-generation
	application.

	Tested by rebuilding.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2026-01-15  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: fix mis-indented lines in dwarf2/read.c
	Change-Id: I4070a60531d396237afa298bbaf6482004f3ab39

2026-01-15  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb, gdbsupport, gdbserver: add support for printf 't' length modifier
	Tom de Vries reported [1] that a use of the `t` printf length modifier
	(used for ptrdiff_t) breaks "set debug dwarf-die 1":

	    +break -qualified main
	    Reading Reading compcomp unit at offset  unit at offset 0x00x39

	    Reading comp unit at offset 0x1a8
	    Reading comp unit at offset 0x1e9
	    Reading comp unit at offset 0x2c5
	    Reading comp unit at offset 0x2a2
	    Reading comp unit at offset 0x904
	    Unrecognized format specifier 't' in printf

	This use is in dwarf2/read.c:

	      gdb_printf (gdb_stdlog, "Read die from %s@0x%tx of %s:\n",
			  m_die_section->get_name (),
			  (begin_info_ptr - m_die_section->buffer),
			  bfd_get_filename (m_abfd));

	Add support for the `t` length modifier in format_pieces, which
	gdb_printf ultimately uses (through ui_out::vmessage).  Modify the three
	users of format_pieces: gdb's printf command, gdb's ui_out::vmessage
	function and gdbserver's ax_printf function.

	The implementation is mostly copied from what we do for size_t.

	Since format_pieces is also used to implement the printf command, this
	patch brings user-visible changes.  Before:

	    (gdb) printf "%td\n", -123
	    ❌️ Unrecognized format specifier 't' in printf

	After:

	    (gdb) printf "%td\n", -123
	    -123

	[1] https://inbox.sourceware.org/gdb-patches/d4ccce34-aad5-4e3d-8fc9-efb2fc11275c@suse.de/

	Change-Id: Ie9fce78f5f48082d8f8a9ca2847b5ae26acaa60d
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-15  Andrew Burgess  <aburgess@redhat.com>

	gdb/Makefile: update HFILES_NO_SRCDIR
	The HFILES_NO_SRCDIR in our Makefile has gotten a little out of date.
	The files: expanded-symbol.h, finish-thread-state.h, and
	nat/amd64-linux.h are missing, and there are a few files that are in
	the list twice.

	This commit adds the missing files and removes the duplicates.

	There should be no changes to a built GDB after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-15  Andrew Burgess  <aburgess@redhat.com>

	gdb: fix handling of raw ANSI escape sequences printed from Python
	Bug PR gdb/33748 reports a regression with print styled output from
	Python when using ANSI escape sequences to apply the styling.  This
	regression was introduced by commit:

	  commit 3825c972a636852600b47c242826313f4b9963b8
	  Date:   Wed Jun 18 15:02:29 2025 +0100

	      gdb: allow gdb.Color to work correctly with pagination

	Prior to this commit GDB would always forward any ANSI escape
	sequences directly to the output stream, but this meant that GDB
	didn't know which style was currently in effect.

	The above commit changed GDB so that we would parse the ANSI escape
	sequence, and then apply it to the output stream, this allowed GDB to
	track which style was in use, which in turn meant that GDB could
	correctly suspend the style and reapply it when the pager was
	activated.

	The problem though is that ANSI escape sequences can be built up in
	parts.  For example, a user can emit the sequence to change the
	foreground blue, and then later emit the sequence to change the text
	to bold.  The result is output that is both blue and bold.

	In the above commit, when parsing an incoming ANSI sequence, GDB was
	always starting from the default styling state.  The result of parsing
	the ANSI sequence was then being applied.  In our above example, this
	meant that when parsing the sequence for bold text we would "forget"
	that the current style had a blue foreground color.

	This can be easily fixed by starting from the current style, rather
	than the default style.

	This fix was suggested by Patryk Sondej who originally reported the
	bug.

	Co-Authored-By: Patryk Sondej <patryk.sondej@gmail.com>
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33748

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-15  Tom Tromey  <tom@tromey.com>

	Remove extraneous 'return'
	This 'return' comes after a call to a 'noreturn' function, and can be
	removed.

	I am not sure exactly what is up with the comment, but perhaps there
	was a time when 'error' was not marked this way.

2026-01-15  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: merge create_dwo_unit_in_dwp_{v2,v5}
	create_dwo_unit_in_dwp_v2 and create_dwo_unit_in_dwp_v5 are very
	similar.  Merge them into a common create_dwo_unit_in_dwp function, with
	a few conditionals for what differs.  This makes it easier to spot the
	differences between the two paths, and it's less code to maintain.

	Change-Id: I71c44b827fff3d4c8214a075a397a852a38d1cf9
	Reviewed-By: Tom Tromey <tom@tromey.com>

2026-01-15  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: remove v2 and v5 section pool structures variants
	The two variants of section_pool are identical, except the size of the
	section_ids array.  We can have only one, we just need to ensure that it
	is large enough for v5.  And then I think that the "section_pool" struct
	is unnecessary, we can have the fields directly in dwp_hash_table.

	Change-Id: I70167a95ff61ff668c09c7e19568ced2798fa6f3
	Reviewed-By: Tom Tromey <tom@tromey.com>

2026-01-15  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: cleanup dwarf2_locate_v{2,5}_dwp_sections parameters
	Change the `void *` parameter to `dwp_file *`.  Remove the unused `abfd`
	parameter.  These were probably missed when converting the caller from
	bfd_map_over_sections to gdb_bfd_sections.

	Change-Id: I0420c83ba35ae304901b9e140584ebaba31f2330
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-15  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: remove support for DWP v1
	The GCC wiki [1] says that version 1 of the DWP format "was an
	experimental version that is no longer supported".  That comment was
	written in 2013.  From what I understand, DWP version 1 was not widely
	adopted.  Unlike version 2 and version 5 (which is part of DWARF 5).

	I propose to get rid of v1 support, which allows removing a bit of code,
	making things a bit easier when reasoning about DWARF code.

	[1] https://gcc.gnu.org/wiki/DebugFissionDWP

	Change-Id: Ie46b55662e63b7f341b7827330154ec4ab5af9e5
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-15  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: initialize fields of virtual_v2_or_v5_dwo_sections
	I noticed that create_dwo_unit_in_dwp_v2 and create_dwo_unit_in_dwp_v5
	initialized structure virtual_v2_or_v5_dwo_sections differently, one
	with a memset and one with default initialization.  Make that consistent
	by moving the initialization in the struct itself, which is less
	error-prone anyway.

	Change-Id: I48a21a871601d076bbeeb19befd0ad62e9ba7f2a
	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-15  Kito Cheng  <kito.cheng@sifive.com>

	RISC-V: Add second-pass relaxation for JAL to C.J/C.JAL
	When linker relaxation converts CALL (auipc+jalr, 8 bytes) to JAL
	(4 bytes), further relaxation to C.J or C.JAL (2 bytes) may become
	possible as code shrinks and jump distances decrease.

	This patch adds _bfd_riscv_relax_jal to perform this second-pass
	relaxation.  To enable this, we introduce R_RISCV_DELETE_AND_RELAX,
	a new internal relocation that combines piecewise deletion with
	preservation of relaxation capability.  When _bfd_riscv_relax_call
	relaxes CALL to JAL, it marks the deletion as R_RISCV_DELETE_AND_RELAX
	instead of R_RISCV_DELETE.  After the piecewise deletion is resolved,
	R_RISCV_DELETE_AND_RELAX is converted back to R_RISCV_RELAX at the
	JAL instruction offset, allowing _bfd_riscv_relax_jal to further
	relax JAL to C.J/C.JAL.

	C.JAL is only available on RV32 (rd=ra), while C.J is available on
	both RV32 and RV64 (rd=x0).

	Changes since v1:
	- Use R_RISCV_DELETE_AND_RELAX with piecewise deletion instead of
	  calling _riscv_relax_delete_immediate directly, to maintain
	  relaxation performance.
	- Add preserve_relax parameter to riscv_relax_delete_bytes to
	  simplify the logic in _bfd_riscv_relax_call.

2026-01-15  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/BFD: Initialize `error_message' in `_bfd_mips_elf_orphan_shr16_reloc'
	There is no value assigned in `_bfd_mips_elf_generic_reloc' via the
	`error_message' parameter and consequently the original `error_message'
	variable in `_bfd_mips_elf_orphan_shr16_reloc' remains uninitialized in
	the error case, which newer versions of GCC can correctly diagnose:

	In function '_bfd_mips_elf_orphan_shr16_reloc',
	    inlined from 'mips_elf_free_hi16_list' at ../../binutils-gdb/bfd/elfxx-mips.c:13309:12:
	../../binutils-gdb/bfd/elfxx-mips.c:13281:5: error: 'error_message' may be used uninitialized [-Werror=maybe-uninitialized]
	13281 |     _bfd_link_reloc_status_error (abfd, info, hi->input_section,
	      |     ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	13282 |                                   &hi->rel, error_message, r);
	      |                                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~
	../../binutils-gdb/bfd/elfxx-mips.c: In function 'mips_elf_free_hi16_list':
	../../binutils-gdb/bfd/elfxx-mips.c:13255:9: note: 'error_message' declared here
	13255 |   char *error_message;
	      |         ^~~~~~~~~~~~~
	cc1: all warnings being treated as errors

	Fix the problem by preinitializing the variable to NULL as at other
	places.

2026-01-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-14  Alan Modra  <amodra@gmail.com>

	Move mips_hi16_list to mips_elf_section_data
	This patch is in response to fuzzing testcases that manage to cause
	segfaults due to stale references to freed memory via mips_hi16.data.

	A number of the error/warning handlers in ldmain.c use %C.  This can
	cause debug info to be parsed for the first time in order to print
	file/function/line.  If one of those warnings is triggered after some
	hi16 relocs have been processed but before the matching lo16 reloc is
	handled, *and* the debug info is corrupted with a lo16 reloc, then the
	mips_hi16_list will be flushed with the result that printing a warning
	changes linker output.  It is also possible that corrupted debug info
	adds to the hi16 list, with the result that when the linker handles a
	later lo16 reloc in a text section, ld will segfault accessing
	mips_hi16.data after the debug buffers have be freed.  Both of these
	problems are fixed by keeping a per-section mips_hi16_list rather than
	a per-file list.

		* elfxx-mips.c (struct mips_hi16): Move earlier, deleting
		input_section field.
		(struct _mips_elf_section_data): Add mips_hi16_list.
		(struct mips_elf_obj_tdata): Delete mips_hi16_list.
		(_bfd_mips_elf_free_cached_info): Adjust to suit new location
		of mips_hi16_list.
		(_bfd_mips_elf_hi16_reloc, _bfd_mips_elf_lo16_reloc): Likewise.
		(_bfd_mips_elf_orphan_shr16_reloc): Likewise.
		(mips_elf_free_hi16_list): Likewise.
		(_bfd_mips_elf_finalize_section_relocs): Likewise.
		(_bfd_elf_mips_get_relocated_section_contents): Likewise.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS: Add tests for orphan REL HI16 relocation addend processing
	Add GAS and LD test cases for orphan REL HI16 relocation processing,
	including verification of the addends produced as well as the warning
	messages expected.

	Due to the ordering used for the list of oustanding cached HI16 reloc
	entries warnings for non-ELF links are issued in the reverse order
	compared to one for ELF links.  This is not considered a defect as all
	the required warnings are produced in both cases, however separate
	warning lists are required and included here for ELF and srec output.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/BFD: Fix howto orphan REL HI16 relocation addend processing
	Correct the addend being ignored for orphan REL HI16 relocations.

	For assembly and non-ELF links `_bfd_mips_elf_hi16_reloc' is called from
	`bfd_install_relocation' and `bfd_perform_relocation' respectively via
	the respective howtos.  It caches the relocation for later processing as
	`_bfd_mips_elf_lo16_reloc' is called via the corresponding LO16 reloc's
	howto, at which point both the HI16 and the LO16 parts are calculated
	and installed.

	If no matching LO16 relocation has been later encountered, then the
	cached entry is never processed, with the outstanding cached entries
	silently dropped at the conclusion of processing, resulting in zero
	addend being used for the field relocated.

	Dropping of the entries only happens in `_bfd_mips_elf_free_cached_info'
	at the time the BFD is being successfully closed and section contents
	long written to output.  For non-ELF links dropping will also execute in
	`_bfd_elf_mips_get_relocated_section_contents' via a separate piece of
	code if the function has encountered an error.

	Address the issues first by factoring out code to process outstanding
	cached entries to `mips_elf_free_hi16_list' and then by making the
	function actually install the relocations cached as required.  This has
	to happen before section contents have been written and therefore the
	success path wires the function call to `bfd_finalize_section_relocs',
	for assembly and `_bfd_elf_mips_get_relocated_section_contents' for
	non-ELF links.

	For housekeeping purposes the latter call will just drop cached entries
	as it happens now in the case of an error, and likewise the call from
	`_bfd_mips_elf_free_cached_info' is retained in case a fatal error in
	the assembler prevents `bfd_finalize_section_relocs' from being called.

	This also results in a warning being issued now about orphan REL HI16
	relocations encountered in non-ELF links.  Previously no such warning
	was produced since the cached entries were dropped.  For assembly we
	expect the tool to have issued its own warning, so we process orphan
	relocations silently if successful, but still issue a warning if an
	error is returned.

	We are careful in `mips_elf_free_hi16_list' to retain any incoming BFD
	error as the function may be called under an error condition and if
	there's another failure in processing at this stage we don't want to
	clobber the original error.

	Test cases will be added with a separate change.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/BFD: Fix ELF link orphan REL HI16 relocation addend processing
	Correct the addend being ignored for orphan REL HI16 relocations.

	For ELF links `_bfd_mips_elf_relocate_section' handles relocation and
	uses `mips_elf_add_lo16_rel_addend' to shift the incoming HI16 in-place
	addend into its intended [31:16] bit positions and combine it with the
	LO16 part.  If no matching LO16 reloc has been found, then the function
	returns early and consequently the incoming HI16 addend is not shifted
	and remains in bits [0:15].  For final links any value of the symbol
	referred is then added.  Then the final value is shifted back into bits
	[0:15] for installation into the field relocated.  It is obviously wrong
	as the original HI16 in-place addend has now been lost.

	Fix the issue by shifting the incoming HI16 in-place addend before using
	`mips_elf_next_relocation' to find the matching LO16 relocation.  Then
	upon early return from `mips_elf_add_lo16_rel_addend' the addend is in
	the intended [31:16] bit positions already.

	Test cases will be added with a separate change.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/BFD: Standardize orphan REL HI16 relocation warning
	Use the warning callback for the orphan REL HI16 relocation warning just
	as with any other linker relocation processing warnings, standardizing
	the message format and providing source location where available.

	Test cases will be added with a separate change.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/GAS: Warn about unmatched REL HI16 relocations
	Ever since commit 749b8d9d455c ("PATCH: ld/4208: `final link failed: Bad
	value' when building Linux MIPS kernels."), which went in back in 2007,
	<https://inbox.sourceware.org/binutils/20070320043504.GA7735@lucon.org/>,
	we've been warning about unmatched HI16 REL relocations in the linker,
	as it has been concluded in the discussion on PR ld/4208 that we have no
	need to be forgiving about compiler bugs that lead to object files to be
	made that are not compliant with the psABI.

	However no corresponding update has ever been made to GAS, despite that
	it's always helpful to issue a warning as early as possible in the build
	process.  In this particular case GAS also has more information to hand
	as it always has the full original addend available that has been used
	for both the high-part and the low-part relocation, while the linker has
	to rely on the in-place value stored in the relocatable field by earlier
	processing, which has necessarily been truncated.  Therefore the linker
	may miss cases where unrelated high-part and low-part relocations have
	been put next to each other that had significantly different addends at
	assembly time (small differences are deliberately permitted where they
	are known not to affect any borrow from the high part).

	Additionally GAS is able to point at the exact place in sources where
	any offending orphan relocations have been used.

	Update GAS to issue the warning then where applicable and remove an old
	comment referring to GCC producing orphan HI16 relocations.

	Test cases will be added with a separate change.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	BFD: Make `bfd_finalize_section_relocs' return status
	Update `bfd_finalize_section_relocs' to return status so that backends
	can fail in this interface and propagate that to the respective callers.
	Add suitable error reporting there.  No failure cases in the existing
	handlers though.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	BFD: Rename `*_set_reloc' to `*_finalize_section_relocs'
	The `*_set_reloc' interface is to be called at the conclusion of section
	relocation processing, however its name reflects a particular action to
	take rather than the context of invocation.  Implementation is already
	backend-specific.

	Rename the interface such as not to make its name artificially limit the
	intended purpose.  Update the callers and documentation accordingly.  No
	functional change.

2026-01-14  Maciej W. Rozycki  <macro@orcam.me.uk>

	GAS: Unify code for SET_SECTION_RELOCS call
	Fold a separate call to `bfd_set_reloc' into SET_SECTION_RELOCS itself,
	so that the GAS interface to this facility is contained in a single
	invocation.

	Currently both `write_relocs' and `obj_mach_o_reorder_section_relocs'
	call `bfd_set_reloc', causing the function to be called twice by Mach-O
	targets, such as `i386-darwin', once before target-specific processing
	and again afterwards, which is at the very least fragile in terms of
	assuming that any actions made by the function on the first invocation
	won't interfere with the final intended result.

	Set the macro by default to a plain call to `bfd_set_reloc', letting
	backends override the macro, with the requirement now to factor in a
	call to said function at the appropriate time.  Backends can choose
	whether to call `bfd_set_reloc' first (such as COFF), or last (such as
	Mach-O), or at any other point in relation to their own additional
	actions.

	Update the COFF variant accordingly, moving it to a new function for a
	better code structure, retaining functionality.

	This is in preparation for `bfd_set_reloc' to return an error status.

2026-01-14  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Speed up gdb.base/tls-dlobj.exp
	In test-case gdb.base/tls-dlobj.exp we use breakpoints to step through the
	executable.  The breakpoints are used only once, but they are permanent, so we
	end up with 11 breakpoints, 10 of which of the form $srcfile:$n.

	The executable loads and unloads shared libraries, triggering solib events in
	gdb, which will re-set the breakpoints.

	Setting a breakpoint of the form $srcfile:$n triggers a filename search that
	iterates over all CUs in all objfiles for which we have debuginfo.

	In case glibc debuginfo is installed, and in case we have a slow gdb, for
	instance because of building with -O0 and Address Sanitizer, this might become
	noticeable.

	While it's a good idea to try to speed up this search (see for instance
	PR33781), measuring this speed is not the point of this test-case, so fix this
	by making the breakpoints temporary.

	Tested on x86_64-linux.

	Approved-by: Kevin Buettner <kevinb@redhat.com>

2026-01-14  Jan Vrany  <jan.vrany@labware.com>

	gdb/jit: add function symbols to global block
	While playing with JIT reader I realized that it is not possible to set
	a breakpoint on jitted function:

	    (gdb) b jit_function_stack_mangle
	    Function "jit_function_stack_mangle" not defined.
	    Make breakpoint pending on future shared library load? (y or [n])

	The problem is that symbols for jitted functions (jit_function_stack_mangle
	in the above example) are not added to jitted compunit's global block:

	    (gdb) maint print symtabs
	    ...
	    Symtab for file  at 0x55d6f8c186c0
	    Read from object file << JIT compiled code at 0x5555555592a0 >> (0x55d6f8cd4090)
	    Language: unknown

	    Line table:

	     line 1 at 0x7ffff7fbc000	(stmt)
	     line 0 at 0x7ffff7fbc001	(stmt)

	    Blockvector:

	    block #000, object at 0x55d6f8c188b0, 0 symbols in 0x7ffff7fbc000..0x7ffff7fbc011
	      block #001, object at 0x55d6f8c18910 under 0x55d6f8c188b0, 0 symbols in 0x7ffff7fbc000..0x7ffff7fbc011
	        block #002, object at 0x55d6f8c18730 under 0x55d6f8c18910, 0 symbols in 0x7ffff7fbc000..0x7ffff7fbc00a, function jit_function_stack_mangle
	        block #003, object at 0x55d6f8c187f0 under 0x55d6f8c18910, 0 symbols in 0x7ffff7fbc00a..0x7ffff7fbc011, function jit_function_add

	This commit changes JIT reader to add jitted functions to the global
	block:

	    ...
	    Blockvector:

	    block #000, object at 0x55ed6665b180, 2 symbols in 0x7ffff7fbc000..0x7ffff7fbc011
	     void jit_function_stack_mangle(); block object 0x55ed6665b000, 0x7ffff7fbc000..0x7ffff7fbc00a
	     void jit_function_add(); block object 0x55ed6665b0c0, 0x7ffff7fbc00a..0x7ffff7fbc011
	      block #001, object at 0x55ed6665b230 under 0x55ed6665b180, 0 symbols in 0x7ffff7fbc000..0x7ffff7fbc011
	        block #002, object at 0x55ed6665b000 under 0x55ed6665b230, 0 symbols in 0x7ffff7fbc000..0x7ffff7fbc00a, function jit_function_stack_mangle
	        block #003, object at 0x55ed6665b0c0 under 0x55ed6665b230, 0 symbols in 0x7ffff7fbc00a..0x7ffff7fbc011, function jit_function_add

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-14  Jens Remus  <jremus@linux.ibm.com>

	gas: sframe: simplify get_offset_size_in_bytes
	Type offsetT is either defined as signed 32-bit or 64-bit integer
	depending on whether BFD64 is defined.  Do not test for whether an
	offsetT value exceeds INT32_MIN..INT32_MAX for !BFD64 32-bit offsetT
	(or INT64_MIN..INT64_MAX for BFD64 64-bit offsetT).  This is always
	true and may result in a compile error when using compiler option
	-Werror=type-limits, such as the one resolved with commit
	6b8fb74a9403 ("gas: sframe: do not test whether offsetT exceeds
	INT64_MIN..INT64_MAX") for BFD64 64-bit offsetT:

	../../binutils-gdb/gas/gen-sframe.c: In function ‘get_offset_size_in_bytes’:
	../../binutils-gdb/gas/gen-sframe.c:213:45: error: comparison is always true due to limited range of data type [-Werror=type-limits]
	  213 |   else if ((sizeof (offsetT) > 4) && (value <= INT64_MAX && value >= INT64_MIN))
	      |                                             ^~
	../../binutils-gdb/gas/gen-sframe.c:213:67: error: comparison is always true due to limited range of data type [-Werror=type-limits]
	  213 |   else if ((sizeof (offsetT) > 4) && (value <= INT64_MAX && value >= INT64_MIN))
	      |                                                                   ^~

	Instead of testing for whether the value is in range of
	INT8_MIN..INT8_MAX, INT16_MIN..INT16_MAX, or INT32_MIN..INT32_MAX,
	test whether the value is unchanged when casted to int8_t, int16_t,
	or int32_t.  This also improves readability.

	gas/
		* gen-sframe.c (get_offset_size_in_bytes): Simplify.  Do not
		test whether !BFD64 32-bit offsetT exceeds INT32_MIN..INT32_MAX.

	Fixes: 58008ed4e6af ("gas: sframe: use standard min/max integer constants")
	Suggested-by: Jan Beulich <jbeulich@suse.com>

2026-01-14  Matthieu Longo  <matthieu.longo@arm.com>

	py-gdb-readline: replace deprecated interfaces in GdbRemoveReadlineFinder
	A previous patch [1] enabled readline in Python in a GDB-specific way
	and blocked the standard Python readline module to prevent conflicts
	with GDB by adding a custom importer raising an exception for the readline
	module.

	This custom importer was written back in 2012 for old Python versions,
	and does not seem to work anymore with Python 3.x. find_module() and
	load_module() have been deprecated since Python 3.4, and the first one
	has been removed since 3.12, and the second will be removed in 3.15.
	The GDB testsuite does not cover this use case, and the removal of
	find_module() was not detected by the testsuite. This issue is tracked
	in bug 32473.

	importlib.abc.MetaPathFinder:
	  find_module(fullname, path)
	    Deprecated since version 3.4: Use find_spec() instead.
	    Changed in version 3.10: Use of find_module() by the import
	    system now raises ImportWarning.
	    Changed in version 3.12: find_module() has been removed. Use
	    find_spec() instead.

	  find_spec(fullname, path, target=None)
	    New in version 3.4, as a replacement for find_module.

	importlib.abc.Loader:
	  load_module(fullname):
	    Deprecated since version 3.4, will be removed in version 3.15
	    The recommended API for loading a module is exec_module()
	    (and create_module()).

	This patch uses Patryk Sondej's approach detailed in bug 32473, but with
	a slight variation regarding the finder insertion in sys.meta_path.
	It also adds a new test to prevent future regression.

	[1]: 037bbc8eeaf8e6f3a5e185e78268aa71a1159ae7

	Approved-By: Tom Tromey <tom@tromey.com>
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=32473

2026-01-14  Nelson Chu  <nelson.chu1990@gmail.com>

	MAINTAINERS: Update my email address

2026-01-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-13  H.J. Lu  <hjl.tools@gmail.com>

	elf: Handle the section flag 'o' linked to special sections
	Call _bfd_elf_section_from_bfd_section to get the sh_link value from
	the section flag 'o' directive, which may point to special sections,
	like SHN_ABS or SHN_COMM.  Update readelf to print the special section
	names in the sh_link field and replace "internal->sh_link > num" with
	"internal->sh_link >= num".

	bfd/

		PR gas/33744
		* elf.c (assign_section_numbers): Call
		_bfd_elf_section_from_bfd_section to get the sh_link value.

	binutils/

		PR gas/33744
		* readelf.c (special_defined_section_index): New.
		(get_32bit_section_headers): Don't warn special section indexes
		in the sh_link field.
		(get_64bit_section_headers): Likewise.
		(process_section_headers): Print special defined section names.

	gas/

		PR gas/33744
		* testsuite/gas/elf/elf.exp: Run PR gas/33744 tests.
		* testsuite/gas/elf/sh-link-abs-1.d: New file.
		* testsuite/gas/elf/sh-link-abs-2.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-3-32.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-3-64.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-4-32.d: Likewise.
		* testsuite/gas/elf/sh-link-abs-4-64.d: Likewise.
		* testsuite/gas/elf/sh-link-abs.s: Likewise.
		* testsuite/gas/elf/sh-link-common-1.d: Likewise.
		* testsuite/gas/elf/sh-link-common-2.d: Likewise.
		* testsuite/gas/elf/sh-link-common-3-32.d: Likewise.
		* testsuite/gas/elf/sh-link-common-3-64.d: Likewise.
		* testsuite/gas/elf/sh-link-common-4-32.d: Likewise.
		* testsuite/gas/elf/sh-link-common-4-64.d: Likewise.
		* testsuite/gas/elf/sh-link-common.s: Likewise.
		* testsuite/gas/elf/sh-link-large-common-1.d: Likewise.
		* testsuite/gas/elf/sh-link-large-common-2.d: Likewise.
		* testsuite/gas/elf/sh-link-large-common-3.d: Likewise.
		* testsuite/gas/elf/sh-link-large-common-4.d: Likewise.
		* testsuite/gas/elf/sh-link-large-common.s: Likewise.

2026-01-13  Jens Remus  <jremus@linux.ibm.com>

	gas: sframe: do not test whether offsetT exceeds INT64_MIN..INT64_MAX
	A value of type offsetT, which is either a signed 32-bit or 64-bit
	integer, cannot exceed the range of INT64_MIN..INT64_MAX.  This
	resolves the following compile error:

	../../binutils-gdb/gas/gen-sframe.c: In function ‘get_offset_size_in_bytes’:
	../../binutils-gdb/gas/gen-sframe.c:213:45: error: comparison is always true due to limited range of data type [-Werror=type-limits]
	  213 |   else if ((sizeof (offsetT) > 4) && (value <= INT64_MAX && value >= INT64_MIN))
	      |                                             ^~
	../../binutils-gdb/gas/gen-sframe.c:213:67: error: comparison is always true due to limited range of data type [-Werror=type-limits]
	  213 |   else if ((sizeof (offsetT) > 4) && (value <= INT64_MAX && value >= INT64_MIN))
	      |                                                                   ^~

	Fixes: 58008ed4e6af ("gas: sframe: use standard min/max integer constants")

2026-01-13  Jens Remus  <jremus@linux.ibm.com>

	gas: sframe: use standard min/max integer constants
	Replace the use of custom VALUE_{8|16|32|64}BIT constant definitions
	with the standard INT{8|16|32|64}_{MIN|MAX} ones from stdint.h.

	Besides improving readability this also fixes the issue that the
	smallest representable signed 8/16/32-bit integer value was
	erroneously sized as the next larger integer type.  For example
	get_offset_size_in_bytes (INT8_MIN) returned 2 instead of 1, due
	to INT8_MIN (= -128) != -VALUE_8BIT (= -127):

	  (gdb) call get_offset_size_in_bytes (-127)
	  $1 = 1
	  (gdb) call get_offset_size_in_bytes (-128)
	  $2 = 2

	gas/
		* gen-sframe.c (VALUE_8BIT, VALUE_16BIT, VALUE_32BIT,
		VALUE_64BIT): Remove.
		(get_offset_size_in_bytes): Use standard min/max integer
		constants.

2026-01-13  Andrew Burgess  <aburgess@redhat.com>

	gdb: yet more miscellaneous styling fixes
	The previous patch was all about address styling, but I spotted some
	non-address styling that was missing.  This patch covers those cases.

	There's function name styling for the 'jump' command, and line number,
	and function name styling for 'maint print symbols'.

	Other than the extra styling, there should be no user visible changes
	after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-13  Andrew Burgess  <aburgess@redhat.com>

	gdb: more address styling throughout
	I looked for the pattern 'gdb_puts (paddress (', these are places in
	GDB where we are printing a target address without styling.  I changed
	most of what I found to print the address as styled.

	I did leave a few unchanged in psymtab.c, these are all in maintenance
	commands 'maint print psymbols', 'maint info psymtabs', and 'maint
	check psymtabs'.  None of these commands appear to print anything for
	me (do we even use partial symtabs these days?  I thought not) so I
	didn't want to mess with commands that I couldn't test.

	Other than the additional styling, there should be no user visible
	changes after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-13  Andrew Burgess  <aburgess@redhat.com>

	gdb: output styling, and GDB code style fixes, for 'info frame'
	I noticed that the output of 'info frame' was not styled much; the
	frame's filename is styled, as are the names of any frame local
	variables.  But there's lots of address and line number styling
	missing.

	When I started looking at the info_frame_command_core function though,
	there were lots of coding standard changes that could be made too, so
	while I was in the area I thought I'd make some coding standard
	changes to the function:

	  + Inlined local variable declarations.

	  + Removed the 'caller_pc_p' local, and made 'caller_pc' a
	    std::optional<CORE_ADDR> instead.

	  + Converted a local from 'int' to 'bool'.

	  + Replaced NULL with nullptr.

	  + Replaced calls to gdb_printf with gdb_puts when the thing to print
	    is a constant string.

	  + Added { ... } around if/else bodies that are a single statement
	    AND a comment inline with GDB coding style.

	  + Avoid treating pointers and integers as booleans in 'if'
	    conditions.  Compare to nullptr and/or zero instead.

	Other than the new styling, there should be no user visible changes
	after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-13  Andreas Schwab  <schwab@linux-m68k.org>

	gas/riscv: Fix grammar in error messages

	objcopy: Set bfd_error_system_call before reporting error from make_tempname

	readelf: Handle R_RISCV_SET32

2026-01-13  Nick Clifton  <nickc@redhat.com>

	Regenerate libiberty/aclocal.m4 and ld/config.in using the correct versions of the autotools

2026-01-13  Christina Schimpe  <christina.schimpe@intel.com>

	gdb: Update comment of c_type_print_template_args.
	Remove function description for TABLE.  This function does not take a
	parameter "table".

	Approved-By: Tom Tromey <tom@tromey.com>

2026-01-13  Abhay Kandpal  <abhay@linux.ibm.com>

	PowerPC: Support for eTCE (RFC02662)
	opcodes/
	        * ppc-opc.c (XTLBIE_MASK, XTLBIEIO_MASK): New macros.
	        (powerpc_opcodes): Add tlbiep, tlbieio, tlbsyncio,
	        ptesyncio.

	gas/
	        * testsuite/gas/ppc/future.s: New test.
	        * testsuite/gas/ppc/future.d: Likewise.

2026-01-13  Abhay Kandpal  <abhay@linux.ibm.com>

	PowerPC: Support for Additional Performance Monitor Counters (RFC02666)
	opcodes/
	        * ppc-opc.c (powerpc_opcodes): Add mtummcrae, mtummcr2e,
	        mtmmcr2e, mtmmcrae, mtmmcr1e, mtmmcr3e, mtupmc7, mtupmc8,
	        mtpmc7, mtpmc8, mfummcrae, mfmmcrae, mfummcr1e, mfmmcr1e,
	        mfummcr2e, mfmmcr2e, mfummcr3e, mfmmcr3e, mfupmc7, mfpmc7,
	        mfupmc8, mfpmc8.

	gas/
	        * testsuite/gas/ppc/future.s: New test.
	        * testsuite/gas/ppc/future.d: Likewise.

2026-01-13  Maciej W. Rozycki  <macro@redhat.com>

	libiberty: sync with gcc
	Import the following commits from GCC as of r16-6728-g7c3584be8c8806:
		07df546fb90 libiberty/testsuite: make test-pexecute's -t option a little more useful
		0c775dcf3e7 libiberty: Make `objalloc_free' `free'-like WRT null pointer

2026-01-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2026-01-12  H.J. Lu  <hjl.tools@gmail.com>

	gas: Check @@@ before renaming the versioned symbol
	The versioned symbol with the @@@ syntax is a special case. If the symbol
	is not defined, 2 `@'s will be removed from the versioned_name. Otherwise,
	1 `@' will be removed.  But for malformed versioned symbols may not have
	@@@:

		.symver foo,foo@@@version1
		.symver foo,foo@version2

	Check @@@ before renaming the versioned symbol.

		PR gas/33745
		* config/obj-elf.c (elf_frob_file_before_adjust): Check @@@ before
		renaming the versioned symbol.
		* testsuite/gas/symver/symver.exp: Run symver17.
		* testsuite/gas/symver/symver17.l: New file.
		* testsuite/gas/symver/symver17.s: Likewise.

2026-01-12  Jan Vrany  <jan.vrany@labware.com>

	gdb/testsuite: fix DUPLICATE in call-sc.exp
	With test-case gdb.base/call-sc.exp I get:

	    DUPLICATE: gdb.base/call-sc.exp: tc: ptype; call-sc-tc (char)
	    DUPLICATE: gdb.base/call-sc.exp: ts: ptype; call-sc-ts (short)
	    DUPLICATE: gdb.base/call-sc.exp: ti: ptype; call-sc-ti (int)
	    ...

	Fix this by changing test name in testcase added in commit be90f3e2.

	Tested on x86_64-linux.

	Approved-By: Tom de Vries <tdevries@suse.de>

2026-01-12  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf: make dwarf2_per_cu size fields atomic
	Make m_addr_size, m_offset_size, and m_ref_addr_size use std::atomic.
	Multiple indexer threads may set these values concurrently, which
	currently causes a TSan failure:

	     WARNING: ThreadSanitizer: data race (pid=1535364)
	       Write of size 1 at 0xfffed1813515 by thread T1:
	         #0 dwarf2_per_cu::set_addr_size(unsigned char) /home/vries/gdb/src/gdb/dwarf2/read.h:291 (gdb+0x98af68) (BuildId: cce1d3c72972f5759cd1746e1a001e90d7498301)
	         #1 cutu_reader::cutu_reader(dwarf2_per_cu&, dwarf2_per_objfile&, abbrev_table const*, dwarf2_cu*, bool, language, abbrev_table_cache const*) /home/vries/gdb/src/gdb/dwarf2/read.c:3114 (gdb+0x9472b4) (BuildId: cce1d3c72972f5759cd1746e1a001e90d7498301)
	         #2 std::__detail::_MakeUniq<cutu_reader>::__single_object std::make_unique<cutu_reader, dwarf2_per_cu&, dwarf2_per_objfile&, decltype(nullptr), decltype(nullptr), bool, language, abbrev_table_cache const*>(dwarf2_per_cu&, dwarf2_per_objfile&, decltype(nullptr)&&, decltype(nullptr)&&, bool&&, language&&, abbrev_table_cache const*&&) /usr/include/c++/15/bits/unique_ptr.h:1084 (gdb+0x891f98) (BuildId: cce1d3c72972f5759cd1746e1a001e90d7498301)
	         #3 cooked_indexer::ensure_cu_exists(cutu_reader*, section_and_offset const&, bool) /home/vries/gdb/src/gdb/dwarf2/cooked-indexer.c:118 (gdb+0x88e1e8) (BuildId: cce1d3c72972f5759cd1746e1a001e90d7498301)
